import { _ as _export_sfc, c as createElementBlock, o as openBlock, a8 as createStaticVNode } from "./chunks/framework.B9AX-CPi.js";
const __pageData = JSON.parse('{"title":"Breaking Changes: My Pull Request Was Flagged","description":"","frontmatter":{},"headers":[],"relativePath":"breaking_changes_instructions.md","filePath":"breaking_changes_instructions.md","lastUpdated":null}');
const _sfc_main = { name: "breaking_changes_instructions.md" };
const _hoisted_1 = /* @__PURE__ */ createStaticVNode('<h1 id="breaking-changes-my-pull-request-was-flagged" tabindex="-1">Breaking Changes: My Pull Request Was Flagged <a class="header-anchor" href="#breaking-changes-my-pull-request-was-flagged" aria-label="Permalink to &quot;Breaking Changes: My Pull Request Was Flagged&quot;">​</a></h1><p>A QMK member may have replied to your pull request stating that your submission is a breaking change. In their judgment, the changes you have proposed have greater implications for either QMK, or its users.</p><p>Some things that may cause a pull request to be flagged are:</p><ul><li><strong>Edits to User Keymaps</strong> A user may submit their keymap to QMK, then some time later open a pull request with further updates, only to find it can&#39;t be merged because it was edited in the <code>qmk/qmk_firmware</code> repository. As not all users are proficient at using Git or GitHub, the user may find themself unable to fix the issue on their own.</li><li><strong>Changes to Expected Behavior</strong> Changes to QMK behavior may cause users to believe their hardware or QMK is broken if they flash new firmware that incorporates changes to existing QMK features, and find themselves without a means to restore the desired behavior.</li><li><strong>Changes Requiring User Action</strong> Changes may also require action to be taken by users, such as updating a toolchain or taking some action in Git.</li><li><strong>Changes Necessitating Increased Scrutiny</strong> On occasion, a submission may have implications for QMK as a project. This could be copyright/licensing issues, coding conventions, large feature overhauls, &quot;high-risk&quot; changes that need wider testing by our community, or something else entirely.</li><li><strong>Changes Requiring Communication to End Users</strong> This includes warnings about future deprecations, outdated practices, and anything else that needs to be communicated but doesn&#39;t fit into one of the above categories.</li></ul><h2 id="what-do-i-do" tabindex="-1">What Do I Do? <a class="header-anchor" href="#what-do-i-do" aria-label="Permalink to &quot;What Do I Do?&quot;">​</a></h2><p>If it is determined that your submission is a breaking change, there are a few things you can do to smooth the process:</p><h3 id="consider-splitting-up-your-pr" tabindex="-1">Consider Splitting Up Your PR <a class="header-anchor" href="#consider-splitting-up-your-pr" aria-label="Permalink to &quot;Consider Splitting Up Your PR&quot;">​</a></h3><p>If you are contributing core code, and the only reason it needs to go through breaking changes is that you are updating keymaps to match your change, consider whether you can submit your feature in a way that the old keymaps continue to work. Then submit a separate PR that goes through the breaking changes process to remove the old code.</p><h3 id="document-your-changes" tabindex="-1">Document Your Changes <a class="header-anchor" href="#document-your-changes" aria-label="Permalink to &quot;Document Your Changes&quot;">​</a></h3><p>Understanding the purpose for your submission, and possible implications or actions it will require can make the review process more straightforward. A changelog may suffice for this purpose, but more extensive changes may require a level of detail that is ill-suited for a changelog.</p><p>Commenting on your pull request and being responsive to questions, comments, and change requests is much appreciated.</p><h3 id="ask-for-help" tabindex="-1">Ask for Help <a class="header-anchor" href="#ask-for-help" aria-label="Permalink to &quot;Ask for Help&quot;">​</a></h3><p>Having your submission flagged may have caught you off guard. If you find yourself intimidated or overwhelmed, let us know. Comment on your pull request, or <a href="https://discord.gg/qmk" target="_blank" rel="noreferrer">reach out to the QMK team on Discord</a>.</p>', 13);
const _hoisted_14 = [
  _hoisted_1
];
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", null, _hoisted_14);
}
const breaking_changes_instructions = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  __pageData,
  breaking_changes_instructions as default
};
