import { _ as _export_sfc, c as createElementBlock, o as openBlock, a8 as createStaticVNode } from "./chunks/framework.B9AX-CPi.js";
const __pageData = JSON.parse('{"title":"QMK Breaking Changes - 2021 February 27 Changelog","description":"","frontmatter":{},"headers":[],"relativePath":"ChangeLog/20210227.md","filePath":"ChangeLog/20210227.md","lastUpdated":null}');
const _sfc_main = { name: "ChangeLog/20210227.md" };
const _hoisted_1 = /* @__PURE__ */ createStaticVNode('<h1 id="qmk-breaking-changes-2021-february-27-changelog" tabindex="-1">QMK Breaking Changes - 2021 February 27 Changelog <a class="header-anchor" href="#qmk-breaking-changes-2021-february-27-changelog" aria-label="Permalink to &quot;QMK Breaking Changes - 2021 February 27 Changelog&quot;">​</a></h1><h2 id="changes-requiring-user-action" tabindex="-1">Changes Requiring User Action <a class="header-anchor" href="#changes-requiring-user-action" aria-label="Permalink to &quot;Changes Requiring User Action&quot;">​</a></h2><p>The following keyboards have had their source moved within QMK:</p><table><thead><tr><th style="text-align:left;">Old Keyboard Name</th><th style="text-align:left;">New Keyboard Name</th></tr></thead><tbody><tr><td style="text-align:left;">bear_65</td><td style="text-align:left;">jacky_studio/bear_65</td></tr><tr><td style="text-align:left;">s7_elephant/rev1</td><td style="text-align:left;">jacky_studio/s7_elephant/rev1</td></tr><tr><td style="text-align:left;">s7_elephant/rev2</td><td style="text-align:left;">jacky_studio/s7_elephant/rev2</td></tr><tr><td style="text-align:left;">aplx6</td><td style="text-align:left;">aplyard/aplx6/rev1</td></tr><tr><td style="text-align:left;">southpaw75</td><td style="text-align:left;">fr4/southpaw75</td></tr></tbody></table><p>The <a href="https://github.com/qmk/qmk_firmware/tree/0.12.0/keyboards/aplyard/aplx6/rev1" target="_blank" rel="noreferrer">Aplyard Aplx6 rev2</a> and the <a href="https://github.com/qmk/qmk_firmware/tree/0.12.0/keyboards/fr4/unix60" target="_blank" rel="noreferrer">FR4Boards Unix60</a> have also been added as part of these changes.</p><p>Additionally, the <code>handwired/bluepill/bluepill70</code> keyboard has been removed.</p><h2 id="core-changes" tabindex="-1">Core Changes <a class="header-anchor" href="#core-changes" aria-label="Permalink to &quot;Core Changes&quot;">​</a></h2><h3 id="chibios-update-and-config-migration" tabindex="-1">ChibiOS Update and Config Migration <a class="header-anchor" href="#chibios-update-and-config-migration" aria-label="Permalink to &quot;ChibiOS Update and Config Migration&quot;">​</a></h3><p>QMK&#39;s ChibiOS and ChibiOS-Contrib submodules have been updated to version 20.3.2.</p><p>Along with this, QMK now provides default configuration files for all commonly-supported ARM microcontrollers running on ChibiOS. As such, keyboards are now only required to define settings which differ from the defaults, thereby reducing the size of pull requests for keyboards running atop ChibiOS.</p><h3 id="qmk-infrastructure-and-internals" tabindex="-1">QMK Infrastructure and Internals <a class="header-anchor" href="#qmk-infrastructure-and-internals" aria-label="Permalink to &quot;QMK Infrastructure and Internals&quot;">​</a></h3><p>Python is now required to build QMK. The minimum Python version has been increased to 3.7.</p><p>The power of <code>info.json</code> has been massively expanded. Most keyboard parameters can now be expressed in <code>info.json</code> instead of <code>config.h</code>/<code>rules.mk</code>. This should make maintaining keyboards easier, and will enable tooling that can allow non-technical users to add and maintain QMK keyboards without writing any code.</p><p>To ease migration a new command has been provided, <code>qmk generate-info-json -kb &lt;keyboard&gt;</code>. You can use this command to generate a complete <code>info.json</code> file for a keyboard and then remove the duplicate information from <code>config.h</code> and <code>rules.mk</code>.</p><p>Detailed example showing how to generate a new info.json and identify duplicate keys:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span>user@hostname:~/qmk_firmware/keyboards/lets_split:0$ qmk generate-info-json &gt; new-info.json</span></span>\n<span class="line"><span>user@hostname:~/qmk_firmware/keyboards/lets_split:0$ mv new-info.json info.json</span></span>\n<span class="line"><span>user@hostname:~/qmk_firmware/keyboards/lets_split:0$ qmk info</span></span>\n<span class="line"><span>⚠ lets_split/rev2: DEBOUNCE in config.h is overwriting debounce in info.json</span></span>\n<span class="line"><span>⚠ lets_split/rev2: DEVICE_VER in config.h is overwriting usb.device_ver in info.json</span></span>\n<span class="line"><span>⚠ lets_split/rev2: DIODE_DIRECTION in config.h is overwriting diode_direction in info.json</span></span>\n<span class="line"><span>⚠ lets_split/rev2: MANUFACTURER in config.h is overwriting manufacturer in info.json</span></span>\n<span class="line"><span>⚠ lets_split/rev2: RGB_DI_PIN in config.h is overwriting rgblight.pin in info.json</span></span>\n<span class="line"><span>⚠ lets_split/rev2: RGBLED_NUM in config.h is overwriting rgblight.led_count in info.json</span></span>\n<span class="line"><span>⚠ lets_split/rev2: PRODUCT_ID in config.h is overwriting usb.pid in info.json</span></span>\n<span class="line"><span>⚠ lets_split/rev2: VENDOR_ID in config.h is overwriting usb.vid in info.json</span></span>\n<span class="line"><span>⚠ lets_split/rev2: Matrix pins are specified in both info.json and config.h, the config.h values win.</span></span>\n<span class="line"><span>⚠ lets_split/rev2: LAYOUTS in rules.mk is overwriting community_layouts in info.json</span></span>\n<span class="line"><span>⚠ lets_split/rev2: Feature bootmagic is specified in both info.json and rules.mk, the rules.mk value wins.</span></span>\n<span class="line"><span>⚠ lets_split/rev2: Feature mousekey is specified in both info.json and rules.mk, the rules.mk value wins.</span></span>\n<span class="line"><span>⚠ lets_split/rev2: Feature extrakey is specified in both info.json and rules.mk, the rules.mk value wins.</span></span>\n<span class="line"><span>⚠ lets_split/rev2: Feature console is specified in both info.json and rules.mk, the rules.mk value wins.</span></span>\n<span class="line"><span>⚠ lets_split/rev2: Feature command is specified in both info.json and rules.mk, the rules.mk value wins.</span></span>\n<span class="line"><span>⚠ lets_split/rev2: Feature nkro is specified in both info.json and rules.mk, the rules.mk value wins.</span></span>\n<span class="line"><span>⚠ lets_split/rev2: Feature backlight is specified in both info.json and rules.mk, the rules.mk value wins.</span></span>\n<span class="line"><span>⚠ lets_split/rev2: Feature midi is specified in both info.json and rules.mk, the rules.mk value wins.</span></span>\n<span class="line"><span>⚠ lets_split/rev2: Feature audio is specified in both info.json and rules.mk, the rules.mk value wins.</span></span>\n<span class="line"><span>⚠ lets_split/rev2: Feature unicode is specified in both info.json and rules.mk, the rules.mk value wins.</span></span>\n<span class="line"><span>⚠ lets_split/rev2: Feature bluetooth is specified in both info.json and rules.mk, the rules.mk value wins.</span></span>\n<span class="line"><span>⚠ lets_split/rev2: Feature rgblight is specified in both info.json and rules.mk, the rules.mk value wins.</span></span>\n<span class="line"><span>⚠ lets_split/rev2: Feature sleep_led is specified in both info.json and rules.mk, the rules.mk value wins.</span></span>\n<span class="line"><span>Keyboard Name: Let&#39;s Split</span></span>\n<span class="line"><span>Manufacturer: Wootpatoot</span></span>\n<span class="line"><span>Website:</span></span>\n<span class="line"><span>Maintainer: QMK Community</span></span>\n<span class="line"><span>Keyboard Folder: lets_split/rev2</span></span>\n<span class="line"><span>Layouts: LAYOUT, LAYOUT_ortho_4x12</span></span>\n<span class="line"><span>Size: 13 x 4</span></span>\n<span class="line"><span>Processor: atmega32u4</span></span>\n<span class="line"><span>Bootloader: caterina</span></span></code></pre></div><h2 id="detailed-change-list" tabindex="-1">Detailed Change List <a class="header-anchor" href="#detailed-change-list" aria-label="Permalink to &quot;Detailed Change List&quot;">​</a></h2><h3 id="changes-requiring-user-action-1" tabindex="-1">Changes Requiring User Action <a class="header-anchor" href="#changes-requiring-user-action-1" aria-label="Permalink to &quot;Changes Requiring User Action&quot;">​</a></h3><ul><li>Refactor Jacky&#39;s boards (Bear65 and S7 Elephant) (<a href="https://github.com/qmk/qmk_firmware/pull/10528" target="_blank" rel="noreferrer">#10528</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11981" target="_blank" rel="noreferrer">#11981</a>)</li><li>Remove handwired/bluepill (<a href="https://github.com/qmk/qmk_firmware/pull/11415" target="_blank" rel="noreferrer">#11415</a>)</li><li>Aplyard Aplx6 Added rev2 &amp; move rev1+rev2 to parent folder (<a href="https://github.com/qmk/qmk_firmware/pull/10973" target="_blank" rel="noreferrer">#10973</a>)</li><li>added <code>unix60</code>, moved together with <code>southpaw75</code> into <code>fr4</code> folder (<a href="https://github.com/qmk/qmk_firmware/pull/11195" target="_blank" rel="noreferrer">#11195</a>)</li></ul><h3 id="fixes" tabindex="-1">Fixes <a class="header-anchor" href="#fixes" aria-label="Permalink to &quot;Fixes&quot;">​</a></h3><ul><li>GCC 10 can now compile Drop Alt firmware (<a href="https://github.com/qmk/qmk_firmware/pull/9485" target="_blank" rel="noreferrer">#9485</a>)</li><li>Fix compiling on <code>develop</code> branch (<a href="https://github.com/qmk/qmk_firmware/pull/11409" target="_blank" rel="noreferrer">#11409</a>)</li><li>Fix broken keyboards and keymaps (<a href="https://github.com/qmk/qmk_firmware/pull/11412" target="_blank" rel="noreferrer">#11412</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11427" target="_blank" rel="noreferrer">#11427</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11448" target="_blank" rel="noreferrer">#11448</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11447" target="_blank" rel="noreferrer">#11447</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11473" target="_blank" rel="noreferrer">#11473</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11584" target="_blank" rel="noreferrer">#11584</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11600" target="_blank" rel="noreferrer">#11600</a>)</li><li>Fixed up build dependencies so that generated files are made available before compiling any object files (<a href="https://github.com/qmk/qmk_firmware/pull/11435" target="_blank" rel="noreferrer">#11435</a>)</li><li>Formatting fixes (<a href="https://github.com/qmk/qmk_firmware/commit/378edd9491f2ab0d3d8a970c9a8e64bc03ca15cf" target="_blank" rel="noreferrer"><code>378edd9</code></a>, <a href="https://github.com/qmk/qmk_firmware/pull/11594" target="_blank" rel="noreferrer">#11594</a>, <a href="https://github.com/qmk/qmk_firmware/commit/27749e1c967c02c05e62a89a0ae2776dd7e5158c" target="_blank" rel="noreferrer"><code>27749e1</code></a>)</li><li>Include <code>stdbool.h</code> in <code>uart.h</code> to fix compiler errors (<a href="https://github.com/qmk/qmk_firmware/pull/11728" target="_blank" rel="noreferrer">#11728</a>)</li><li>Decouple USB events from the USB interrupt handler in ChibiOS (<a href="https://github.com/qmk/qmk_firmware/pull/10437" target="_blank" rel="noreferrer">#10437</a>) <ul><li>Fixes an issue while using Backlight and External EEPROM at the same time that would cause the MCU to lock up.</li></ul></li><li>Address wake from sleep instability (<a href="https://github.com/qmk/qmk_firmware/pull/11450" target="_blank" rel="noreferrer">#11450</a>)</li><li>Fix pressing media key on a momentarily activated layer may lead to missing key up events (<a href="https://github.com/qmk/qmk_firmware/pull/11162" target="_blank" rel="noreferrer">#11162</a>)</li><li>Fix an RGB initialisation bug on Massdrop keyboards (<a href="https://github.com/qmk/qmk_firmware/pull/12022" target="_blank" rel="noreferrer">#12022</a>)</li><li>Fix file encoding errors on Windows, and layouts not correctly merging into info.json (<a href="https://github.com/qmk/qmk_firmware/pull/12039" target="_blank" rel="noreferrer">#12039</a>)</li></ul><h3 id="additions-and-enhancements" tabindex="-1">Additions and Enhancements <a class="header-anchor" href="#additions-and-enhancements" aria-label="Permalink to &quot;Additions and Enhancements&quot;">​</a></h3><ul><li>Allow configuration of serial USART timeout (<a href="https://github.com/qmk/qmk_firmware/pull/11057" target="_blank" rel="noreferrer">#11057</a>)</li><li>Added Sync Timer feature for Split Common keyboards (<a href="https://github.com/qmk/qmk_firmware/pull/10997" target="_blank" rel="noreferrer">#10997</a>)</li><li>Add modifier state to the Split Common transport (<a href="https://github.com/qmk/qmk_firmware/pull/10400" target="_blank" rel="noreferrer">#10400</a>)</li><li>Add Pix keyboard by sendz (<code>sendyyeah/pix</code>) (<a href="https://github.com/qmk/qmk_firmware/pull/11154" target="_blank" rel="noreferrer">#11154</a>)</li><li>Implement option for kinetic mouse movement algorithm for mouse keys (<a href="https://github.com/qmk/qmk_firmware/pull/6739" target="_blank" rel="noreferrer">#6739</a>)</li><li>Improved Language Specific Keycodes for US International and Extended Layouts (<a href="https://github.com/qmk/qmk_firmware/pull/11307" target="_blank" rel="noreferrer">#11307</a>)</li><li>Modified <code>QWIIC_ENABLE</code> in <code>rules.mk</code> to be yes/no choice, adding <code>QWIIC_DRIVERS</code> to allow for inclusion of specific drivers (<a href="https://github.com/qmk/qmk_firmware/pull/11426" target="_blank" rel="noreferrer">#11426</a>)</li><li>Allow AVR-based keyboards to override the <code>bootloader_jump</code> function (<a href="https://github.com/qmk/qmk_firmware/pull/11418" target="_blank" rel="noreferrer">#11418</a>)</li><li>Refine RGBLight Twinkle effect to be smoother (use breathing curve) (<a href="https://github.com/qmk/qmk_firmware/pull/11350" target="_blank" rel="noreferrer">#11350</a>)</li><li>Keep track of last matrix activity (<a href="https://github.com/qmk/qmk_firmware/pull/10730" target="_blank" rel="noreferrer">#10730</a>, <a href="https://github.com/qmk/qmk_firmware/commit/ab375d3d075c105f09a1ddd0e155f178225518bc" target="_blank" rel="noreferrer"><code>ab375d3</code></a>, <a href="https://github.com/qmk/qmk_firmware/pull/11552" target="_blank" rel="noreferrer">#11552</a>)</li><li>fix <code>matrix_io_delay()</code> timing in <code>quantum/matrix.c</code> (<a href="https://github.com/qmk/qmk_firmware/pull/9603" target="_blank" rel="noreferrer">#9603</a>)</li><li>Keep track of encoder activity (<a href="https://github.com/qmk/qmk_firmware/pull/11595" target="_blank" rel="noreferrer">#11595</a>)</li><li>Backport ChibiOS Audio changes from ZSA (<a href="https://github.com/qmk/qmk_firmware/pull/11687" target="_blank" rel="noreferrer">#11687</a>)</li><li>Add support for 8 buttons to mouse report (<a href="https://github.com/qmk/qmk_firmware/pull/10807" target="_blank" rel="noreferrer">#10807</a>)</li><li>Allow <code>post_config.h</code> to be implemented in userspace (<a href="https://github.com/qmk/qmk_firmware/pull/11519" target="_blank" rel="noreferrer">#11519</a>)</li><li>Adds AT90USB162 support (<a href="https://github.com/qmk/qmk_firmware/pull/11570" target="_blank" rel="noreferrer">#11570</a>)</li><li>Stop sounds when suspended (<a href="https://github.com/qmk/qmk_firmware/pull/11553" target="_blank" rel="noreferrer">#11553</a>)</li><li>Revamp spidey3 userspace and keymaps (<a href="https://github.com/qmk/qmk_firmware/pull/11768" target="_blank" rel="noreferrer">#11768</a>)</li><li>Add support for analog USBPD on STM32G4xx (<a href="https://github.com/qmk/qmk_firmware/pull/11824" target="_blank" rel="noreferrer">#11824</a>)</li><li>Master matrix can now be transported to the slave side in Split Common keyboards (<a href="https://github.com/qmk/qmk_firmware/pull/11046" target="_blank" rel="noreferrer">#11046</a>)</li><li>RGBLight: Allow configurable default settings (<a href="https://github.com/qmk/qmk_firmware/pull/11912" target="_blank" rel="noreferrer">#11912</a>)</li><li>Add <code>tap_code_delay(code, delay)</code> (<a href="https://github.com/qmk/qmk_firmware/pull/11913" target="_blank" rel="noreferrer">#11913</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11938" target="_blank" rel="noreferrer">#11938</a>)</li></ul><h3 id="clean-ups-and-optimizations" tabindex="-1">Clean-ups and Optimizations <a class="header-anchor" href="#clean-ups-and-optimizations" aria-label="Permalink to &quot;Clean-ups and Optimizations&quot;">​</a></h3><ul><li>Fix duplicate <code>I2C_KEYMAP_START</code> define (<a href="https://github.com/qmk/qmk_firmware/pull/11237" target="_blank" rel="noreferrer">#11237</a>)</li><li>Rewrite APA102 support for RGBLight (<a href="https://github.com/qmk/qmk_firmware/pull/10894" target="_blank" rel="noreferrer">#10894</a>)</li><li>Update ADB Protocol implementation in TMK Core (<a href="https://github.com/qmk/qmk_firmware/pull/11168" target="_blank" rel="noreferrer">#11168</a>)</li><li>Remove unused <code>action_get_macro()</code> usages in user files (<a href="https://github.com/qmk/qmk_firmware/pull/11165" target="_blank" rel="noreferrer">#11165</a>)</li><li>Remove <code>QMK_KEYBOARD_CONFIG_H</code> (<a href="https://github.com/qmk/qmk_firmware/pull/11576" target="_blank" rel="noreferrer">#11576</a>)</li><li>Remove duplicated housekeeping in <code>arm_atsam</code> (<a href="https://github.com/qmk/qmk_firmware/pull/11672" target="_blank" rel="noreferrer">#11672</a>)</li><li>UART driver refactor (<a href="https://github.com/qmk/qmk_firmware/pull/11637" target="_blank" rel="noreferrer">#11637</a>)</li><li>Move <code>transport.c</code> to <code>QUANTUM_LIB_SRC</code> (<a href="https://github.com/qmk/qmk_firmware/pull/11751" target="_blank" rel="noreferrer">#11751</a>)</li><li>Remove <code>MIDI_ENABLE_STRICT</code> from user keymaps (<a href="https://github.com/qmk/qmk_firmware/pull/11750" target="_blank" rel="noreferrer">#11750</a>)</li><li>Remove legacy print backward compatiblitly (<a href="https://github.com/qmk/qmk_firmware/pull/11805" target="_blank" rel="noreferrer">#11805</a>)</li><li>Migrate mousekey to quantum (<a href="https://github.com/qmk/qmk_firmware/pull/11804" target="_blank" rel="noreferrer">#11804</a>)</li><li>remove deprecated <code>qmk json-keymap</code> (<a href="https://github.com/qmk/qmk_firmware/pull/11823" target="_blank" rel="noreferrer">#11823</a>)</li><li>Remove FAUXCLICKY feature (deprecated) (<a href="https://github.com/qmk/qmk_firmware/pull/11829" target="_blank" rel="noreferrer">#11829</a>)</li><li>Refactor platform logic within <code>print.h</code> (<a href="https://github.com/qmk/qmk_firmware/pull/11863" target="_blank" rel="noreferrer">#11863</a>)</li><li>Audio system overhaul (<a href="https://github.com/qmk/qmk_firmware/pull/11820" target="_blank" rel="noreferrer">#11820</a>)</li><li>Output selection: Remove &quot;USB and BT&quot; option for Bluetooth (<a href="https://github.com/qmk/qmk_firmware/pull/11940" target="_blank" rel="noreferrer">#11940</a>)</li><li><code>tmk_core/common/action.c</code>: refactor for code size; merge multiple <code>case</code>s into one (<a href="https://github.com/qmk/qmk_firmware/pull/11943" target="_blank" rel="noreferrer">#11943</a>)</li><li>Remove rules and settings from user keymaps that are already defined at keyboard level (<a href="https://github.com/qmk/qmk_firmware/pull/11966" target="_blank" rel="noreferrer">#11966</a>)</li></ul><h3 id="qmk-infrastructure-and-internals-1" tabindex="-1">QMK Infrastructure and Internals <a class="header-anchor" href="#qmk-infrastructure-and-internals-1" aria-label="Permalink to &quot;QMK Infrastructure and Internals&quot;">​</a></h3><ul><li>bump to python 3.7 (<a href="https://github.com/qmk/qmk_firmware/pull/11408" target="_blank" rel="noreferrer">#11408</a>)</li><li><code>develop</code> branch is now formatted as part of CI tasks (<a href="https://github.com/qmk/qmk_firmware/pull/11893" target="_blank" rel="noreferrer">#11893</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11905" target="_blank" rel="noreferrer">#11905</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11907" target="_blank" rel="noreferrer">#11907</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11928" target="_blank" rel="noreferrer">#11928</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11936" target="_blank" rel="noreferrer">#11936</a>)</li><li>Configure keyboard matrix from info.json (<a href="https://github.com/qmk/qmk_firmware/pull/10817" target="_blank" rel="noreferrer">#10817</a>)</li><li>Validate our JSON data using json_schema (<a href="https://github.com/qmk/qmk_firmware/pull/11101" target="_blank" rel="noreferrer">#11101</a>)</li><li>Use the schema to eliminate custom code (<a href="https://github.com/qmk/qmk_firmware/pull/11108" target="_blank" rel="noreferrer">#11108</a>)</li><li>Add support for specifying BOARD in <code>info.json</code> (<a href="https://github.com/qmk/qmk_firmware/pull/11492" target="_blank" rel="noreferrer">#11492</a>)</li><li>Document how to add data driven configurations (<a href="https://github.com/qmk/qmk_firmware/pull/11502" target="_blank" rel="noreferrer">#11502</a>)</li><li>Process info.json rules ahead of userspace rules (<a href="https://github.com/qmk/qmk_firmware/pull/11542" target="_blank" rel="noreferrer">#11542</a>)</li><li>Remove duplicate manufacturer definitions (<a href="https://github.com/qmk/qmk_firmware/pull/11544" target="_blank" rel="noreferrer">#11544</a>)</li><li>Update list of MCUs in <code>keyboard.jsonschema</code> to mirror <code>qmk.constants.py</code> (<a href="https://github.com/qmk/qmk_firmware/pull/11688" target="_blank" rel="noreferrer">#11688</a>)</li><li>Create a system to map between <code>info.json</code> and <code>config.h</code>/<code>rules.mk</code> (<a href="https://github.com/qmk/qmk_firmware/pull/11548" target="_blank" rel="noreferrer">#11548</a>)</li><li>Make LAYOUT parsing more robust (<a href="https://github.com/qmk/qmk_firmware/pull/12000" target="_blank" rel="noreferrer">#12000</a>)</li></ul><h3 id="chibios-update-and-config-migration-1" tabindex="-1">ChibiOS Update and Config Migration <a class="header-anchor" href="#chibios-update-and-config-migration-1" aria-label="Permalink to &quot;ChibiOS Update and Config Migration&quot;">​</a></h3><ul><li>Add board specific to Proton-C, with usual defaults turned on to match Pro-Micro (<a href="https://github.com/qmk/qmk_firmware/pull/10976" target="_blank" rel="noreferrer">#10976</a>)</li><li>Disable almost all ChibiOS subsystems in default configs (<a href="https://github.com/qmk/qmk_firmware/pull/11111" target="_blank" rel="noreferrer">#11111</a>)</li><li>Config Migrations (<a href="https://github.com/qmk/qmk_firmware/pull/10418" target="_blank" rel="noreferrer">#10418</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11123" target="_blank" rel="noreferrer">#11123</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11261" target="_blank" rel="noreferrer">#11261</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11413" target="_blank" rel="noreferrer">#11413</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11414" target="_blank" rel="noreferrer">#11414</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11495" target="_blank" rel="noreferrer">#11495</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11504" target="_blank" rel="noreferrer">#11504</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11529" target="_blank" rel="noreferrer">#11529</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11588" target="_blank" rel="noreferrer">#11588</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11598" target="_blank" rel="noreferrer">#11598</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11607" target="_blank" rel="noreferrer">#11607</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11617" target="_blank" rel="noreferrer">#11617</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11620" target="_blank" rel="noreferrer">#11620</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11630" target="_blank" rel="noreferrer">#11630</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11646" target="_blank" rel="noreferrer">#11646</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11689" target="_blank" rel="noreferrer">#11689</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11846" target="_blank" rel="noreferrer">#11846</a>, <a href="https://github.com/qmk/qmk_firmware/pull/11927" target="_blank" rel="noreferrer">#11927</a>, <a href="https://github.com/qmk/qmk_firmware/pull/12001" target="_blank" rel="noreferrer">#12001</a>)</li><li>Disable subsystems repo-wide (<a href="https://github.com/qmk/qmk_firmware/pull/11449" target="_blank" rel="noreferrer">#11449</a>)</li><li>Leftover early initialisation conversions (<a href="https://github.com/qmk/qmk_firmware/pull/11615" target="_blank" rel="noreferrer">#11615</a>)</li><li>Fix up comments showing how to execute config migration (<a href="https://github.com/qmk/qmk_firmware/pull/11621" target="_blank" rel="noreferrer">#11621</a>)</li><li>Add STM32G431 and STM32G474 board definitions (<a href="https://github.com/qmk/qmk_firmware/pull/11793" target="_blank" rel="noreferrer">#11793</a>)</li></ul>', 29);
const _hoisted_30 = [
  _hoisted_1
];
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", null, _hoisted_30);
}
const _20210227 = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  __pageData,
  _20210227 as default
};
