import { _ as _export_sfc, c as createElementBlock, o as openBlock, a8 as createStaticVNode } from "./chunks/framework.B9AX-CPi.js";
const __pageData = JSON.parse('{"title":"QMK Breaking Changes - 2022 May 28 Changelog","description":"","frontmatter":{},"headers":[],"relativePath":"ChangeLog/20220528.md","filePath":"ChangeLog/20220528.md","lastUpdated":null}');
const _sfc_main = { name: "ChangeLog/20220528.md" };
const _hoisted_1 = /* @__PURE__ */ createStaticVNode('<h1 id="qmk-breaking-changes-2022-may-28-changelog" tabindex="-1">QMK Breaking Changes - 2022 May 28 Changelog <a class="header-anchor" href="#qmk-breaking-changes-2022-may-28-changelog" aria-label="Permalink to &quot;QMK Breaking Changes - 2022 May 28 Changelog&quot;">​</a></h1><h2 id="notable-features" tabindex="-1">Notable Features <a class="header-anchor" href="#notable-features" aria-label="Permalink to &quot;Notable Features {#notable-features}&quot;">​</a></h2><h3 id="caps-word" tabindex="-1">Caps Word (<a href="https://github.com/qmk/qmk_firmware/pull/16588" target="_blank" rel="noreferrer">#16588</a>) <a class="header-anchor" href="#caps-word" aria-label="Permalink to &quot;Caps Word ([#16588](https://github.com/qmk/qmk_firmware/pull/16588)) {#caps-word}&quot;">​</a></h3><p>This is a new feature that allows for capslock-like functionality that turns itself off at the end of the word.</p><p>For instance, if you wish to type &quot;QMK&quot; without holding shift the entire time, you can either tap both left and right shift, or double-tap shift, to turn on <em>Caps Word</em> -- then type <code>qmk</code> (lowercase) without holding shift. Once you hit any key other than <code>a</code>--<code>z</code>, <code>0</code>--<code>9</code>, <code>-</code>, <code>_</code>, delete, or backspace, this will go back to normal typing!</p><p>There are other activation mechanisms as well as configurable options like timeout and the like -- see the <a href="./../features/caps_word">Caps Word documentation</a> for more information.</p><h3 id="quantum-painter" tabindex="-1">Quantum Painter (<a href="https://github.com/qmk/qmk_firmware/pull/10174" target="_blank" rel="noreferrer">#10174</a>) <a class="header-anchor" href="#quantum-painter" aria-label="Permalink to &quot;Quantum Painter ([#10174](https://github.com/qmk/qmk_firmware/pull/10174)) {#quantum-painter}&quot;">​</a></h3><p>QMK has had support for small OLED displays for some time now, but hasn&#39;t really gained too much ability to draw to panels other than the SSD1306 or SH1106 panels.</p><p>Quantum Painter is a new drawing subsystem available to suitable ARM and RISC-V boards that is capable of drawing to large panel RGB LCDs and RGB OLEDs. It also allows for a lot more flexibility with a larger set of drawing APIs -- lines, rectangles, circles, ellipses, text, images, and even animations.</p><p>The QMK CLI has new commands added to be able to generate images and fonts for Quantum Painter to digest -- it&#39;s even capable of converting animated gifs for display on screen.</p><p>See the <a href="./../quantum_painter">Quantum Painter documentation</a> for more information on how to set up the displays as well as how to convert images and fonts.</p><div class="warning custom-block"><p class="custom-block-title">WARNING</p><p>Quantum Painter is not supported on AVR due to complexity and size constraints. Boards based on AVR such as ProMicro or Elite-C builds will not be able to leverage Quantum Painter.</p></div><h3 id="encoder-mapping" tabindex="-1">Encoder Mapping (<a href="https://github.com/qmk/qmk_firmware/pull/13286" target="_blank" rel="noreferrer">#13286</a>) <a class="header-anchor" href="#encoder-mapping" aria-label="Permalink to &quot;Encoder Mapping ([#13286](https://github.com/qmk/qmk_firmware/pull/13286)) {#encoder-mapping}&quot;">​</a></h3><p>One of the long-standing complaints with Encoders is that there has been no easy way to configure them in user keymaps. <a href="https://github.com/qmk/qmk_firmware/pull/13286" target="_blank" rel="noreferrer">#13286</a> added support for <a href="./../features/encoders#encoder-map">Encoder Mapping</a>, which allows users to define encoder functionality in a similar way to their normal keymap.</p><div class="warning custom-block"><p class="custom-block-title">WARNING</p><p>This is not yet supported by QMK Configurator. It is also unlikely to ever be supported by VIA.</p></div><h2 id="changes-requiring-user-action" tabindex="-1">Changes Requiring User Action <a class="header-anchor" href="#changes-requiring-user-action" aria-label="Permalink to &quot;Changes Requiring User Action {#changes-requiring-user-action}&quot;">​</a></h2><h3 id="reset-2-qk_boot" tabindex="-1"><code>RESET</code> =&gt; <code>QK_BOOT</code> (<a href="https://github.com/qmk/qmk_firmware/pull/17037" target="_blank" rel="noreferrer">#17037</a>) <a class="header-anchor" href="#reset-2-qk_boot" aria-label="Permalink to &quot;`RESET` =&gt; `QK_BOOT` ([#17037](https://github.com/qmk/qmk_firmware/pull/17037)) {#reset-2-qk_boot}&quot;">​</a></h3><p>QMK is always in the process of picking up support for new hardware platforms. One of the side-effects for future integrations has shown that QMK&#39;s usage of <code>RESET</code> as a keycode is causing naming collisions. As a result, <a href="https://github.com/qmk/qmk_firmware/pull/17037" target="_blank" rel="noreferrer">#17037</a> changed usages of <code>RESET</code> to the new keycode <code>QK_BOOT</code> in the majority of default-like keymaps. At this stage the old keycode is still usable but will likely be removed in the next breaking changes cycle. Users with keymaps containing <code>RESET</code> should also move to <code>QK_BOOT</code>.</p><h3 id="sendstring-keycodes" tabindex="-1">Sendstring keycode overhaul (<a href="https://github.com/qmk/qmk_firmware/pull/16941" target="_blank" rel="noreferrer">#16941</a>) <a class="header-anchor" href="#sendstring-keycodes" aria-label="Permalink to &quot;Sendstring keycode overhaul ([#16941](https://github.com/qmk/qmk_firmware/pull/16941)) {#sendstring-keycodes}&quot;">​</a></h3><p>Some keycodes used with <code>SEND_STRING</code> and its relatives have been deprecated and may have their old keycode usages removed at a later date. The list of <a href="https://github.com/qmk/qmk_firmware/blob/ebd402788346aa6e88bde1486b2a835684d40d39/quantum/send_string_keycodes.h#L456-L505" target="_blank" rel="noreferrer">deprecated keycodes</a> should be consulted to determine if you&#39;re using one of the older names (the first identifier after <code>#define</code>) -- you should swap to the newer variant (the second identifier on the same line).</p><h3 id="pillow-install" tabindex="-1">Pillow Installation (<a href="https://github.com/qmk/qmk_firmware/pull/17133" target="_blank" rel="noreferrer">#17133</a>) <a class="header-anchor" href="#pillow-install" aria-label="Permalink to &quot;Pillow Installation ([#17133](https://github.com/qmk/qmk_firmware/pull/17133)) {#pillow-install}&quot;">​</a></h3><p>The merge of Quantum Painter added some new dependencies in the QMK CLI, most notably <em>Pillow</em>, which requires some installation in order for the CLI to function. If you&#39;ve got an existing installation, you&#39;ll need to run some commands in order to get things working:</p><p>On Windows, if using <em>QMK MSYS</em> or <em>msys2</em>, you&#39;ll need to run the following command:</p><div class="language-sh vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">sh</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">pacman</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> --needed</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> --noconfirm</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> --disable-download-timeout</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> -S</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> mingw-w64-x86_64-python-pillow</span></span>\n<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">python3</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> -m</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> pip</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> install</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> --upgrade</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> qmk</span></span></code></pre></div><p>On macOS:</p><div class="language-sh vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">sh</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">brew</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> update</span></span>\n<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">brew</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> upgrade</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> qmk/qmk/qmk</span></span></code></pre></div><p>On Linux or WSL:</p><div class="language-sh vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">sh</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">python3</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> -m</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> pip</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> install</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> --user</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> --upgrade</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> qmk</span></span></code></pre></div><h3 id="updated-keyboard-codebases" tabindex="-1">Updated Keyboard Codebases <a class="header-anchor" href="#updated-keyboard-codebases" aria-label="Permalink to &quot;Updated Keyboard Codebases {#updated-keyboard-codebases}&quot;">​</a></h3><p>The following keyboards have had their source moved within QMK:</p><table><thead><tr><th>Old Keyboard Name</th><th>New Keyboard Name</th></tr></thead><tbody><tr><td>absinthe</td><td>keyhive/absinthe</td></tr><tr><td>amj40</td><td>amjkeyboard/amj40</td></tr><tr><td>amj60</td><td>amjkeyboard/amj60</td></tr><tr><td>amj96</td><td>amjkeyboard/amj96</td></tr><tr><td>amjpad</td><td>amjkeyboard/amjpad</td></tr><tr><td>at101_bh</td><td>viktus/at101_bh</td></tr><tr><td>ergosaurus</td><td>keyhive/ergosaurus</td></tr><tr><td>gmmk/pro/ansi</td><td>gmmk/pro/rev1/ansi</td></tr><tr><td>gmmk/pro/iso</td><td>gmmk/pro/rev1/iso</td></tr><tr><td>honeycomb</td><td>keyhive/honeycomb</td></tr><tr><td>lattice60</td><td>keyhive/lattice60</td></tr><tr><td>melody96</td><td>ymdk/melody96</td></tr><tr><td>mt40</td><td>mt/mt40</td></tr><tr><td>mt64rgb</td><td>mt/mt64rgb</td></tr><tr><td>mt84</td><td>mt/mt84</td></tr><tr><td>mt980</td><td>mt/mt980</td></tr><tr><td>navi10</td><td>keyhive/navi10</td></tr><tr><td>omnikey_bh</td><td>viktus/omnikey_bh</td></tr><tr><td>opus</td><td>keyhive/opus</td></tr><tr><td>smallice</td><td>keyhive/smallice</td></tr><tr><td>southpole</td><td>keyhive/southpole</td></tr><tr><td>uno</td><td>keyhive/uno</td></tr><tr><td>ut472</td><td>keyhive/ut472</td></tr><tr><td>wheatfield/blocked65</td><td>mt/blocked65</td></tr><tr><td>wheatfield/split75</td><td>mt/split75</td></tr><tr><td>z150_bh</td><td>viktus/z150_bh</td></tr></tbody></table><hr><h2 id="full-changelist" tabindex="-1">Full changelist <a class="header-anchor" href="#full-changelist" aria-label="Permalink to &quot;Full changelist {#full-changelist}&quot;">​</a></h2><p>Core:</p><ul><li>Quantum Painter (<a href="https://github.com/qmk/qmk_firmware/pull/10174" target="_blank" rel="noreferrer">#10174</a>)</li><li>Add support for encoder mapping. (<a href="https://github.com/qmk/qmk_firmware/pull/13286" target="_blank" rel="noreferrer">#13286</a>)</li><li>Add support for multiple switchs/solenoids to Haptic Feedback engine (<a href="https://github.com/qmk/qmk_firmware/pull/15657" target="_blank" rel="noreferrer">#15657</a>)</li><li>Add compile/make macro to core (<a href="https://github.com/qmk/qmk_firmware/pull/15959" target="_blank" rel="noreferrer">#15959</a>)</li><li>Add Reboot keycode to core (<a href="https://github.com/qmk/qmk_firmware/pull/15990" target="_blank" rel="noreferrer">#15990</a>)</li><li>Add support for multiple sensors to pmw3360 (<a href="https://github.com/qmk/qmk_firmware/pull/15996" target="_blank" rel="noreferrer">#15996</a>)</li><li>Asymmetric encoders, encoder tests. (<a href="https://github.com/qmk/qmk_firmware/pull/16068" target="_blank" rel="noreferrer">#16068</a>)</li><li>Add hacky via support for RGB Matrix (<a href="https://github.com/qmk/qmk_firmware/pull/16086" target="_blank" rel="noreferrer">#16086</a>)</li><li>Allow usage of AVRs minimal printf library (<a href="https://github.com/qmk/qmk_firmware/pull/16266" target="_blank" rel="noreferrer">#16266</a>)</li><li>Squeeze AVR some more with <code>-mrelax</code> and <code>-mcall-prologues</code> (<a href="https://github.com/qmk/qmk_firmware/pull/16269" target="_blank" rel="noreferrer">#16269</a>)</li><li>Heatmap incorrect matrix effect workaround (<a href="https://github.com/qmk/qmk_firmware/pull/16315" target="_blank" rel="noreferrer">#16315</a>)</li><li>Add SN74x154 driver and convert AL1 custom matrix (<a href="https://github.com/qmk/qmk_firmware/pull/16331" target="_blank" rel="noreferrer">#16331</a>)</li><li>Add customizable snake and knight animation increments (<a href="https://github.com/qmk/qmk_firmware/pull/16337" target="_blank" rel="noreferrer">#16337</a>)</li><li>Chibios USB protocol: allow overriding RAW Capacity (<a href="https://github.com/qmk/qmk_firmware/pull/16339" target="_blank" rel="noreferrer">#16339</a>)</li><li>HD44780 driver rework (<a href="https://github.com/qmk/qmk_firmware/pull/16370" target="_blank" rel="noreferrer">#16370</a>)</li><li>Update wb32-dfu (<a href="https://github.com/qmk/qmk_firmware/pull/16438" target="_blank" rel="noreferrer">#16438</a>)</li><li>Remove <code>send_unicode_hex_string()</code> (<a href="https://github.com/qmk/qmk_firmware/pull/16518" target="_blank" rel="noreferrer">#16518</a>)</li><li>Add :flash target for UF2 bootloaders (<a href="https://github.com/qmk/qmk_firmware/pull/16525" target="_blank" rel="noreferrer">#16525</a>)</li><li>Move <code>has_mouse_report_changed</code> function to <code>report.c</code> (<a href="https://github.com/qmk/qmk_firmware/pull/16543" target="_blank" rel="noreferrer">#16543</a>)</li><li>Move Doxygen docs to subdirectory (<a href="https://github.com/qmk/qmk_firmware/pull/16561" target="_blank" rel="noreferrer">#16561</a>)</li><li>Add Caps Word feature to core (<a href="https://github.com/qmk/qmk_firmware/pull/16588" target="_blank" rel="noreferrer">#16588</a>)</li><li>Add non blackpill F4x1 config files (<a href="https://github.com/qmk/qmk_firmware/pull/16600" target="_blank" rel="noreferrer">#16600</a>)</li><li>Force platform pin defs to be included (<a href="https://github.com/qmk/qmk_firmware/pull/16611" target="_blank" rel="noreferrer">#16611</a>)</li><li>Refactor CTPC logic to allow future converters (<a href="https://github.com/qmk/qmk_firmware/pull/16621" target="_blank" rel="noreferrer">#16621</a>)</li><li>Use a mutex guard for split shared memory (<a href="https://github.com/qmk/qmk_firmware/pull/16647" target="_blank" rel="noreferrer">#16647</a>)</li><li>Rename TICK to TICK_EVENT (<a href="https://github.com/qmk/qmk_firmware/pull/16649" target="_blank" rel="noreferrer">#16649</a>)</li><li>Add GET_TAPPING_TERM macro to reduce duplicate code (<a href="https://github.com/qmk/qmk_firmware/pull/16681" target="_blank" rel="noreferrer">#16681</a>)</li><li>add the ability to change the pwm frequency for the IS31FL3737B (<a href="https://github.com/qmk/qmk_firmware/pull/16718" target="_blank" rel="noreferrer">#16718</a>)</li><li>Joystick feature updates (<a href="https://github.com/qmk/qmk_firmware/pull/16732" target="_blank" rel="noreferrer">#16732</a>)</li><li>Add emulated eeprom support for STM32F303xE (<a href="https://github.com/qmk/qmk_firmware/pull/16737" target="_blank" rel="noreferrer">#16737</a>)</li><li>Refactor writePin to work with statements (<a href="https://github.com/qmk/qmk_firmware/pull/16738" target="_blank" rel="noreferrer">#16738</a>)</li><li>Add mechanism to limit available converters (<a href="https://github.com/qmk/qmk_firmware/pull/16783" target="_blank" rel="noreferrer">#16783</a>)</li><li>Implement XAP &#39;secure&#39; core requirements (<a href="https://github.com/qmk/qmk_firmware/pull/16843" target="_blank" rel="noreferrer">#16843</a>)</li><li>rgblight: Add functions to stop blinking one or all but one layer (<a href="https://github.com/qmk/qmk_firmware/pull/16859" target="_blank" rel="noreferrer">#16859</a>)</li><li>Expose API for hardware unique ID (<a href="https://github.com/qmk/qmk_firmware/pull/16869" target="_blank" rel="noreferrer">#16869</a>)</li><li>Added support for Wb32fq95 (<a href="https://github.com/qmk/qmk_firmware/pull/16871" target="_blank" rel="noreferrer">#16871</a>)</li><li>Provide better config defaults for bluepill boards (<a href="https://github.com/qmk/qmk_firmware/pull/16909" target="_blank" rel="noreferrer">#16909</a>)</li><li>Joystick: Simplify report descriptor and clean up error messages (<a href="https://github.com/qmk/qmk_firmware/pull/16926" target="_blank" rel="noreferrer">#16926</a>)</li><li>Rename keymap_extras headers for consistency (<a href="https://github.com/qmk/qmk_firmware/pull/16939" target="_blank" rel="noreferrer">#16939</a>)</li><li>Sendstring keycode overhaul (<a href="https://github.com/qmk/qmk_firmware/pull/16941" target="_blank" rel="noreferrer">#16941</a>)</li><li>Move disable_jtag to platforms (<a href="https://github.com/qmk/qmk_firmware/pull/16960" target="_blank" rel="noreferrer">#16960</a>)</li><li>Remove ARM pgm_read_word workaround in rgblight (<a href="https://github.com/qmk/qmk_firmware/pull/16961" target="_blank" rel="noreferrer">#16961</a>)</li><li>Warn about LTO with arm_atsam, not ChibiOS. (<a href="https://github.com/qmk/qmk_firmware/pull/17106" target="_blank" rel="noreferrer">#17106</a>)</li></ul><p>CLI:</p><ul><li>Rework generate-api CLI command to use .build directory (<a href="https://github.com/qmk/qmk_firmware/pull/16441" target="_blank" rel="noreferrer">#16441</a>)</li><li>Change data driven &quot;str&quot; type to represent a quoted string literal (<a href="https://github.com/qmk/qmk_firmware/pull/16516" target="_blank" rel="noreferrer">#16516</a>)</li><li>Bump the &#39;jsonschema&#39; version (<a href="https://github.com/qmk/qmk_firmware/pull/16635" target="_blank" rel="noreferrer">#16635</a>)</li><li>Add frameworking for development board presets (<a href="https://github.com/qmk/qmk_firmware/pull/16637" target="_blank" rel="noreferrer">#16637</a>)</li><li>Extend &#39;qmk info&#39; to handle keymap level overrides (<a href="https://github.com/qmk/qmk_firmware/pull/16702" target="_blank" rel="noreferrer">#16702</a>)</li><li>Data driven <code>g_led_config</code> (<a href="https://github.com/qmk/qmk_firmware/pull/16728" target="_blank" rel="noreferrer">#16728</a>)</li><li>Allow new-keyboard to use development_board presets (<a href="https://github.com/qmk/qmk_firmware/pull/16785" target="_blank" rel="noreferrer">#16785</a>)</li><li>Also format *.hpp files. (<a href="https://github.com/qmk/qmk_firmware/pull/16997" target="_blank" rel="noreferrer">#16997</a>)</li></ul><p>Submodule updates:</p><ul><li>ChibiOS 21.11.1 update. (<a href="https://github.com/qmk/qmk_firmware/pull/16251" target="_blank" rel="noreferrer">#16251</a>)</li><li>Update ChibiOS-Contrib (<a href="https://github.com/qmk/qmk_firmware/pull/16915" target="_blank" rel="noreferrer">#16915</a>)</li></ul><p>Keyboards:</p><ul><li>chore: Add personal GMMK Pro keymap (<a href="https://github.com/qmk/qmk_firmware/pull/15320" target="_blank" rel="noreferrer">#15320</a>)</li><li>move melody96 to ymdk vendor folder (<a href="https://github.com/qmk/qmk_firmware/pull/15680" target="_blank" rel="noreferrer">#15680</a>)</li><li>move amj keyboards into amjkeyboard vendor folder (<a href="https://github.com/qmk/qmk_firmware/pull/15733" target="_blank" rel="noreferrer">#15733</a>)</li><li>move z150_bh at101_bh omnikey_bh to viktus/ (<a href="https://github.com/qmk/qmk_firmware/pull/16004" target="_blank" rel="noreferrer">#16004</a>)</li><li>MS Sculpt Mobile refactor (<a href="https://github.com/qmk/qmk_firmware/pull/16038" target="_blank" rel="noreferrer">#16038</a>)</li><li>move keyhive exclusive boards into /keyhive (<a href="https://github.com/qmk/qmk_firmware/pull/16084" target="_blank" rel="noreferrer">#16084</a>)</li><li>move 麦田 boards into /mt (<a href="https://github.com/qmk/qmk_firmware/pull/16095" target="_blank" rel="noreferrer">#16095</a>)</li><li>Convert Wasdat Code custom matrix to SN74x138 driver (<a href="https://github.com/qmk/qmk_firmware/pull/16257" target="_blank" rel="noreferrer">#16257</a>)</li><li>Move GMMK Pro to allow for multiple revisions (<a href="https://github.com/qmk/qmk_firmware/pull/16423" target="_blank" rel="noreferrer">#16423</a>)</li><li>Updated pin mapping and readme. (<a href="https://github.com/qmk/qmk_firmware/pull/16505" target="_blank" rel="noreferrer">#16505</a>)</li><li>Map data driven <code>DESCRIPTION</code> as string literal (<a href="https://github.com/qmk/qmk_firmware/pull/16523" target="_blank" rel="noreferrer">#16523</a>)</li><li>remove unecessary layers (<a href="https://github.com/qmk/qmk_firmware/pull/16559" target="_blank" rel="noreferrer">#16559</a>)</li><li>Helix/rev2 move to split common (<a href="https://github.com/qmk/qmk_firmware/pull/16723" target="_blank" rel="noreferrer">#16723</a>)</li><li>Remove some layout exceptions (<a href="https://github.com/qmk/qmk_firmware/pull/16957" target="_blank" rel="noreferrer">#16957</a>)</li><li>Refactor legacy quantum keycodes in default-ish keymaps (<a href="https://github.com/qmk/qmk_firmware/pull/17037" target="_blank" rel="noreferrer">#17037</a>)</li><li>Refactor legacy quantum keycodes in default-ish keymaps (<a href="https://github.com/qmk/qmk_firmware/pull/17150" target="_blank" rel="noreferrer">#17150</a>)</li></ul><p>Keyboard fixes:</p><ul><li>gboards/gergoplex: move <code>COMBO_ENABLE</code> to keymap level (<a href="https://github.com/qmk/qmk_firmware/pull/16667" target="_blank" rel="noreferrer">#16667</a>)</li><li>usb-usb converter: community layout support (<a href="https://github.com/qmk/qmk_firmware/pull/16773" target="_blank" rel="noreferrer">#16773</a>)</li><li>Fix build of <code>keyhive/uno</code>. (<a href="https://github.com/qmk/qmk_firmware/pull/16891" target="_blank" rel="noreferrer">#16891</a>)</li><li>Fix uno (<a href="https://github.com/qmk/qmk_firmware/pull/16892" target="_blank" rel="noreferrer">#16892</a>)</li><li>converter/usb_usb: remove surplus commas (<a href="https://github.com/qmk/qmk_firmware/pull/17024" target="_blank" rel="noreferrer">#17024</a>)</li><li>Various fixes for g_led_config lint warnings (<a href="https://github.com/qmk/qmk_firmware/pull/17104" target="_blank" rel="noreferrer">#17104</a>)</li></ul><p>Others:</p><ul><li>Add warning for CTPC/CONVERT_TO_PROTON_C. (<a href="https://github.com/qmk/qmk_firmware/pull/16782" target="_blank" rel="noreferrer">#16782</a>)</li><li>Add bluepill/blackpill development board presets (<a href="https://github.com/qmk/qmk_firmware/pull/16806" target="_blank" rel="noreferrer">#16806</a>)</li><li>Recommend pillow as part of manual MSYS install (<a href="https://github.com/qmk/qmk_firmware/pull/17133" target="_blank" rel="noreferrer">#17133</a>)</li></ul><p>Bugs:</p><ul><li>Fix one-shot locked modifiers (<a href="https://github.com/qmk/qmk_firmware/pull/16114" target="_blank" rel="noreferrer">#16114</a>)</li><li>Fix missing definition for non-encoder case. (<a href="https://github.com/qmk/qmk_firmware/pull/16593" target="_blank" rel="noreferrer">#16593</a>)</li><li>Fixup builds. (<a href="https://github.com/qmk/qmk_firmware/pull/16596" target="_blank" rel="noreferrer">#16596</a>)</li><li>Missed some erroneous prints. (<a href="https://github.com/qmk/qmk_firmware/pull/16597" target="_blank" rel="noreferrer">#16597</a>)</li><li>Workaround for pin_def errors on KINETIS based builds (<a href="https://github.com/qmk/qmk_firmware/pull/16614" target="_blank" rel="noreferrer">#16614</a>)</li><li>Fix flipped logic bug with One Shot <code>OS_ON</code> / <code>OS_OFF</code> keys (<a href="https://github.com/qmk/qmk_firmware/pull/16617" target="_blank" rel="noreferrer">#16617</a>)</li><li>Redo workaround for pin_def errors on KINETIS (<a href="https://github.com/qmk/qmk_firmware/pull/16620" target="_blank" rel="noreferrer">#16620</a>)</li><li>Fix oneshot toggle logic (<a href="https://github.com/qmk/qmk_firmware/pull/16630" target="_blank" rel="noreferrer">#16630</a>)</li><li>Mousekeys fix (<a href="https://github.com/qmk/qmk_firmware/pull/16640" target="_blank" rel="noreferrer">#16640</a>)</li><li>Ignore transport defaults if SPLIT_KEYBOARD is unset (<a href="https://github.com/qmk/qmk_firmware/pull/16706" target="_blank" rel="noreferrer">#16706</a>)</li><li>Fixes #16705 : digital rain follows val (<a href="https://github.com/qmk/qmk_firmware/pull/16716" target="_blank" rel="noreferrer">#16716</a>)</li><li>Fix AVR backlight breathing: low brightness limit &amp; exceeding breathing table max index (<a href="https://github.com/qmk/qmk_firmware/pull/16770" target="_blank" rel="noreferrer">#16770</a>)</li><li>Fixed usb read loops not reading until timeout (<a href="https://github.com/qmk/qmk_firmware/pull/16827" target="_blank" rel="noreferrer">#16827</a>)</li><li>[QP] Check BPP capabilities before loading the palette (<a href="https://github.com/qmk/qmk_firmware/pull/16863" target="_blank" rel="noreferrer">#16863</a>)</li><li>Fix #16859. (<a href="https://github.com/qmk/qmk_firmware/pull/16865" target="_blank" rel="noreferrer">#16865</a>)</li><li>Preinstall python dependencies before executing <code>qmk</code>. (<a href="https://github.com/qmk/qmk_firmware/pull/16874" target="_blank" rel="noreferrer">#16874</a>)</li><li>Fixup AVR builds. (<a href="https://github.com/qmk/qmk_firmware/pull/16875" target="_blank" rel="noreferrer">#16875</a>)</li><li>Fix kinetic mouse mode (<a href="https://github.com/qmk/qmk_firmware/pull/16951" target="_blank" rel="noreferrer">#16951</a>)</li><li>Enhancement and fixes of &quot;Secure&quot; feature (<a href="https://github.com/qmk/qmk_firmware/pull/16958" target="_blank" rel="noreferrer">#16958</a>)</li><li>Check for ongoing transfers on the OUT endpoint (<a href="https://github.com/qmk/qmk_firmware/pull/16974" target="_blank" rel="noreferrer">#16974</a>)</li><li>MSYS2 install: add some Python dependencies through Pacman (<a href="https://github.com/qmk/qmk_firmware/pull/17025" target="_blank" rel="noreferrer">#17025</a>)</li><li>Revert &quot;Fix kinetic mouse mode (#16951)&quot; (<a href="https://github.com/qmk/qmk_firmware/pull/17095" target="_blank" rel="noreferrer">#17095</a>)</li><li>Workaround for recent -Werror=array-bounds AVR issues (<a href="https://github.com/qmk/qmk_firmware/pull/17136" target="_blank" rel="noreferrer">#17136</a>)</li><li>Bug fix: Continue Caps Word when AltGr (right Alt) is held. (<a href="https://github.com/qmk/qmk_firmware/pull/17156" target="_blank" rel="noreferrer">#17156</a>)</li></ul>', 47);
const _hoisted_48 = [
  _hoisted_1
];
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", null, _hoisted_48);
}
const _20220528 = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  __pageData,
  _20220528 as default
};
