import { _ as _export_sfc, c as createElementBlock, o as openBlock, a8 as createStaticVNode } from "./chunks/framework.B9AX-CPi.js";
const __pageData = JSON.parse('{"title":"Compatible Microcontrollers","description":"","frontmatter":{},"headers":[],"relativePath":"compatible_microcontrollers.md","filePath":"compatible_microcontrollers.md","lastUpdated":null}');
const _sfc_main = { name: "compatible_microcontrollers.md" };
const _hoisted_1 = /* @__PURE__ */ createStaticVNode('<h1 id="compatible-microcontrollers" tabindex="-1">Compatible Microcontrollers <a class="header-anchor" href="#compatible-microcontrollers" aria-label="Permalink to &quot;Compatible Microcontrollers&quot;">​</a></h1><p>QMK runs on any USB-capable AVR or ARM microcontroller with enough flash space - generally 32kB+ for AVR, and 64kB+ for ARM. With significant disabling of features, QMK may <em>just</em> squeeze into 16kB AVR MCUs.</p><p>Features within QMK may or may not be compatible with every microcontroller.</p><h2 id="atmel-avr" tabindex="-1">Atmel AVR <a class="header-anchor" href="#atmel-avr" aria-label="Permalink to &quot;Atmel AVR&quot;">​</a></h2><p>The following use <a href="https://www.fourwalledcubicle.com/LUFA.php" target="_blank" rel="noreferrer">LUFA</a> as the USB stack:</p><ul><li><a href="https://www.microchip.com/wwwproducts/en/ATmega16U2" target="_blank" rel="noreferrer">ATmega16U2</a> / <a href="https://www.microchip.com/wwwproducts/en/ATmega32U2" target="_blank" rel="noreferrer">ATmega32U2</a></li><li><a href="https://www.microchip.com/wwwproducts/en/ATmega16U4" target="_blank" rel="noreferrer">ATmega16U4</a> / <a href="https://www.microchip.com/wwwproducts/en/ATmega32U4" target="_blank" rel="noreferrer">ATmega32U4</a><ul><li>SparkFun Pro Micro (and clones)</li><li>PJRC Teensy 2.0</li><li>Adafruit Feather 32U4</li></ul></li><li><a href="https://www.microchip.com/wwwproducts/en/AT90USB646" target="_blank" rel="noreferrer">AT90USB64</a> / <a href="https://www.microchip.com/wwwproducts/en/AT90USB1286" target="_blank" rel="noreferrer">AT90USB128</a><ul><li>PJRC Teensy++ 2.0</li></ul></li><li><a href="https://www.microchip.com/wwwproducts/en/AT90USB162" target="_blank" rel="noreferrer">AT90USB162</a></li></ul><p>Certain MCUs which do not have native USB will use <a href="https://www.obdev.at/products/vusb/index.html" target="_blank" rel="noreferrer">V-USB</a> instead:</p><ul><li><a href="https://www.microchip.com/wwwproducts/en/ATmega32A" target="_blank" rel="noreferrer">ATmega32A</a></li><li><a href="https://www.microchip.com/wwwproducts/en/ATmega328P" target="_blank" rel="noreferrer">ATmega328P</a></li><li><a href="https://www.microchip.com/wwwproducts/en/ATmega328" target="_blank" rel="noreferrer">ATmega328</a></li></ul><h2 id="arm" tabindex="-1">ARM <a class="header-anchor" href="#arm" aria-label="Permalink to &quot;ARM&quot;">​</a></h2><p>You can also use any ARM chip with USB that <a href="https://www.chibios.org" target="_blank" rel="noreferrer">ChibiOS</a> supports. Most have plenty of flash. Known to work are:</p><h3 id="stmicroelectronics-stm32" tabindex="-1">STMicroelectronics (STM32) <a class="header-anchor" href="#stmicroelectronics-stm32" aria-label="Permalink to &quot;STMicroelectronics (STM32)&quot;">​</a></h3><ul><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32f0x2.html" target="_blank" rel="noreferrer">STM32F0x2</a></li><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32f103.html" target="_blank" rel="noreferrer">STM32F103</a><ul><li>Bluepill (with STM32duino bootloader)</li></ul></li><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32f303.html" target="_blank" rel="noreferrer">STM32F303</a><ul><li>QMK Proton-C</li></ul></li><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32f401.html" target="_blank" rel="noreferrer">STM32F401</a><ul><li>WeAct Blackpill</li></ul></li><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32f405-415.html" target="_blank" rel="noreferrer">STM32F405</a></li><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32f407-417.html" target="_blank" rel="noreferrer">STM32F407</a></li><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32f411.html" target="_blank" rel="noreferrer">STM32F411</a><ul><li>WeAct Blackpill</li></ul></li><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32f446.html" target="_blank" rel="noreferrer">STM32F446</a></li><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32g4x1.html" target="_blank" rel="noreferrer">STM32G431</a></li><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32g4x4.html" target="_blank" rel="noreferrer">STM32G474</a></li><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32h723-733.html" target="_blank" rel="noreferrer">STM32H723</a></li><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32h723-733.html" target="_blank" rel="noreferrer">STM32H733</a></li><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32l4x2.html" target="_blank" rel="noreferrer">STM32L412</a></li><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32l4x2.html" target="_blank" rel="noreferrer">STM32L422</a></li><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32l4x2.html" target="_blank" rel="noreferrer">STM32L432</a></li><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32l4x3.html" target="_blank" rel="noreferrer">STM32L433</a></li><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32l4x2.html" target="_blank" rel="noreferrer">STM32L442</a></li><li><a href="https://www.st.com/en/microcontrollers-microprocessors/stm32l4x3.html" target="_blank" rel="noreferrer">STM32L443</a></li></ul><h3 id="westberrytech-wb32" tabindex="-1">WestBerryTech (WB32) <a class="header-anchor" href="#westberrytech-wb32" aria-label="Permalink to &quot;WestBerryTech (WB32)&quot;">​</a></h3><ul><li><a href="http://www.westberrytech.com" target="_blank" rel="noreferrer">WB32F3G71xx</a></li><li><a href="http://www.westberrytech.com" target="_blank" rel="noreferrer">WB32FQ95xx</a></li></ul><h3 id="artery-at32" tabindex="-1">Artery (AT32) <a class="header-anchor" href="#artery-at32" aria-label="Permalink to &quot;Artery (AT32)&quot;">​</a></h3><ul><li><a href="https://www.arterychip.com/en/product/AT32F415.jsp" target="_blank" rel="noreferrer">AT32F415</a></li></ul><h3 id="nxp-kinetis" tabindex="-1">NXP (Kinetis) <a class="header-anchor" href="#nxp-kinetis" aria-label="Permalink to &quot;NXP (Kinetis)&quot;">​</a></h3><ul><li><a href="https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/general-purpose-mcus/kl-series-cortex-m0-plus/kinetis-kl2x-72-96-mhz-usb-ultra-low-power-microcontrollers-mcus-based-on-arm-cortex-m0-plus-core:KL2x" target="_blank" rel="noreferrer">MKL26Z64</a><ul><li>PJRC Teensy LC</li></ul></li><li><a href="https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/general-purpose-mcus/k-series-cortex-m4/k2x-usb/kinetis-k20-50-mhz-full-speed-usb-mixed-signal-integration-microcontrollers-based-on-arm-cortex-m4-core:K20_50" target="_blank" rel="noreferrer">MK20DX128</a></li><li><a href="https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/general-purpose-mcus/k-series-cortex-m4/k2x-usb/kinetis-k20-72-mhz-full-speed-usb-mixed-signal-integration-microcontrollers-mcus-based-on-arm-cortex-m4-core:K20_72" target="_blank" rel="noreferrer">MK20DX256</a><ul><li>PJRC Teensy 3.2</li></ul></li><li><a href="https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/general-purpose-mcus/k-series-cortex-m4/k6x-ethernet/kinetis-k64-120-mhz-256-kb-sram-microcontrollers-mcus-based-on-arm-cortex-m4-core:K64_120" target="_blank" rel="noreferrer">MK64FX512</a><ul><li>PJRC Teensy 3.5</li></ul></li><li><a href="https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/general-purpose-mcus/k-series-cortex-m4/k6x-ethernet/kinetis-k66-180-mhz-dual-high-speed-full-speed-usbs-2mb-flash-microcontrollers-mcus-based-on-arm-cortex-m4-core:K66_180" target="_blank" rel="noreferrer">MK66FX1M0</a><ul><li>PJRC Teensy 3.6</li></ul></li></ul><h3 id="raspberry-pi" tabindex="-1">Raspberry Pi <a class="header-anchor" href="#raspberry-pi" aria-label="Permalink to &quot;Raspberry Pi&quot;">​</a></h3><ul><li><a href="https://www.raspberrypi.com/documentation/microcontrollers/rp2040.html" target="_blank" rel="noreferrer">RP2040</a></li></ul><p>For a detailed overview about the RP2040 support by QMK see the <a href="./platformdev_rp2040">dedicated RP2040 page</a>.</p><h2 id="risc-v" tabindex="-1">RISC-V <a class="header-anchor" href="#risc-v" aria-label="Permalink to &quot;RISC-V&quot;">​</a></h2><h3 id="gigadevice" tabindex="-1">GigaDevice <a class="header-anchor" href="#gigadevice" aria-label="Permalink to &quot;GigaDevice&quot;">​</a></h3><p><a href="https://github.com/ChibiOS/ChibiOS-Contrib" target="_blank" rel="noreferrer">ChibiOS-Contrib</a> has support for the GigaDevice <a href="https://www.gigadevice.com/products/microcontrollers/gd32/risc-v/mainstream-line/gd32vf103-series/" target="_blank" rel="noreferrer">GD32VF103 series</a> microcontrollers and provides configurations for the <a href="https://longan.sipeed.com/en/" target="_blank" rel="noreferrer">SiPeed Longan Nano</a> development board that uses this microcontroller. It is largely pin and feature compatible with STM32F103 and STM32F303 microcontrollers.</p>', 24);
const _hoisted_25 = [
  _hoisted_1
];
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", null, _hoisted_25);
}
const compatible_microcontrollers = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  __pageData,
  compatible_microcontrollers as default
};
