import { _ as _export_sfc, c as createElementBlock, o as openBlock, a8 as createStaticVNode } from "./chunks/framework.B9AX-CPi.js";
const __pageData = JSON.parse('{"title":"QMK Configurator: Step by Step","description":"","frontmatter":{},"headers":[],"relativePath":"configurator_step_by_step.md","filePath":"configurator_step_by_step.md","lastUpdated":null}');
const _sfc_main = { name: "configurator_step_by_step.md" };
const _hoisted_1 = /* @__PURE__ */ createStaticVNode('<h1 id="qmk-configurator-step-by-step" tabindex="-1">QMK Configurator: Step by Step <a class="header-anchor" href="#qmk-configurator-step-by-step" aria-label="Permalink to &quot;QMK Configurator: Step by Step&quot;">​</a></h1><p>This page describes the steps for building your firmware in QMK Configurator.</p><h2 id="step-1-select-your-keyboard" tabindex="-1">Step 1: Select Your Keyboard <a class="header-anchor" href="#step-1-select-your-keyboard" aria-label="Permalink to &quot;Step 1: Select Your Keyboard&quot;">​</a></h2><p>Click the drop down box and select the keyboard you want to create a keymap for.</p><div class="tip custom-block"><p class="custom-block-title">TIP</p><p>If your keyboard has several versions, make sure you select the correct one.</p></div><p>I&#39;ll say that again because it&#39;s important:</p><div class="warning custom-block"><p class="custom-block-title">WARNING</p><p><strong>MAKE SURE YOU SELECT THE RIGHT VERSION!</strong></p></div><p>Unfortunately if your keyboard has been advertised to be powered by QMK but is not in the list, you will <strong>not</strong> be able to use Configurator to customize your keyboard.</p><p>Chances are a developer hasn&#39;t gotten round to adding support or we haven&#39;t had a chance to merge it in yet. If there is no active <a href="https://github.com/qmk/qmk_firmware/pulls?q=is%3Aopen+is%3Apr+label%3Akeyboard" target="_blank" rel="noreferrer">Pull Request</a>, contact the manufacturer and encourage them to add support.</p><h2 id="step-2-select-your-keyboard-layout" tabindex="-1">Step 2: Select Your Keyboard Layout <a class="header-anchor" href="#step-2-select-your-keyboard-layout" aria-label="Permalink to &quot;Step 2: Select Your Keyboard Layout&quot;">​</a></h2><p>Choose the layout that best represents the keymap you want to create. Some keyboards do not have enough layouts or correct layouts defined yet. They will be supported in the future.</p><div class="warning custom-block"><p class="custom-block-title">WARNING</p><p>Sometimes there isn&#39;t a layout that supports your exact build. In that case select <code>LAYOUT_all</code>.</p></div><h2 id="step-3-name-your-keymap" tabindex="-1">Step 3: Name Your Keymap <a class="header-anchor" href="#step-3-name-your-keymap" aria-label="Permalink to &quot;Step 3: Name Your Keymap&quot;">​</a></h2><p>Call this keymap what you want.</p><div class="tip custom-block"><p class="custom-block-title">TIP</p><p>If you are running into issues when compiling, it may be worth changing this name, as it may already exist in the QMK Firmware repo.</p></div><h2 id="step-4-define-your-keymap" tabindex="-1">Step 4: Define Your Keymap <a class="header-anchor" href="#step-4-define-your-keymap" aria-label="Permalink to &quot;Step 4: Define Your Keymap&quot;">​</a></h2><p>Keycode Entry is accomplished in one of 3 ways:</p><ol><li>Drag and drop</li><li>Clicking on an empty spot on the layout, then clicking the keycode you desire</li><li>Clicking on an empty spot on the layout, then pressing the physical key on your keyboard</li></ol><div class="tip custom-block"><p class="custom-block-title">TIP</p><p>Hover your mouse over a key and a short blurb will tell you what that keycode does. For a more verbose description please see:</p></div><ul><li><a href="./keycodes_basic">Basic Keycode Reference</a></li><li><a href="./feature_advanced_keycodes">Advanced Keycode Reference</a></li></ul><div class="warning custom-block"><p class="custom-block-title">WARNING</p><p>If your selected layout doesn&#39;t match your physical build leave the unused keys blank. If you&#39;re not sure which key is in use, for example you have a one backspace key but <code>LAYOUT_all</code> has 2 keys, put the same keycode in both locations.</p></div><h2 id="step-5-save-your-keymap-for-future-changes" tabindex="-1">Step 5: Save Your Keymap for Future Changes <a class="header-anchor" href="#step-5-save-your-keymap-for-future-changes" aria-label="Permalink to &quot;Step 5: Save Your Keymap for Future Changes&quot;">​</a></h2><p>When you&#39;re satisfied with your keymap or just want to work on it later, press the <code>Download this QMK Keymap JSON File</code> button. It will save your keymap to your computer. You can then load this .json file in the future by pressing the <code>Upload a QMK Keymap JSON File</code> button.</p><div class="warning custom-block"><p class="custom-block-title">WARNING</p><p><strong>CAUTION:</strong> This is not the same type of .json file used for kbfirmware.com or any other tool. If you try to use this for those tools, or the .json from those tools with QMK Configurator, you will encounter problems.</p></div><h2 id="step-6-compile-your-firmware-file" tabindex="-1">Step 6: Compile Your Firmware File <a class="header-anchor" href="#step-6-compile-your-firmware-file" aria-label="Permalink to &quot;Step 6: Compile Your Firmware File&quot;">​</a></h2><p>Press the green <code>Compile</code> button.</p><p>When the compilation is done, you will be able to press the green <code>Download Firmware</code> button.</p><h2 id="next-steps-flashing-your-keyboard" tabindex="-1">Next steps: Flashing Your Keyboard <a class="header-anchor" href="#next-steps-flashing-your-keyboard" aria-label="Permalink to &quot;Next steps: Flashing Your Keyboard&quot;">​</a></h2><p>Please refer to <a href="./newbs_flashing">Flashing Firmware</a>.</p>', 29);
const _hoisted_30 = [
  _hoisted_1
];
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", null, _hoisted_30);
}
const configurator_step_by_step = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  __pageData,
  configurator_step_by_step as default
};
