import { _ as _export_sfc, c as createElementBlock, o as openBlock, a8 as createStaticVNode } from "./chunks/framework.B9AX-CPi.js";
const __pageData = JSON.parse('{"title":"Frequently Asked Questions","description":"","frontmatter":{},"headers":[],"relativePath":"faq_general.md","filePath":"faq_general.md","lastUpdated":null}');
const _sfc_main = { name: "faq_general.md" };
const _hoisted_1 = /* @__PURE__ */ createStaticVNode('<h1 id="frequently-asked-questions" tabindex="-1">Frequently Asked Questions <a class="header-anchor" href="#frequently-asked-questions" aria-label="Permalink to &quot;Frequently Asked Questions&quot;">​</a></h1><h2 id="what-is-qmk" tabindex="-1">What is QMK? <a class="header-anchor" href="#what-is-qmk" aria-label="Permalink to &quot;What is QMK?&quot;">​</a></h2><p><a href="https://github.com/qmk" target="_blank" rel="noreferrer">QMK</a>, short for Quantum Mechanical Keyboard, is a group of people building tools for custom keyboards. We started with the <a href="https://github.com/qmk/qmk_firmware" target="_blank" rel="noreferrer">QMK firmware</a>, a heavily modified fork of <a href="https://github.com/tmk/tmk_keyboard" target="_blank" rel="noreferrer">TMK</a>.</p><h2 id="i-don-t-know-where-to-start" tabindex="-1">I don&#39;t know where to start! <a class="header-anchor" href="#i-don-t-know-where-to-start" aria-label="Permalink to &quot;I don&#39;t know where to start!&quot;">​</a></h2><p>If this is the case, then you should start with our <a href="./newbs">Newbs Guide</a>. There is a lot of great info there, and that should cover everything you need to get started.</p><p>If that&#39;s an issue, hop onto the <a href="https://config.qmk.fm" target="_blank" rel="noreferrer">QMK Configurator</a>, as that will handle a majority of what you need there.</p><h2 id="how-can-i-flash-the-firmware-i-built" tabindex="-1">How can I flash the firmware I built? <a class="header-anchor" href="#how-can-i-flash-the-firmware-i-built" aria-label="Permalink to &quot;How can I flash the firmware I built?&quot;">​</a></h2><p>First, head to the <a href="./faq_build">Compiling/Flashing FAQ Page</a>. There is a good deal of info there, and you&#39;ll find a bunch of solutions to common issues there.</p><h2 id="what-if-i-have-an-issue-that-isn-t-covered-here" tabindex="-1">What if I have an issue that isn&#39;t covered here? <a class="header-anchor" href="#what-if-i-have-an-issue-that-isn-t-covered-here" aria-label="Permalink to &quot;What if I have an issue that isn&#39;t covered here?&quot;">​</a></h2><p>Okay, that&#39;s fine. Then please check the <a href="https://github.com/qmk/qmk_firmware/issues" target="_blank" rel="noreferrer">open issues in our GitHub</a> to see if somebody is experiencing the same thing (make sure it&#39;s not just similar, but actually the same).</p><p>If you can&#39;t find anything, then please open a <a href="https://github.com/qmk/qmk_firmware/issues/new" target="_blank" rel="noreferrer">new issue</a>!</p><h2 id="what-if-i-found-a-bug" tabindex="-1">What if I found a bug? <a class="header-anchor" href="#what-if-i-found-a-bug" aria-label="Permalink to &quot;What if I found a bug?&quot;">​</a></h2><p>Then please open an <a href="https://github.com/qmk/qmk_firmware/issues/new" target="_blank" rel="noreferrer">issue</a>, and if you know how to fix it, open up a Pull Request on GitHub with the fix.</p><h2 id="but-git-and-github-are-intimidating" tabindex="-1">But <code>git</code> and <code>GitHub</code> are intimidating! <a class="header-anchor" href="#but-git-and-github-are-intimidating" aria-label="Permalink to &quot;But `git` and `GitHub` are intimidating!&quot;">​</a></h2><p>Don&#39;t worry, we have some pretty nice <a href="./newbs_git_best_practices">Guidelines</a> on how to start using <code>git</code> and GitHub to make things easier to develop.</p><p>Additionally, you can find additional <code>git</code> and GitHub related links <a href="./newbs_learn_more_resources">here</a>.</p><h2 id="i-have-a-keyboard-that-i-want-to-add-support-for" tabindex="-1">I have a Keyboard that I want to add support for <a class="header-anchor" href="#i-have-a-keyboard-that-i-want-to-add-support-for" aria-label="Permalink to &quot;I have a Keyboard that I want to add support for&quot;">​</a></h2><p>Awesome! Open up a Pull Request for it. We&#39;ll review the code, and merge it!</p><h3 id="what-if-i-want-to-brand-it-with-qmk" tabindex="-1">What if I want to brand it with <code>QMK</code>? <a class="header-anchor" href="#what-if-i-want-to-brand-it-with-qmk" aria-label="Permalink to &quot;What if I want to brand it with `QMK`?&quot;">​</a></h3><p>That&#39;s amazing! We would love to assist you with that!</p><p>In fact, we have a <a href="https://qmk.fm/powered/" target="_blank" rel="noreferrer">whole page</a> dedicated to adding QMK Branding to your page and keyboard. This covers pretty much everything you need (knowledge and images) to officially support QMK.</p><p>If you have any questions about this, open an issue or head to <a href="https://discord.gg/qmk" target="_blank" rel="noreferrer">Discord</a>.</p><h2 id="what-differences-are-there-between-qmk-and-tmk" tabindex="-1">What Differences Are There Between QMK and TMK? <a class="header-anchor" href="#what-differences-are-there-between-qmk-and-tmk" aria-label="Permalink to &quot;What Differences Are There Between QMK and TMK?&quot;">​</a></h2><p>TMK was originally designed and implemented by <a href="https://github.com/tmk" target="_blank" rel="noreferrer">Jun Wako</a>. QMK started as <a href="https://github.com/jackhumbert" target="_blank" rel="noreferrer">Jack Humbert</a>&#39;s fork of TMK for the Planck. After a while Jack&#39;s fork had diverged quite a bit from TMK, and in 2015 Jack decided to rename his fork to QMK.</p><p>From a technical standpoint QMK builds upon TMK by adding several new features. Most notably QMK has expanded the number of available keycodes and uses these to implement advanced features like <code>S()</code>, <code>LCTL()</code>, and <code>MO()</code>. You can see a complete list of these keycodes in <a href="./keycodes">Keycodes</a>.</p><p>From a project and community management standpoint TMK maintains all the officially supported keyboards by himself, with a bit of community support. Separate community maintained forks exist or can be created for other keyboards. Only a few keymaps are provided by default, so users typically don&#39;t share keymaps with each other. QMK encourages sharing of both keyboards and keymaps through a centrally managed repository, accepting all pull requests that follow the quality standards. These are mostly community maintained, but the QMK team also helps when necessary.</p><p>Both approaches have their merits and their drawbacks, and code flows freely between TMK and QMK when it makes sense.</p>', 27);
const _hoisted_28 = [
  _hoisted_1
];
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", null, _hoisted_28);
}
const faq_general = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  __pageData,
  faq_general as default
};
