import { _ as _export_sfc, c as createElementBlock, o as openBlock, a8 as createStaticVNode } from "./chunks/framework.B9AX-CPi.js";
const __pageData = JSON.parse('{"title":"Userspace: Sharing Code Between Keymaps","description":"","frontmatter":{},"headers":[],"relativePath":"feature_userspace.md","filePath":"feature_userspace.md","lastUpdated":null}');
const _sfc_main = { name: "feature_userspace.md" };
const _hoisted_1 = /* @__PURE__ */ createStaticVNode('<h1 id="userspace-sharing-code-between-keymaps" tabindex="-1">Userspace: Sharing Code Between Keymaps <a class="header-anchor" href="#userspace-sharing-code-between-keymaps" aria-label="Permalink to &quot;Userspace: Sharing Code Between Keymaps&quot;">​</a></h1><div class="warning custom-block"><p class="custom-block-title">WARNING</p><p>Please note, userspace submissions to the upstream <code>qmk/qmk_firmware</code> repository are no longer being accepted. The userspace feature itself remains functional and can be configured locally.</p></div><p>If you use more than one keyboard with a similar keymap, you might see the benefit in being able to share code between them. Create your own folder in <code>users/</code> named the same as your keymap (ideally your GitHub username, <code>&lt;name&gt;</code>) with the following structure:</p><ul><li><code>/users/&lt;name&gt;/</code> (added to the path automatically) <ul><li><code>readme.md</code> (optional, recommended)</li><li><code>rules.mk</code> (included automatically)</li><li><code>config.h</code> (included automatically)</li><li><code>&lt;name&gt;.h</code> (optional)</li><li><code>&lt;name&gt;.c</code> (optional)</li><li><code>cool_rgb_stuff.c</code> (optional)</li><li><code>cool_rgb_stuff.h</code> (optional)</li></ul></li></ul><p>All this only happens when you build a keymap named <code>&lt;name&gt;</code>, like this:</p><pre><code>make planck:&lt;name&gt;\n</code></pre><p>For example,</p><pre><code>make planck:jack\n</code></pre><p>Will include the <code>/users/jack/</code> folder in the path, along with <code>/users/jack/rules.mk</code>.</p><div class="warning custom-block"><p class="custom-block-title">WARNING</p><p>This <code>name</code> can be <a href="#override-default-userspace">overridden</a>, if needed.</p></div><h2 id="rules-mk" tabindex="-1"><code>Rules.mk</code> <a class="header-anchor" href="#rules-mk" aria-label="Permalink to &quot;`Rules.mk`&quot;">​</a></h2><p>The <code>rules.mk</code> is one of the two files that gets processed automatically. This is how you add additional source files (such as <code>&lt;name&gt;.c</code>) will be added when compiling.</p><p>It&#39;s highly recommended that you use <code>&lt;name&gt;.c</code> as the default source file to be added. And to add it, you need to add it the SRC in <code>rules.mk</code> like this:</p><pre><code>SRC += &lt;name&gt;.c\n</code></pre><p>Additional files may be added in the same way - it&#39;s recommended you have one named <code>&lt;name&gt;</code>.c/.h to start off with, though.</p><p>The <code>/users/&lt;name&gt;/rules.mk</code> file will be included in the build <em>after</em> the <code>rules.mk</code> from your keymap. This allows you to have features in your userspace <code>rules.mk</code> that depend on individual QMK features that may or may not be available on a specific keyboard.</p><p>For example, if you have RGB control features shared between all your keyboards that support RGB lighting, you can add support for that if the RGBLIGHT feature is enabled:</p><div class="language-make vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">make</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">ifeq</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> (</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">$(</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">strip</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> $(</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">RGBLIGHT_ENABLE</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">))</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, yes)</span></span>\n<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">  # Include my fancy rgb functions source here</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  SRC += cool_rgb_stuff.c</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">endif</span></span></code></pre></div><p>Alternatively, you can <code>define RGB_ENABLE</code> in your keymap&#39;s <code>rules.mk</code> and then check for the variable in your userspace&#39;s <code>rules.mk</code> like this:</p><div class="language-make vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">make</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">ifdef</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> RGB_ENABLE</span></span>\n<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">  # Include my fancy rgb functions source here</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  SRC += cool_rgb_stuff.c</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">endif</span></span></code></pre></div><h3 id="override-default-userspace" tabindex="-1">Override default userspace <a class="header-anchor" href="#override-default-userspace" aria-label="Permalink to &quot;Override default userspace&quot;">​</a></h3><p>By default the userspace used will be the same as the keymap name. In some situations this isn&#39;t desirable. For instance, if you use the <a href="./feature_layouts">layout</a> feature you can&#39;t use the same name for different keymaps (e.g. ANSI and ISO). You can name your layouts <code>mylayout-ansi</code> and <code>mylayout-iso</code> and add the following line to your layout&#39;s <code>rules.mk</code>:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span>USER_NAME := mylayout</span></span></code></pre></div><p>This is also useful if you have multiple different keyboards with different features physically present on the board (such as one with RGB Lights, and one with Audio, or different number of LEDs, or connected to a different PIN on the controller).</p><h2 id="configuration-options-config-h" tabindex="-1">Configuration Options (<code>config.h</code>) <a class="header-anchor" href="#configuration-options-config-h" aria-label="Permalink to &quot;Configuration Options (`config.h`)&quot;">​</a></h2><p>Additionally, <code>config.h</code> here will be processed like the same file in your keymap folder. This is handled separately from the <code>&lt;name&gt;.h</code> file.</p><p>The reason for this, is that <code>&lt;name&gt;.h</code> won&#39;t be added in time to add settings (such as <code>#define TAPPING_TERM 100</code>), and including the <code>&lt;name.h&gt;</code> file in any <code>config.h</code> files will result in compile issues.</p><p>!&gt;You should use the <code>config.h</code> for <a href="./config_options">configuration options</a>, and the <code>&lt;name&gt;.h</code> file for user or keymap specific settings (such as the enum for layer or keycodes)</p><h2 id="readme-readme-md" tabindex="-1">Readme (<code>readme.md</code>) <a class="header-anchor" href="#readme-readme-md" aria-label="Permalink to &quot;Readme (`readme.md`)&quot;">​</a></h2><p>Please include authorship (your name, GitHub username, email), and optionally <a href="https://www.gnu.org/licenses/license-list.html#GPLCompatibleLicenses" target="_blank" rel="noreferrer">a license that&#39;s GPL compatible</a>.</p><p>You can use this as a template:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span>Copyright &lt;year&gt; &lt;name&gt; &lt;email&gt; @&lt;github_username&gt;</span></span>\n<span class="line"><span></span></span>\n<span class="line"><span>This program is free software: you can redistribute it and/or modify</span></span>\n<span class="line"><span>it under the terms of the GNU General Public License as published by</span></span>\n<span class="line"><span>the Free Software Foundation, either version 2 of the License, or</span></span>\n<span class="line"><span>(at your option) any later version.</span></span>\n<span class="line"><span></span></span>\n<span class="line"><span>This program is distributed in the hope that it will be useful,</span></span>\n<span class="line"><span>but WITHOUT ANY WARRANTY; without even the implied warranty of</span></span>\n<span class="line"><span>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span></span>\n<span class="line"><span>GNU General Public License for more details.</span></span>\n<span class="line"><span></span></span>\n<span class="line"><span>You should have received a copy of the GNU General Public License</span></span>\n<span class="line"><span>along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.</span></span></code></pre></div><p>You&#39;d want to replace the year, name, email and GitHub username with your info.</p><p>Additionally, this is a good place to document your code, if you wish to share it with others.</p><h2 id="build-all-keyboards-that-support-a-specific-keymap" tabindex="-1">Build All Keyboards That Support a Specific Keymap <a class="header-anchor" href="#build-all-keyboards-that-support-a-specific-keymap" aria-label="Permalink to &quot;Build All Keyboards That Support a Specific Keymap&quot;">​</a></h2><p>Want to check all your keymaps build in a single command? You can run:</p><pre><code>make all:&lt;name&gt;\n</code></pre><p>For example,</p><pre><code>make all:jack\n</code></pre><p>This is ideal for when you want ensure everything compiles successfully when preparing a <a href="https://github.com/qmk/qmk_firmware/pulls" target="_blank" rel="noreferrer"><em>Pull request</em></a>.</p><h2 id="examples" tabindex="-1">Examples <a class="header-anchor" href="#examples" aria-label="Permalink to &quot;Examples&quot;">​</a></h2><p>For a brief example, checkout <a href="https://github.com/qmk/qmk_firmware/tree/master/users/_example" target="_blank" rel="noreferrer"><code>/users/_example/</code></a>.<br> For a more complicated example, checkout <a href="https://github.com/qmk/qmk_firmware/tree/master/users/drashna" target="_blank" rel="noreferrer"><code>/users/drashna/</code></a>&#39;s userspace.</p><h3 id="customized-functions" tabindex="-1">Customized Functions <a class="header-anchor" href="#customized-functions" aria-label="Permalink to &quot;Customized Functions&quot;">​</a></h3><p>QMK has a bunch of <a href="./custom_quantum_functions">functions</a> that have <a href="./custom_quantum_functions#a-word-on-core-vs-keyboards-vs-keymap"><code>_quantum</code>, <code>_kb</code>, and <code>_user</code> versions</a> that you can use. You will pretty much always want to use the user version of these functions. But the problem is that if you use them in your userspace, then you don&#39;t have a version that you can use in your keymap.</p><p>However, you can actually add support for keymap version, so that you can use it in both your userspace and your keymap!</p><p>For instance, let&#39;s look at the <code>layer_state_set_user()</code> function. You can enable the <a href="./ref_functions#olkb-tri-layers">Tri Layer State</a> functionality on all of your boards, while also retaining the Tri Layer functionality in your <code>keymap.c</code> files.</p><p>In your <code>&lt;name.c&gt;</code> file, you&#39;d want to add this:</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">__attribute__</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> ((weak))</span></span>\n<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">layer_state_t</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> layer_state_set_keymap</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> (</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">layer_state_t</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;"> state</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">) {</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  return</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> state;</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span>\n<span class="line"></span>\n<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">layer_state_t</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> layer_state_set_user</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> (</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">layer_state_t</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;"> state</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">) {</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  state </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> update_tri_layer_state</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(state, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">2</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">3</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">5</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">);</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  return</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> layer_state_set_keymap</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> (state);</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><p>The <code>__attribute__ ((weak))</code> part tells the compiler that this is a placeholder function that can then be replaced by a version in your <code>keymap.c</code>. That way, you don&#39;t need to add it to your <code>keymap.c</code>, but if you do, you won&#39;t get any conflicts because the function is the same name.</p><p>The <code>_keymap</code> part here doesn&#39;t matter, it just needs to be something other than <code>_quantum</code>, <code>_kb</code>, or <code>_user</code>, since those are already in use. So you could use <code>layer_state_set_mine</code>, <code>layer_state_set_fn</code>, or anything else.</p><p>You can see a list of this and other common functions in <a href="https://github.com/qmk/qmk_firmware/blob/master/users/drashna/template.c" target="_blank" rel="noreferrer"><code>template.c</code></a> in <a href="https://github.com/qmk/qmk_firmware/tree/master/users/drashna" target="_blank" rel="noreferrer"><code>users/drashna</code></a>.</p><h3 id="custom-features" tabindex="-1">Custom Features <a class="header-anchor" href="#custom-features" aria-label="Permalink to &quot;Custom Features&quot;">​</a></h3><p>Since the Userspace feature can support a staggering number of boards, you may have boards that you want to enable certain functionality for, but not for others. And you can actually create &quot;features&quot; that you can enable or disable in your own userspace.</p><p>For instance, if you wanted to have a bunch of macros available, but only on certain boards (to save space), you could &quot;hide&quot; them being a <code>#ifdef MACROS_ENABLED</code>, and then enable it per board. To do this, add this to your rules.mk</p><div class="language-make vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">make</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">ifeq</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> (</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">$(</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">strip</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> $(</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">MACROS_ENABLED</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">))</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, yes)</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    OPT_DEFS += -DMACROS_ENABLED</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">endif</span></span></code></pre></div><p>The <code>OPT_DEFS</code> setting causes <code>MACROS_ENABLED</code> to be defined for your keyboards (note the <code>-D</code> in front of the name), and you could use <code>#ifdef MACROS_ENABLED</code> to check the status in your c/h files, and handle that code based on that.</p><p>Then you add <code>MACROS_ENABLED = yes</code> to the <code>rules.mk</code> for you keymap to enable this feature and the code in your userspace.</p><p>And in your <code>process_record_user</code> function, you&#39;d do something like this:</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">bool</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> process_record_user</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">uint16_t</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;"> keycode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">keyrecord_t</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;"> *</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;">record</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">) {</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  switch</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> (keycode) {</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#ifdef</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> MACROS_ENABLED</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  case MACRO1:</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">    if</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> (</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">!</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">record</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">-&gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">event.pressed) {</span></span>\n<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">      SEND_STRING</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;This is macro 1!&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">);</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    }</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">    break</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">;</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  case MACRO2:</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">    if</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> (</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">!</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">record</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">-&gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">event.pressed) {</span></span>\n<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">      SEND_STRING</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;This is macro 2!&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">);</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    }</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">    break</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">;</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#endif</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  }</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  return</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> true</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">;</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><h3 id="consolidated-macros" tabindex="-1">Consolidated Macros <a class="header-anchor" href="#consolidated-macros" aria-label="Permalink to &quot;Consolidated Macros&quot;">​</a></h3><p>If you wanted to consolidate macros and other functions into your userspace for all of your keymaps, you can do that. This builds upon the <a href="#customized-functions">Customized Functions</a> example above. This lets you maintain a bunch of macros that are shared between the different keyboards, and allow for keyboard specific macros, too.</p><p>First, you&#39;d want to go through all of your <code>keymap.c</code> files and replace <code>process_record_user</code> with <code>process_record_keymap</code> instead. This way, you can still use keyboard specific codes on those boards, and use your custom &quot;global&quot; keycodes as well. You&#39;ll also want to replace <code>SAFE_RANGE</code> with <code>NEW_SAFE_RANGE</code> so that you wont have any overlapping keycodes</p><p>Then add <code>#include &quot;&lt;name&gt;.h&quot;</code> to all of your keymap.c files. This allows you to use these new keycodes without having to redefine them in each keymap.</p><p>Once you&#39;ve done that, you&#39;ll want to set the keycode definitions that you need to the <code>&lt;name&gt;.h</code> file. For instance:</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#pragma</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> once</span></span>\n<span class="line"></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#include</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> &quot;quantum.h&quot;</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#include</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> &quot;action.h&quot;</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#include</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> &quot;version.h&quot;</span></span>\n<span class="line"></span>\n<span class="line"><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">// Define all of</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">enum</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> custom_keycodes {</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  KC_MAKE </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> SAFE_RANGE,</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  NEW_SAFE_RANGE</span><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">  //use &quot;NEW_SAFE_RANGE&quot; for keymap specific codes</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">};</span></span></code></pre></div><p>Now you want to create the <code>&lt;name&gt;.c</code> file, and add this content to it:</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#include</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> &quot;&lt;name&gt;.h&quot;</span></span>\n<span class="line"></span>\n<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">__attribute__</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> ((weak))</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">bool</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> process_record_keymap</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">uint16_t</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;"> keycode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">keyrecord_t</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;"> *</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;">record</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">) {</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  return</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> true</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">;</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span>\n<span class="line"></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">bool</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> process_record_user</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">uint16_t</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;"> keycode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">keyrecord_t</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;"> *</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;">record</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">) {</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  switch</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> (keycode) {</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">    case</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> KC_MAKE:</span><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;">  // Compiles the firmware, and adds the flash command based on keyboard bootloader</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">            if</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> (</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">!</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">record</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">-&gt;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">event.pressed) {</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">            uint8_t</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> temp_mod </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> get_mods</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">();</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">            uint8_t</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> temp_osm </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> get_oneshot_mods</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">();</span></span>\n<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">            clear_mods</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(); </span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">clear_oneshot_mods</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">();</span></span>\n<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">            SEND_STRING</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;make &quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> QMK_KEYBOARD </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;:&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> QMK_KEYMAP);</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">    #ifndef</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> FLASH_BOOTLOADER</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">            if</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> ((temp_mod </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">|</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> temp_osm) </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">&amp;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> MOD_MASK_SHIFT)</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">    #endif</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">            {</span></span>\n<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">                SEND_STRING</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;:flash&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">);</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">            }</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">            if</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> ((temp_mod </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">|</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> temp_osm) </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">&amp;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> MOD_MASK_CTRL) {</span></span>\n<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">                SEND_STRING</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot; -j8 --output-sync&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">);</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">            }</span></span>\n<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">            tap_code</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(KC_ENT);</span></span>\n<span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">            set_mods</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(temp_mod);</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">        }</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">        break</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">;</span></span>\n<span class="line"></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  }</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  return</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> process_record_keymap</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(keycode, record);</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><p>For boards that may not have a shift button (such as on a macro pad), we need a way to always include the bootloader option. To do that, add the following to the <code>rules.mk</code> in your userspace folder:</p><div class="language-make vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">make</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">ifeq</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> (</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">$(</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">strip</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;"> $(</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">FLASH_BOOTLOADER</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">))</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, yes)</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    OPT_DEFS += -DFLASH_BOOTLOADER</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">endif</span></span></code></pre></div><p>This will add a new <code>KC_MAKE</code> keycode that can be used in any of your keymaps. And this keycode will output <code>make &lt;keyboard&gt;:&lt;keymap&gt;</code>, making frequent compiling easier. And this will work with any keyboard and any keymap as it will output the current boards info, so that you don&#39;t have to type this out every time.</p><p>Also, holding Shift will add the flash target (<code>:flash</code>) to the command. Holding Control will add some commands that will speed up compiling time by processing multiple files at once.</p><p>And for the boards that lack a shift key, or that you want to always attempt the flashing part, you can add <code>FLASH_BOOTLOADER = yes</code> to the <code>rules.mk</code> of that keymap.</p><div class="tip custom-block"><p class="custom-block-title">TIP</p><p>This should flash the newly compiled firmware automatically, using the correct utility, based on the bootloader settings (or default to just generating the HEX file). However, it should be noted that this may not work on all systems. AVRDUDE doesn&#39;t work on WSL, namely.</p></div>', 73);
const _hoisted_74 = [
  _hoisted_1
];
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", null, _hoisted_74);
}
const feature_userspace = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  __pageData,
  feature_userspace as default
};
