import { _ as _export_sfc, c as createElementBlock, o as openBlock, a8 as createStaticVNode } from "./chunks/framework.B9AX-CPi.js";
const __pageData = JSON.parse('{"title":"Audio","description":"","frontmatter":{},"headers":[],"relativePath":"features/audio.md","filePath":"features/audio.md","lastUpdated":null}');
const _sfc_main = { name: "features/audio.md" };
const _hoisted_1 = /* @__PURE__ */ createStaticVNode('<h1 id="audio" tabindex="-1">Audio <a class="header-anchor" href="#audio" aria-label="Permalink to &quot;Audio&quot;">​</a></h1><p>Your keyboard can make sounds! If you&#39;ve got a spare pin you can hook up a simple speaker and make it beep. You can use those beeps to indicate layer transitions, modifiers, special keys, or just to play some funky 8bit tunes.</p><p>To activate this feature, add <code>AUDIO_ENABLE = yes</code> to your <code>rules.mk</code>.</p><h2 id="avr-based-boards" tabindex="-1">AVR based boards <a class="header-anchor" href="#avr-based-boards" aria-label="Permalink to &quot;AVR based boards&quot;">​</a></h2><p>On Atmega32U4 based boards, up to two simultaneous tones can be rendered. With one speaker connected to a PWM capable pin on PORTC driven by timer 3 and the other on one of the PWM pins on PORTB driven by timer 1.</p><p>The following pins can be configured as audio outputs in <code>config.h</code> - for one speaker set either one out of:</p><ul><li><code>#define AUDIO_PIN C4</code></li><li><code>#define AUDIO_PIN C5</code></li><li><code>#define AUDIO_PIN C6</code></li><li><code>#define AUDIO_PIN B5</code></li><li><code>#define AUDIO_PIN B6</code></li><li><code>#define AUDIO_PIN B7</code></li></ul><p>and <em>optionally</em>, for a second speaker, one of:</p><ul><li><code>#define AUDIO_PIN_ALT B5</code></li><li><code>#define AUDIO_PIN_ALT B6</code></li><li><code>#define AUDIO_PIN_ALT B7</code></li></ul><h3 id="wiring" tabindex="-1">Wiring <a class="header-anchor" href="#wiring" aria-label="Permalink to &quot;Wiring&quot;">​</a></h3><p>per speaker is - for example with a piezo buzzer - the black lead to Ground, and the red lead connected to the selected AUDIO_PIN for the primary; and similarly with AUDIO_PIN_ALT for the secondary.</p><h2 id="arm-based-boards" tabindex="-1">ARM based boards <a class="header-anchor" href="#arm-based-boards" aria-label="Permalink to &quot;ARM based boards&quot;">​</a></h2><p>for more technical details, see the notes on <a href="./../drivers/audio">Audio driver</a>.</p><h3 id="dac-basic" tabindex="-1">DAC (basic) <a class="header-anchor" href="#dac-basic" aria-label="Permalink to &quot;DAC (basic)&quot;">​</a></h3><p>Most STM32 MCUs have DAC peripherals, with a notable exception of the STM32F1xx series. Generally, the DAC peripheral drives pins A4 or A5. To enable DAC-based audio output on STM32 devices, add <code>AUDIO_DRIVER = dac_basic</code> to <code>rules.mk</code> and set in <code>config.h</code> either:</p><p><code>#define AUDIO_PIN A4</code> or <code>#define AUDIO_PIN A5</code></p><p>the other DAC channel can optionally be used with a secondary speaker, just set:</p><p><code>#define AUDIO_PIN_ALT A4</code> or <code>#define AUDIO_PIN_ALT A5</code></p><p>Do note though that the dac_basic driver is only capable of reproducing one tone per speaker/channel at a time, for more tones simultaneously, try the dac_additive driver.</p><h4 id="wiring-1" tabindex="-1">Wiring: <a class="header-anchor" href="#wiring-1" aria-label="Permalink to &quot;Wiring:&quot;">​</a></h4><p>for two piezos, for example configured as <code>AUDIO_PIN A4</code> and <code>AUDIO_PIN_ALT A5</code> would be: red lead to A4 and black to Ground, and similarly with the second one: A5 = red, and Ground = black</p><p>another alternative is to drive <em>one</em> piezo with both DAC pins - for an extra &quot;push&quot;. wiring red to A4 and black to A5 (or the other way round) and add <code>#define AUDIO_PIN_ALT_AS_NEGATIVE</code> to <code>config.h</code></p><h5 id="proton-c-example" tabindex="-1">Proton-C Example: <a class="header-anchor" href="#proton-c-example" aria-label="Permalink to &quot;Proton-C Example:&quot;">​</a></h5><p>The Proton-C comes (optionally) with one &#39;builtin&#39; piezo, which is wired to A4+A5. For this board <code>config.h</code> would include these defines:</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#define</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> AUDIO_PIN</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> A5</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#define</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> AUDIO_PIN_ALT</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> A4</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#define</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> AUDIO_PIN_ALT_AS_NEGATIVE</span></span></code></pre></div><h3 id="dac-additive" tabindex="-1">DAC (additive) <a class="header-anchor" href="#dac-additive" aria-label="Permalink to &quot;DAC (additive)&quot;">​</a></h3><p>Another option, besides dac_basic (which produces sound through a square-wave), is to use the DAC to do additive wave synthesis. With a number of predefined wave-forms or by providing your own implementation to generate samples on the fly. To use this feature set <code>AUDIO_DRIVER = dac_additive</code> in your <code>rules.mk</code>, and select in <code>config.h</code> EITHER <code>#define AUDIO_PIN A4</code> or <code>#define AUDIO_PIN A5</code>.</p><p>The used waveform <em>defaults</em> to sine, but others can be selected by adding one of the following defines to <code>config.h</code>:</p><ul><li><code>#define AUDIO_DAC_SAMPLE_WAVEFORM_SINE</code></li><li><code>#define AUDIO_DAC_SAMPLE_WAVEFORM_TRIANGLE</code></li><li><code>#define AUDIO_DAC_SAMPLE_WAVEFORM_TRAPEZOID</code></li><li><code>#define AUDIO_DAC_SAMPLE_WAVEFORM_SQUARE</code></li></ul><p>Should you rather choose to generate and use your own sample-table with the DAC unit, implement <code>uint16_t dac_value_generate(void)</code> with your keyboard - for an example implementation see keyboards/planck/keymaps/synth_sample or keyboards/planck/keymaps/synth_wavetable</p><h3 id="pwm-software" tabindex="-1">PWM (software) <a class="header-anchor" href="#pwm-software" aria-label="Permalink to &quot;PWM (software)&quot;">​</a></h3><p>if the DAC pins are unavailable (or the MCU has no usable DAC at all, like STM32F1xx); PWM can be an alternative. Note that there is currently only one speaker/pin supported.</p><p>set in <code>rules.mk</code>:</p><p><code>AUDIO_DRIVER = pwm_software</code> and in <code>config.h</code>: <code>#define AUDIO_PIN C13</code> (can be any pin) to have the selected pin output a pwm signal, generated from a timer callback which toggles the pin in software.</p><h4 id="wiring-2" tabindex="-1">Wiring <a class="header-anchor" href="#wiring-2" aria-label="Permalink to &quot;Wiring&quot;">​</a></h4><p>the usual piezo wiring: red goes to the selected AUDIO_PIN, black goes to ground.</p><p>OR if you can chose to drive one piezo with two pins, for example <code>#define AUDIO_PIN B1</code>, <code>#define AUDIO_PIN_ALT B2</code> in <code>config.h</code>, with <code>#define AUDIO_PIN_ALT_AS_NEGATIVE</code> - then the red lead could go to B1, the black to B2.</p><h3 id="pwm-hardware" tabindex="-1">PWM (hardware) <a class="header-anchor" href="#pwm-hardware" aria-label="Permalink to &quot;PWM (hardware)&quot;">​</a></h3><p>STM32F1xx have to fall back to using PWM, but can do so in hardware; but again on currently only one speaker/pin.</p><p><code>AUDIO_DRIVER = pwm_hardware</code> in <code>rules.mk</code>, and in <code>config.h</code>: <code>#define AUDIO_PIN A8</code><code>#define AUDIO_PWM_DRIVER PWMD1</code><code>#define AUDIO_PWM_CHANNEL 1</code> (as well as <code>#define AUDIO_PWM_PAL_MODE 42</code> if you are on STM32F2 or larger) which will use Timer 1 to directly drive pin PA8 through the PWM hardware (TIM1_CH1 = PA8). Should you want to use the pwm-hardware on another pin and timer - be ready to dig into the STM32 data-sheet to pick the right TIMx_CHy and pin-alternate function.</p><h2 id="tone-multiplexing" tabindex="-1">Tone Multiplexing <a class="header-anchor" href="#tone-multiplexing" aria-label="Permalink to &quot;Tone Multiplexing&quot;">​</a></h2><p>Since most drivers can only render one tone per speaker at a time (with the one exception: arm dac-additive) there also exists a &quot;workaround-feature&quot; that does time-slicing/multiplexing - which does what the name implies: cycle through a set of active tones (e.g. when playing chords in Music Mode) at a given rate, and put one tone at a time out through the one/few speakers that are available.</p><p>To enable this feature, and configure a starting-rate, add the following defines to <code>config.h</code>:</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#define</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> AUDIO_ENABLE_TONE_MULTIPLEXING</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#define</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> AUDIO_TONE_MULTIPLEXING_RATE_DEFAULT</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> 10</span></span></code></pre></div><p>The audio core offers interface functions to get/set/change the tone multiplexing rate from within <code>keymap.c</code>.</p><h2 id="songs" tabindex="-1">Songs <a class="header-anchor" href="#songs" aria-label="Permalink to &quot;Songs&quot;">​</a></h2><p>There&#39;s a couple of different sounds that will automatically be enabled without any other configuration:</p><div class="language- vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang"></span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span>STARTUP_SONG // plays when the keyboard starts up (audio.c)</span></span>\n<span class="line"><span>GOODBYE_SONG // plays when you press the QK_BOOT key (quantum.c)</span></span>\n<span class="line"><span>AG_NORM_SONG // plays when you press AG_NORM (quantum.c)</span></span>\n<span class="line"><span>AG_SWAP_SONG // plays when you press AG_SWAP (quantum.c)</span></span>\n<span class="line"><span>CG_NORM_SONG // plays when you press CG_NORM (quantum.c)</span></span>\n<span class="line"><span>CG_SWAP_SONG // plays when you press CG_SWAP (quantum.c)</span></span>\n<span class="line"><span>MUSIC_ON_SONG // plays when music mode is activated (process_music.c)</span></span>\n<span class="line"><span>MUSIC_OFF_SONG // plays when music mode is deactivated (process_music.c)</span></span>\n<span class="line"><span>CHROMATIC_SONG // plays when the chromatic music mode is selected (process_music.c)</span></span>\n<span class="line"><span>GUITAR_SONG // plays when the guitar music mode is selected (process_music.c)</span></span>\n<span class="line"><span>VIOLIN_SONG // plays when the violin music mode is selected (process_music.c)</span></span>\n<span class="line"><span>MAJOR_SONG // plays when the major music mode is selected (process_music.c)</span></span></code></pre></div><p>You can override the default songs by doing something like this in your <code>config.h</code>:</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#ifdef</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> AUDIO_ENABLE</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;"># define</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> STARTUP_SONG</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> SONG</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(STARTUP_SOUND)</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#endif</span></span></code></pre></div><p>A full list of sounds can be found in <a href="https://github.com/qmk/qmk_firmware/blob/master/quantum/audio/song_list.h" target="_blank" rel="noreferrer">quantum/audio/song_list.h</a> - feel free to add your own to this list! All available notes can be seen in <a href="https://github.com/qmk/qmk_firmware/blob/master/quantum/audio/musical_notes.h" target="_blank" rel="noreferrer">quantum/audio/musical_notes.h</a>.</p><p>Additionally, if you with to maintain your own list of songs (such as ones that may be copyrighted) and not have them added to the repo, you can create a <code>user_song_list.h</code> file and place it in your keymap (or userspace) folder. This file will be automatically included, it just needs to exist.</p><p>To play a custom sound at a particular time, you can define a song like this (near the top of the file):</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">float</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> my_song</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">[]</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">[</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">2</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">] </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> SONG</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(QWERTY_SOUND);</span></span></code></pre></div><p>And then play your song like this:</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">PLAY_SONG</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(my_song);</span></span></code></pre></div><p>Alternatively, you can play it in a loop like this:</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">PLAY_LOOP</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(my_song);</span></span></code></pre></div><p>It&#39;s advised that you wrap all audio features in <code>#ifdef AUDIO_ENABLE</code> / <code>#endif</code> to avoid causing problems when audio isn&#39;t built into the keyboard.</p><p>The available keycodes for audio are:</p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_AUDIO_ON</code></td><td><code>AU_ON</code></td><td>Turns on Audio Feature</td></tr><tr><td><code>QK_AUDIO_OFF</code></td><td><code>AU_OFF</code></td><td>Turns off Audio Feature</td></tr><tr><td><code>QK_AUDIO_TOGGLE</code></td><td><code>AU_TOGG</code></td><td>Toggles Audio state</td></tr></tbody></table><div class="warning custom-block"><p class="custom-block-title">WARNING</p><p>These keycodes turn all of the audio functionality on and off. Turning it off means that audio feedback, audio clicky, music mode, etc. are disabled, completely.</p></div><h2 id="audio-config" tabindex="-1">Audio Config <a class="header-anchor" href="#audio-config" aria-label="Permalink to &quot;Audio Config&quot;">​</a></h2><table><thead><tr><th>Settings</th><th>Default</th><th>Description</th></tr></thead><tbody><tr><td><code>AUDIO_PIN</code></td><td><em>Not defined</em></td><td>Configures the pin that the speaker is connected to.</td></tr><tr><td><code>AUDIO_PIN_ALT</code></td><td><em>Not defined</em></td><td>Configures the pin for a second speaker or second pin connected to one speaker.</td></tr><tr><td><code>AUDIO_PIN_ALT_AS_NEGATIVE</code></td><td><em>Not defined</em></td><td>Enables support for one speaker connected to two pins.</td></tr><tr><td><code>AUDIO_INIT_DELAY</code></td><td><em>Not defined</em></td><td>Enables delay during startup song to accomidate for USB startup issues.</td></tr><tr><td><code>AUDIO_ENABLE_TONE_MULTIPLEXING</code></td><td><em>Not defined</em></td><td>Enables time splicing/multiplexing to create multiple tones simutaneously.</td></tr><tr><td><code>AUDIO_POWER_CONTROL_PIN</code></td><td><em>Not defined</em></td><td>Enables power control code to enable or cut off power to speaker (such as with PAM8302 amp).</td></tr><tr><td><code>AUDIO_POWER_CONTROL_PIN_ON_STATE</code></td><td><code>1</code></td><td>The state of the audio power control pin when audio is &quot;on&quot; - <code>1</code> for high, <code>0</code> for low.</td></tr><tr><td><code>STARTUP_SONG</code></td><td><code>STARTUP_SOUND</code></td><td>Plays when the keyboard starts up (audio.c)</td></tr><tr><td><code>GOODBYE_SONG</code></td><td><code>GOODBYE_SOUND</code></td><td>Plays when you press the QK_BOOT key (quantum.c)</td></tr><tr><td><code>AG_NORM_SONG</code></td><td><code>AG_NORM_SOUND</code></td><td>Plays when you press AG_NORM (process_magic.c)</td></tr><tr><td><code>AG_SWAP_SONG</code></td><td><code>AG_SWAP_SOUND</code></td><td>Plays when you press AG_SWAP (process_magic.c)</td></tr><tr><td><code>CG_NORM_SONG</code></td><td><code>AG_NORM_SOUND</code></td><td>Plays when you press CG_NORM (process_magic.c)</td></tr><tr><td><code>CG_SWAP_SONG</code></td><td><code>AG_SWAP_SOUND</code></td><td>Plays when you press CG_SWAP (process_magic.c)</td></tr><tr><td><code>MUSIC_ON_SONG</code></td><td><code>MUSIC_ON_SOUND</code></td><td>Plays when music mode is activated (process_music.c)</td></tr><tr><td><code>MUSIC_OFF_SONG</code></td><td><code>MUSIC_OFF_SOUND</code></td><td>Plays when music mode is deactivated (process_music.c)</td></tr><tr><td><code>MIDI_ON_SONG</code></td><td><code>MUSIC_ON_SOUND</code></td><td>Plays when midi mode is activated (process_music.c)</td></tr><tr><td><code>MIDI_OFF_SONG</code></td><td><code>MUSIC_OFF_SOUND</code></td><td>Plays when midi mode is deactivated (process_music.c)</td></tr><tr><td><code>CHROMATIC_SONG</code></td><td><code>CHROMATIC_SOUND</code></td><td>Plays when the chromatic music mode is selected (process_music.c)</td></tr><tr><td><code>GUITAR_SONG</code></td><td><code>GUITAR_SOUND</code></td><td>Plays when the guitar music mode is selected (process_music.c)</td></tr><tr><td><code>VIOLIN_SONG</code></td><td><code>VIOLIN_SOUND</code></td><td>Plays when the violin music mode is selected (process_music.c)</td></tr><tr><td><code>MAJOR_SONG</code></td><td><code>MAJOR_SOUND</code></td><td>Plays when the major music mode is selected (process_music.c)</td></tr><tr><td><code>DEFAULT_LAYER_SONGS</code></td><td><em>Not defined</em></td><td>Plays song when switched default layers with <a href="./../ref_functions#setting-the-persistent-default-layer"><code>set_single_persistent_default_layer(layer)</code></a>(quantum.c).</td></tr><tr><td><code>SENDSTRING_BELL</code></td><td><em>Not defined</em></td><td>Plays chime when the &quot;enter&quot; (&quot;\\a&quot;) character is sent (send_string.c)</td></tr></tbody></table><h2 id="tempo" tabindex="-1">Tempo <a class="header-anchor" href="#tempo" aria-label="Permalink to &quot;Tempo&quot;">​</a></h2><p>the &#39;speed&#39; at which SONGs are played is dictated by the set Tempo, which is measured in beats-per-minute. Note lengths are defined relative to that. The initial/default tempo is set to 120 bpm, but can be configured by setting <code>TEMPO_DEFAULT</code> in <code>config.c</code>. There is also a set of functions to modify the tempo from within the user/keymap code:</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">void</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> audio_set_tempo</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">uint8_t</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;"> tempo</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">);</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">void</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> audio_increase_tempo</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">uint8_t</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;"> tempo_change</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">);</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">void</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> audio_decrease_tempo</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">uint8_t</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;"> tempo_change</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">);</span></span></code></pre></div><h2 id="arm-audio-volume" tabindex="-1">ARM Audio Volume <a class="header-anchor" href="#arm-audio-volume" aria-label="Permalink to &quot;ARM Audio Volume&quot;">​</a></h2><p>For ARM devices, you can adjust the DAC sample values. If your board is too loud for you or your coworkers, you can set the max using <code>AUDIO_DAC_SAMPLE_MAX</code> in your <code>config.h</code>:</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#define</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> AUDIO_DAC_SAMPLE_MAX</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> 4095</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">U</span></span></code></pre></div><p>the DAC usually runs in 12Bit mode, hence a volume of 100% = 4095U</p><p>Note: this only adjusts the volume aka &#39;works&#39; if you stick to WAVEFORM_SQUARE, since its samples are generated on the fly - any other waveform uses a hardcoded/precomputed sample-buffer.</p><h2 id="voices" tabindex="-1">Voices <a class="header-anchor" href="#voices" aria-label="Permalink to &quot;Voices&quot;">​</a></h2><p>Aka &quot;audio effects&quot;, different ones can be enabled by setting in <code>config.h</code> these defines: <code>#define AUDIO_VOICES</code> to enable the feature, and <code>#define AUDIO_VOICE_DEFAULT something</code> to select a specific effect for details see quantum/audio/voices.h and .c</p><p>Keycodes available:</p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_AUDIO_VOICE_NEXT</code></td><td><code>AU_NEXT</code></td><td>Cycles through the audio voices</td></tr><tr><td><code>QK_AUDIO_VOICE_PREVIOUS</code></td><td><code>AU_PREV</code></td><td>Cycles through the audio voices in reverse</td></tr></tbody></table><h2 id="music-mode" tabindex="-1">Music Mode <a class="header-anchor" href="#music-mode" aria-label="Permalink to &quot;Music Mode&quot;">​</a></h2><p>The music mode maps your columns to a chromatic scale, and your rows to octaves. This works best with ortholinear keyboards, but can be made to work with others. All keycodes less than <code>0xFF</code> get blocked, so you won&#39;t type while playing notes - if you have special keys/mods, those will still work. A work-around for this is to jump to a different layer with KC_NOs before (or after) enabling music mode.</p><p>Recording is experimental due to some memory issues - if you experience some weird behavior, unplugging/replugging your keyboard will fix things.</p><p>Keycodes available:</p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_MUSIC_ON</code></td><td><code>MU_ON</code></td><td>Turns on Music Mode</td></tr><tr><td><code>QK_MUSIC_OFF</code></td><td><code>MU_OFF</code></td><td>Turns off Music Mode</td></tr><tr><td><code>QK_MUSIC_TOGGLE</code></td><td><code>MU_TOGG</code></td><td>Toggles Music Mode</td></tr><tr><td><code>QK_MUSIC_MODE_NEXT</code></td><td><code>MU_NEXT</code></td><td>Cycles through the music modes</td></tr></tbody></table><p>Available Modes:</p><ul><li><code>CHROMATIC_MODE</code> - Chromatic scale, row changes the octave</li><li><code>GUITAR_MODE</code> - Chromatic scale, but the row changes the string (+5 st)</li><li><code>VIOLIN_MODE</code> - Chromatic scale, but the row changes the string (+7 st)</li><li><code>MAJOR_MODE</code> - Major scale</li></ul><p>In music mode, the following keycodes work differently, and don&#39;t pass through:</p><ul><li><code>LCTL</code> - start a recording</li><li><code>LALT</code> - stop recording/stop playing</li><li><code>LGUI</code> - play recording</li><li><code>KC_UP</code> - speed-up playback</li><li><code>KC_DOWN</code> - slow-down playback</li></ul><p>The pitch standard (<code>PITCH_STANDARD_A</code>) is 440.0f by default - to change this, add something like this to your <code>config.h</code>:</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#define</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> PITCH_STANDARD_A</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> 432.0</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">f</span></span></code></pre></div><p>You can completely disable Music Mode as well. This is useful, if you&#39;re pressed for space on your controller. To disable it, add this to your <code>config.h</code>:</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#define</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> NO_MUSIC_MODE</span></span></code></pre></div><h3 id="music-mask" tabindex="-1">Music Mask <a class="header-anchor" href="#music-mask" aria-label="Permalink to &quot;Music Mask&quot;">​</a></h3><p>By default, <code>MUSIC_MASK</code> is set to <code>keycode &lt; 0xFF</code> which means keycodes less than <code>0xFF</code> are turned into notes, and don&#39;t output anything. You can change this by defining this in your <code>config.h</code> like this:</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#define</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> MUSIC_MASK</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> keycode </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">!=</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> KC_NO</span></span></code></pre></div><p>Which will capture all keycodes - be careful, this will get you stuck in music mode until you restart your keyboard!</p><p>For a more advanced way to control which keycodes should still be processed, you can use <code>music_mask_kb(keycode)</code> in <code>&lt;keyboard&gt;.c</code> and <code>music_mask_user(keycode)</code> in your <code>keymap.c</code>:</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">  bool</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> music_mask_user</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">uint16_t</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;"> keycode</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">) {</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">    switch</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> (keycode) {</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">      case</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> RAISE:</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">      case</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;"> LOWER:</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">        return</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> false</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">;</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">      default</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">:</span></span>\n<span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">        return</span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;"> true</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">;</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">    }</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  }</span></span></code></pre></div><p>Things that return false are not part of the mask, and are always processed.</p><h3 id="music-map" tabindex="-1">Music Map <a class="header-anchor" href="#music-map" aria-label="Permalink to &quot;Music Map&quot;">​</a></h3><p>By default, the Music Mode uses the columns and row to determine the scale for the keys. For a board that uses a rectangular matrix that matches the keyboard layout, this is just fine. However, for boards that use a more complicated matrix (such as the Planck Rev6, or many split keyboards) this would result in a very skewed experience.</p><p>However, the Music Map option allows you to remap the scaling for the music mode, so it fits the layout, and is more natural.</p><p>To enable this feature, add <code>#define MUSIC_MAP</code> to your <code>config.h</code> file, and then you will want to add a <code>uint8_t music_map</code> to your keyboard&#39;s <code>c</code> file, or your <code>keymap.c</code>.</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">const</span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;"> uint8_t</span><span style="--shiki-light:#E36209;--shiki-dark:#FFAB70;"> music_map</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">[MATRIX_ROWS][MATRIX_COLS] </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">=</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> LAYOUT_ortho_4x12</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(</span></span>\n<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">	36</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">37</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">38</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">39</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">40</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">41</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">42</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">43</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">44</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">45</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">46</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">47</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>\n<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">	24</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">25</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">26</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">27</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">28</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">29</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">30</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">31</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">32</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">33</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">34</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">35</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>\n<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">	12</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">13</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">14</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">15</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">16</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">17</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">18</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">19</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">20</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">21</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">22</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">23</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,</span></span>\n<span class="line"><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">	 0</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,  </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">1</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,  </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">2</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,  </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">3</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,  </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">4</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,  </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">5</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,  </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">6</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,  </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">7</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,  </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">8</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">,  </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">9</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">10</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#005CC5;--shiki-dark:#79B8FF;">11</span></span>\n<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">);</span></span></code></pre></div><p>You will want to use whichever <code>LAYOUT</code> macro that your keyboard uses here. This maps it to the correct key location. Start in the bottom left of the keyboard layout, and move to the right, and then upwards. Fill in all the entries until you have a complete matrix.</p><p>You can look at the <a href="https://github.com/qmk/qmk_firmware/blob/e9ace1487887c1f8b4a7e8e6d87c322988bec9ce/keyboards/planck/planck.c#L24-L29" target="_blank" rel="noreferrer">Planck Keyboard</a> as an example of how to implement this.</p><h2 id="audio-click" tabindex="-1">Audio Click <a class="header-anchor" href="#audio-click" aria-label="Permalink to &quot;Audio Click&quot;">​</a></h2><p>This adds a click sound each time you hit a button, to simulate click sounds from the keyboard. And the sounds are slightly different for each keypress, so it doesn&#39;t sound like a single long note, if you type rapidly.</p><p>Keycodes available:</p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_AUDIO_CLICKY_TOGGLE</code></td><td><code>CK_TOGG</code></td><td>Toggles Audio clicky mode</td></tr><tr><td><code>QK_AUDIO_CLICKY_ON</code></td><td><code>CK_ON</code></td><td>Turns on Audio clicky mode</td></tr><tr><td><code>QK_AUDIO_CLICKY_OFF</code></td><td><code>CK_OFF</code></td><td>Turns on Audio clicky mode</td></tr><tr><td><code>QK_AUDIO_CLICKY_UP</code></td><td><code>CK_UP</code></td><td>Increases frequency of the clicks</td></tr><tr><td><code>QK_AUDIO_CLICKY_DOWN</code></td><td><code>CK_DOWN</code></td><td>Decreases frequency of the clicks</td></tr><tr><td><code>QK_AUDIO_CLICKY_RESET</code></td><td><code>CK_RST</code></td><td>Resets frequency to default</td></tr></tbody></table><p>The feature is disabled by default, to save space. To enable it, add this to your <code>config.h</code>:</p><div class="language-c vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">c</span><pre class="shiki shiki-themes github-light github-dark vp-code"><code><span class="line"><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">#define</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;"> AUDIO_CLICKY</span></span></code></pre></div><p>You can configure the default, min and max frequencies, the stepping and built in randomness by defining these values:</p><table><thead><tr><th>Option</th><th>Default Value</th><th>Description</th></tr></thead><tbody><tr><td><code>AUDIO_CLICKY_FREQ_DEFAULT</code></td><td>440.0f</td><td>Sets the default/starting audio frequency for the clicky sounds.</td></tr><tr><td><code>AUDIO_CLICKY_FREQ_MIN</code></td><td>65.0f</td><td>Sets the lowest frequency (under 60f are a bit buggy).</td></tr><tr><td><code>AUDIO_CLICKY_FREQ_MAX</code></td><td>1500.0f</td><td>Sets the highest frequency. Too high may result in coworkers attacking you.</td></tr><tr><td><code>AUDIO_CLICKY_FREQ_FACTOR</code></td><td>1.18921f</td><td>Sets the stepping of UP/DOWN key codes. This is a multiplicative factor. The default steps the frequency up/down by a musical minor third.</td></tr><tr><td><code>AUDIO_CLICKY_FREQ_RANDOMNESS</code></td><td>0.05f</td><td>Sets a factor of randomness for the clicks, Setting this to <code>0f</code> will make each click identical, and <code>1.0f</code> will make this sound much like the 90&#39;s computer screen scrolling/typing effect.</td></tr><tr><td><code>AUDIO_CLICKY_DELAY_DURATION</code></td><td>1</td><td>An integer note duration where 1 is 1/16th of the tempo, or a sixty-fourth note (see <code>quantum/audio/musical_notes.h</code> for implementation details). The main clicky effect will be delayed by this duration. Adjusting this to values around 6-12 will help compensate for loud switches.</td></tr></tbody></table><h2 id="midi-functionality" tabindex="-1">MIDI Functionality <a class="header-anchor" href="#midi-functionality" aria-label="Permalink to &quot;MIDI Functionality&quot;">​</a></h2><p>See <a href="./midi">MIDI</a></p><h2 id="audio-keycodes" tabindex="-1">Audio Keycodes <a class="header-anchor" href="#audio-keycodes" aria-label="Permalink to &quot;Audio Keycodes&quot;">​</a></h2><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_AUDIO_ON</code></td><td><code>AU_ON</code></td><td>Turns on Audio Feature</td></tr><tr><td><code>QK_AUDIO_OFF</code></td><td><code>AU_OFF</code></td><td>Turns off Audio Feature</td></tr><tr><td><code>QK_AUDIO_TOGGLE</code></td><td><code>AU_TOGG</code></td><td>Toggles Audio state</td></tr><tr><td><code>QK_AUDIO_CLICKY_TOGGLE</code></td><td><code>CK_TOGG</code></td><td>Toggles Audio clicky mode</td></tr><tr><td><code>QK_AUDIO_CLICKY_ON</code></td><td><code>CK_ON</code></td><td>Turns on Audio clicky mode</td></tr><tr><td><code>QK_AUDIO_CLICKY_OFF</code></td><td><code>CK_OFF</code></td><td>Turns on Audio clicky mode</td></tr><tr><td><code>QK_AUDIO_CLICKY_UP</code></td><td><code>CK_UP</code></td><td>Increases frequency of the clicks</td></tr><tr><td><code>QK_AUDIO_CLICKY_DOWN</code></td><td><code>CK_DOWN</code></td><td>Decreases frequency of the clicks</td></tr><tr><td><code>QK_AUDIO_CLICKY_RESET</code></td><td><code>CK_RST</code></td><td>Resets frequency to default</td></tr><tr><td><code>QK_MUSIC_ON</code></td><td><code>MU_ON</code></td><td>Turns on Music Mode</td></tr><tr><td><code>QK_MUSIC_OFF</code></td><td><code>MU_OFF</code></td><td>Turns off Music Mode</td></tr><tr><td><code>QK_MUSIC_TOGGLE</code></td><td><code>MU_TOGG</code></td><td>Toggles Music Mode</td></tr><tr><td><code>QK_MUSIC_MODE_NEXT</code></td><td><code>MU_NEXT</code></td><td>Cycles through the music modes</td></tr><tr><td><code>QK_AUDIO_VOICE_NEXT</code></td><td><code>AU_NEXT</code></td><td>Cycles through the audio voices</td></tr><tr><td><code>QK_AUDIO_VOICE_PREVIOUS</code></td><td><code>AU_PREV</code></td><td>Cycles through the audio voices in reverse</td></tr></tbody></table>', 115);
const _hoisted_116 = [
  _hoisted_1
];
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", null, _hoisted_116);
}
const audio = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  __pageData,
  audio as default
};
