import { _ as _export_sfc, c as createElementBlock, o as openBlock, a8 as createStaticVNode } from "./chunks/framework.B9AX-CPi.js";
const __pageData = JSON.parse('{"title":"Keycodes Overview","description":"","frontmatter":{},"headers":[],"relativePath":"keycodes.md","filePath":"keycodes.md","lastUpdated":null}');
const _sfc_main = { name: "keycodes.md" };
const _hoisted_1 = /* @__PURE__ */ createStaticVNode('<h1 id="keycodes-overview" tabindex="-1">Keycodes Overview <a class="header-anchor" href="#keycodes-overview" aria-label="Permalink to &quot;Keycodes Overview&quot;">​</a></h1><p>When defining a <a href="./keymap">keymap</a> each key needs a valid key definition. This page documents the symbols that correspond to keycodes that are available to you in QMK.</p><p>This is a reference only. Each group of keys links to the page documenting their functionality in more detail.</p><h2 id="basic-keycodes" tabindex="-1">Basic Keycodes <a class="header-anchor" href="#basic-keycodes" aria-label="Permalink to &quot;Basic Keycodes {#basic-keycodes}&quot;">​</a></h2><p>See also: <a href="./keycodes_basic">Basic Keycodes</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th><th>Windows</th><th>macOS</th><th>Linux<sup>1</sup></th></tr></thead><tbody><tr><td><code>KC_NO</code></td><td><code>XXXXXXX</code></td><td>Ignore this key (NOOP)</td><td><em>N/A</em></td><td><em>N/A</em></td><td><em>N/A</em></td></tr><tr><td><code>KC_TRANSPARENT</code></td><td><code>KC_TRNS</code>, <code>_______</code></td><td>Use the next lowest non-transparent key</td><td><em>N/A</em></td><td><em>N/A</em></td><td><em>N/A</em></td></tr><tr><td><code>KC_A</code></td><td></td><td><code>a</code> and <code>A</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_B</code></td><td></td><td><code>b</code> and <code>B</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_C</code></td><td></td><td><code>c</code> and <code>C</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_D</code></td><td></td><td><code>d</code> and <code>D</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_E</code></td><td></td><td><code>e</code> and <code>E</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F</code></td><td></td><td><code>f</code> and <code>F</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_G</code></td><td></td><td><code>g</code> and <code>G</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_H</code></td><td></td><td><code>h</code> and <code>H</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_I</code></td><td></td><td><code>i</code> and <code>I</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_J</code></td><td></td><td><code>j</code> and <code>J</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_K</code></td><td></td><td><code>k</code> and <code>K</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_L</code></td><td></td><td><code>l</code> and <code>L</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_M</code></td><td></td><td><code>m</code> and <code>M</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_N</code></td><td></td><td><code>n</code> and <code>N</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_O</code></td><td></td><td><code>o</code> and <code>O</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_P</code></td><td></td><td><code>p</code> and <code>P</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_Q</code></td><td></td><td><code>q</code> and <code>Q</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_R</code></td><td></td><td><code>r</code> and <code>R</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_S</code></td><td></td><td><code>s</code> and <code>S</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_T</code></td><td></td><td><code>t</code> and <code>T</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_U</code></td><td></td><td><code>u</code> and <code>U</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_V</code></td><td></td><td><code>v</code> and <code>V</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_W</code></td><td></td><td><code>w</code> and <code>W</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_X</code></td><td></td><td><code>x</code> and <code>X</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_Y</code></td><td></td><td><code>y</code> and <code>Y</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_Z</code></td><td></td><td><code>z</code> and <code>Z</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_1</code></td><td></td><td><code>1</code> and <code>!</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_2</code></td><td></td><td><code>2</code> and <code>@</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_3</code></td><td></td><td><code>3</code> and <code>#</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_4</code></td><td></td><td><code>4</code> and <code>$</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_5</code></td><td></td><td><code>5</code> and <code>%</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_6</code></td><td></td><td><code>6</code> and <code>^</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_7</code></td><td></td><td><code>7</code> and <code>&amp;</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_8</code></td><td></td><td><code>8</code> and <code>*</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_9</code></td><td></td><td><code>9</code> and <code>(</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_0</code></td><td></td><td><code>0</code> and <code>)</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_ENTER</code></td><td><code>KC_ENT</code></td><td>Return (Enter)</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_ESCAPE</code></td><td><code>KC_ESC</code></td><td>Escape</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_BACKSPACE</code></td><td><code>KC_BSPC</code></td><td>Delete (Backspace)</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_TAB</code></td><td></td><td>Tab</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_SPACE</code></td><td><code>KC_SPC</code></td><td>Spacebar</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_MINUS</code></td><td><code>KC_MINS</code></td><td><code>-</code> and <code>_</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_EQUAL</code></td><td><code>KC_EQL</code></td><td><code>=</code> and <code>+</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_LEFT_BRACKET</code></td><td><code>KC_LBRC</code></td><td><code>[</code> and <code>{</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_RIGHT_BRACKET</code></td><td><code>KC_RBRC</code></td><td><code>]</code> and <code>}</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_BACKSLASH</code></td><td><code>KC_BSLS</code></td><td><code>\\</code> and <code>|</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_NONUS_HASH</code></td><td><code>KC_NUHS</code></td><td>Non-US <code>#</code> and <code>~</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_SEMICOLON</code></td><td><code>KC_SCLN</code></td><td><code>;</code> and <code>:</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_QUOTE</code></td><td><code>KC_QUOT</code></td><td><code>&#39;</code> and <code>&quot;</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_GRAVE</code></td><td><code>KC_GRV</code></td><td><code>`</code> and <code>~</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_COMMA</code></td><td><code>KC_COMM</code></td><td><code>,</code> and <code>&lt;</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_DOT</code></td><td></td><td><code>.</code> and <code>&gt;</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_SLASH</code></td><td><code>KC_SLSH</code></td><td><code>/</code> and <code>?</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_CAPS_LOCK</code></td><td><code>KC_CAPS</code></td><td>Caps Lock</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F1</code></td><td></td><td>F1</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F2</code></td><td></td><td>F2</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F3</code></td><td></td><td>F3</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F4</code></td><td></td><td>F4</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F5</code></td><td></td><td>F5</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F6</code></td><td></td><td>F6</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F7</code></td><td></td><td>F7</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F8</code></td><td></td><td>F8</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F9</code></td><td></td><td>F9</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F10</code></td><td></td><td>F10</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F11</code></td><td></td><td>F11</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F12</code></td><td></td><td>F12</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_PRINT_SCREEN</code></td><td><code>KC_PSCR</code></td><td>Print Screen</td><td>✔</td><td>✔<sup>2</sup></td><td>✔</td></tr><tr><td><code>KC_SCROLL_LOCK</code></td><td><code>KC_SCRL</code>, <code>KC_BRMD</code></td><td>Scroll Lock, Brightness Down (macOS)</td><td>✔</td><td>✔<sup>2</sup></td><td>✔</td></tr><tr><td><code>KC_PAUSE</code></td><td><code>KC_PAUS</code>, <code>KC_BRK</code>, <code>KC_BRMU</code></td><td>Pause, Brightness Up (macOS)</td><td>✔</td><td>✔<sup>2</sup></td><td>✔</td></tr><tr><td><code>KC_INSERT</code></td><td><code>KC_INS</code></td><td>Insert</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_HOME</code></td><td></td><td>Home</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_PAGE_UP</code></td><td><code>KC_PGUP</code></td><td>Page Up</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_DELETE</code></td><td><code>KC_DEL</code></td><td>Forward Delete</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_END</code></td><td></td><td>End</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_PAGE_DOWN</code></td><td><code>KC_PGDN</code></td><td>Page Down</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_RIGHT</code></td><td><code>KC_RGHT</code></td><td>Right Arrow</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_LEFT</code></td><td></td><td>Left Arrow</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_DOWN</code></td><td></td><td>Down Arrow</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_UP</code></td><td></td><td>Up Arrow</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_NUM_LOCK</code></td><td><code>KC_NUM</code></td><td>Keypad Num Lock and Clear</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KP_SLASH</code></td><td><code>KC_PSLS</code></td><td>Keypad <code>/</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KP_ASTERISK</code></td><td><code>KC_PAST</code></td><td>Keypad <code>*</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KP_MINUS</code></td><td><code>KC_PMNS</code></td><td>Keypad <code>-</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KP_PLUS</code></td><td><code>KC_PPLS</code></td><td>Keypad <code>+</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KP_ENTER</code></td><td><code>KC_PENT</code></td><td>Keypad Enter</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KP_1</code></td><td><code>KC_P1</code></td><td>Keypad <code>1</code> and End</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KP_2</code></td><td><code>KC_P2</code></td><td>Keypad <code>2</code> and Down Arrow</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KP_3</code></td><td><code>KC_P3</code></td><td>Keypad <code>3</code> and Page Down</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KP_4</code></td><td><code>KC_P4</code></td><td>Keypad <code>4</code> and Left Arrow</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KP_5</code></td><td><code>KC_P5</code></td><td>Keypad <code>5</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KP_6</code></td><td><code>KC_P6</code></td><td>Keypad <code>6</code> and Right Arrow</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KP_7</code></td><td><code>KC_P7</code></td><td>Keypad <code>7</code> and Home</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KP_8</code></td><td><code>KC_P8</code></td><td>Keypad <code>8</code> and Up Arrow</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KP_9</code></td><td><code>KC_P9</code></td><td>Keypad <code>9</code> and Page Up</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KP_0</code></td><td><code>KC_P0</code></td><td>Keypad <code>0</code> and Insert</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KP_DOT</code></td><td><code>KC_PDOT</code></td><td>Keypad <code>.</code> and Delete</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_NONUS_BACKSLASH</code></td><td><code>KC_NUBS</code></td><td>Non-US <code>\\</code> and <code>|</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_APPLICATION</code></td><td><code>KC_APP</code></td><td>Application (Windows Context Menu Key)</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_KB_POWER</code></td><td></td><td>System Power</td><td></td><td>✔<sup>3</sup></td><td>✔</td></tr><tr><td><code>KC_KP_EQUAL</code></td><td><code>KC_PEQL</code></td><td>Keypad <code>=</code></td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F13</code></td><td></td><td>F13</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F14</code></td><td></td><td>F14</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F15</code></td><td></td><td>F15</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F16</code></td><td></td><td>F16</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F17</code></td><td></td><td>F17</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F18</code></td><td></td><td>F18</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F19</code></td><td></td><td>F19</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_F20</code></td><td></td><td>F20</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_F21</code></td><td></td><td>F21</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_F22</code></td><td></td><td>F22</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_F23</code></td><td></td><td>F23</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_F24</code></td><td></td><td>F24</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_EXECUTE</code></td><td><code>KC_EXEC</code></td><td>Execute</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_HELP</code></td><td></td><td>Help</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_MENU</code></td><td></td><td>Menu</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_SELECT</code></td><td><code>KC_SLCT</code></td><td>Select</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_STOP</code></td><td></td><td>Stop</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_AGAIN</code></td><td><code>KC_AGIN</code></td><td>Again</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_UNDO</code></td><td></td><td>Undo</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_CUT</code></td><td></td><td>Cut</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_COPY</code></td><td></td><td>Copy</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_PASTE</code></td><td><code>KC_PSTE</code></td><td>Paste</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_FIND</code></td><td></td><td>Find</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_KB_MUTE</code></td><td></td><td>Mute</td><td></td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KB_VOLUME_UP</code></td><td></td><td>Volume Up</td><td></td><td>✔</td><td>✔</td></tr><tr><td><code>KC_KB_VOLUME_DOWN</code></td><td></td><td>Volume Down</td><td></td><td>✔</td><td>✔</td></tr><tr><td><code>KC_LOCKING_CAPS_LOCK</code></td><td><code>KC_LCAP</code></td><td>Locking Caps Lock</td><td>✔</td><td>✔</td><td></td></tr><tr><td><code>KC_LOCKING_NUM_LOCK</code></td><td><code>KC_LNUM</code></td><td>Locking Num Lock</td><td>✔</td><td>✔</td><td></td></tr><tr><td><code>KC_LOCKING_SCROLL_LOCK</code></td><td><code>KC_LSCR</code></td><td>Locking Scroll Lock</td><td>✔</td><td>✔</td><td></td></tr><tr><td><code>KC_KP_COMMA</code></td><td><code>KC_PCMM</code></td><td>Keypad <code>,</code></td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_KP_EQUAL_AS400</code></td><td></td><td>Keypad <code>=</code> on AS/400 keyboards</td><td></td><td></td><td></td></tr><tr><td><code>KC_INTERNATIONAL_1</code></td><td><code>KC_INT1</code></td><td>International 1</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_INTERNATIONAL_2</code></td><td><code>KC_INT2</code></td><td>International 2</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_INTERNATIONAL_3</code></td><td><code>KC_INT3</code></td><td>International 3</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_INTERNATIONAL_4</code></td><td><code>KC_INT4</code></td><td>International 4</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_INTERNATIONAL_5</code></td><td><code>KC_INT5</code></td><td>International 5</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_INTERNATIONAL_6</code></td><td><code>KC_INT6</code></td><td>International 6</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_INTERNATIONAL_7</code></td><td><code>KC_INT7</code></td><td>International 7</td><td></td><td></td><td></td></tr><tr><td><code>KC_INTERNATIONAL_8</code></td><td><code>KC_INT8</code></td><td>International 8</td><td></td><td></td><td></td></tr><tr><td><code>KC_INTERNATIONAL_9</code></td><td><code>KC_INT9</code></td><td>International 9</td><td></td><td></td><td></td></tr><tr><td><code>KC_LANGUAGE_1</code></td><td><code>KC_LNG1</code></td><td>Language 1</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_LANGUAGE_2</code></td><td><code>KC_LNG2</code></td><td>Language 2</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_LANGUAGE_3</code></td><td><code>KC_LNG3</code></td><td>Language 3</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_LANGUAGE_4</code></td><td><code>KC_LNG4</code></td><td>Language 4</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_LANGUAGE_5</code></td><td><code>KC_LNG5</code></td><td>Language 5</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_LANGUAGE_6</code></td><td><code>KC_LNG6</code></td><td>Language 6</td><td></td><td></td><td></td></tr><tr><td><code>KC_LANGUAGE_7</code></td><td><code>KC_LNG7</code></td><td>Language 7</td><td></td><td></td><td></td></tr><tr><td><code>KC_LANGUAGE_8</code></td><td><code>KC_LNG8</code></td><td>Language 8</td><td></td><td></td><td></td></tr><tr><td><code>KC_LANGUAGE_9</code></td><td><code>KC_LNG9</code></td><td>Language 9</td><td></td><td></td><td></td></tr><tr><td><code>KC_ALTERNATE_ERASE</code></td><td><code>KC_ERAS</code></td><td>Alternate Erase</td><td></td><td></td><td></td></tr><tr><td><code>KC_SYSTEM_REQUEST</code></td><td><code>KC_SYRQ</code></td><td>SysReq/Attention</td><td></td><td></td><td></td></tr><tr><td><code>KC_CANCEL</code></td><td><code>KC_CNCL</code></td><td>Cancel</td><td></td><td></td><td></td></tr><tr><td><code>KC_CLEAR</code></td><td><code>KC_CLR</code></td><td>Clear</td><td></td><td></td><td>✔</td></tr><tr><td><code>KC_PRIOR</code></td><td><code>KC_PRIR</code></td><td>Prior</td><td></td><td></td><td></td></tr><tr><td><code>KC_RETURN</code></td><td><code>KC_RETN</code></td><td>Return</td><td></td><td></td><td></td></tr><tr><td><code>KC_SEPARATOR</code></td><td><code>KC_SEPR</code></td><td>Separator</td><td></td><td></td><td></td></tr><tr><td><code>KC_OUT</code></td><td></td><td>Out</td><td></td><td></td><td></td></tr><tr><td><code>KC_OPER</code></td><td></td><td>Oper</td><td></td><td></td><td></td></tr><tr><td><code>KC_CLEAR_AGAIN</code></td><td><code>KC_CLAG</code></td><td>Clear/Again</td><td></td><td></td><td></td></tr><tr><td><code>KC_CRSEL</code></td><td><code>KC_CRSL</code></td><td>CrSel/Props</td><td></td><td></td><td></td></tr><tr><td><code>KC_EXSEL</code></td><td><code>KC_EXSL</code></td><td>ExSel</td><td></td><td></td><td></td></tr><tr><td><code>KC_LEFT_CTRL</code></td><td><code>KC_LCTL</code></td><td>Left Control</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_LEFT_SHIFT</code></td><td><code>KC_LSFT</code></td><td>Left Shift</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_LEFT_ALT</code></td><td><code>KC_LALT</code>, <code>KC_LOPT</code></td><td>Left Alt (Option)</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_LEFT_GUI</code></td><td><code>KC_LGUI</code>, <code>KC_LCMD</code>, <code>KC_LWIN</code></td><td>Left GUI (Windows/Command/Meta key)</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_RIGHT_CTRL</code></td><td><code>KC_RCTL</code></td><td>Right Control</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_RIGHT_SHIFT</code></td><td><code>KC_RSFT</code></td><td>Right Shift</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_RIGHT_ALT</code></td><td><code>KC_RALT</code>, <code>KC_ROPT</code>, <code>KC_ALGR</code></td><td>Right Alt (Option/AltGr)</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_RIGHT_GUI</code></td><td><code>KC_RGUI</code>, <code>KC_RCMD</code>, <code>KC_RWIN</code></td><td>Right GUI (Windows/Command/Meta key)</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_SYSTEM_POWER</code></td><td><code>KC_PWR</code></td><td>System Power Down</td><td>✔</td><td>✔<sup>3</sup></td><td>✔</td></tr><tr><td><code>KC_SYSTEM_SLEEP</code></td><td><code>KC_SLEP</code></td><td>System Sleep</td><td>✔</td><td>✔<sup>3</sup></td><td>✔</td></tr><tr><td><code>KC_SYSTEM_WAKE</code></td><td><code>KC_WAKE</code></td><td>System Wake</td><td></td><td>✔<sup>3</sup></td><td>✔</td></tr><tr><td><code>KC_AUDIO_MUTE</code></td><td><code>KC_MUTE</code></td><td>Mute</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_AUDIO_VOL_UP</code></td><td><code>KC_VOLU</code></td><td>Volume Up</td><td>✔</td><td>✔<sup>4</sup></td><td>✔</td></tr><tr><td><code>KC_AUDIO_VOL_DOWN</code></td><td><code>KC_VOLD</code></td><td>Volume Down</td><td>✔</td><td>✔<sup>4</sup></td><td>✔</td></tr><tr><td><code>KC_MEDIA_NEXT_TRACK</code></td><td><code>KC_MNXT</code></td><td>Next Track</td><td>✔</td><td>✔<sup>5</sup></td><td>✔</td></tr><tr><td><code>KC_MEDIA_PREV_TRACK</code></td><td><code>KC_MPRV</code></td><td>Previous Track</td><td>✔</td><td>✔<sup>5</sup></td><td>✔</td></tr><tr><td><code>KC_MEDIA_STOP</code></td><td><code>KC_MSTP</code></td><td>Stop Track</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_MEDIA_PLAY_PAUSE</code></td><td><code>KC_MPLY</code></td><td>Play/Pause Track</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_MEDIA_SELECT</code></td><td><code>KC_MSEL</code></td><td>Launch Media Player</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_MEDIA_EJECT</code></td><td><code>KC_EJCT</code></td><td>Eject</td><td></td><td>✔</td><td>✔</td></tr><tr><td><code>KC_MAIL</code></td><td></td><td>Launch Mail</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_CALCULATOR</code></td><td><code>KC_CALC</code></td><td>Launch Calculator</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_MY_COMPUTER</code></td><td><code>KC_MYCM</code></td><td>Launch My Computer</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_WWW_SEARCH</code></td><td><code>KC_WSCH</code></td><td>Browser Search</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_WWW_HOME</code></td><td><code>KC_WHOM</code></td><td>Browser Home</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_WWW_BACK</code></td><td><code>KC_WBAK</code></td><td>Browser Back</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_WWW_FORWARD</code></td><td><code>KC_WFWD</code></td><td>Browser Forward</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_WWW_STOP</code></td><td><code>KC_WSTP</code></td><td>Browser Stop</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_WWW_REFRESH</code></td><td><code>KC_WREF</code></td><td>Browser Refresh</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_WWW_FAVORITES</code></td><td><code>KC_WFAV</code></td><td>Browser Favorites</td><td>✔</td><td></td><td>✔</td></tr><tr><td><code>KC_MEDIA_FAST_FORWARD</code></td><td><code>KC_MFFD</code></td><td>Next Track</td><td>✔</td><td>✔<sup>5</sup></td><td>✔</td></tr><tr><td><code>KC_MEDIA_REWIND</code></td><td><code>KC_MRWD</code></td><td>Previous Track</td><td>✔<sup>6</sup></td><td>✔<sup>5</sup></td><td>✔</td></tr><tr><td><code>KC_BRIGHTNESS_UP</code></td><td><code>KC_BRIU</code></td><td>Brightness Up</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_BRIGHTNESS_DOWN</code></td><td><code>KC_BRID</code></td><td>Brightness Down</td><td>✔</td><td>✔</td><td>✔</td></tr><tr><td><code>KC_CONTROL_PANEL</code></td><td><code>KC_CPNL</code></td><td>Open Control Panel</td><td>✔</td><td></td><td></td></tr><tr><td><code>KC_ASSISTANT</code></td><td><code>KC_ASST</code></td><td>Launch Context-Aware Assistant</td><td>✔</td><td></td><td></td></tr><tr><td><code>KC_MISSION_CONTROL</code></td><td><code>KC_MCTL</code></td><td>Open Mission Control</td><td></td><td>✔</td><td></td></tr><tr><td><code>KC_LAUNCHPAD</code></td><td><code>KC_LPAD</code></td><td>Open Launchpad</td><td></td><td>✔</td><td></td></tr></tbody></table><p><sup>1. The Linux kernel HID driver recognizes <a href="https://github.com/torvalds/linux/blob/master/drivers/hid/hid-input.c" target="_blank" rel="noreferrer">nearly all keycodes</a>, but the default bindings depend on the DE/WM.</sup><br><sup>2. Treated as F13-F15.</sup><br><sup>3. Must be held for about three seconds, and will display a prompt instead.</sup><br><sup>4. Holding Shift+Option allows for finer control of volume level.</sup><br><sup>5. Skips the entire track in iTunes when tapped, seeks within the current track when held.</sup><br><sup>6. WMP does not recognize the Rewind key, but both alter playback speed in VLC.</sup></p><h2 id="quantum-keycodes" tabindex="-1">Quantum Keycodes <a class="header-anchor" href="#quantum-keycodes" aria-label="Permalink to &quot;Quantum Keycodes {#quantum-keycodes}&quot;">​</a></h2><p>See also: <a href="./quantum_keycodes#qmk-keycodes">Quantum Keycodes</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_BOOTLOADER</code></td><td><code>QK_BOOT</code></td><td>Put the keyboard into bootloader mode for flashing</td></tr><tr><td><code>QK_DEBUG_TOGGLE</code></td><td><code>DB_TOGG</code></td><td>Toggle debug mode</td></tr><tr><td><code>QK_CLEAR_EEPROM</code></td><td><code>EE_CLR</code></td><td>Reinitializes the keyboard&#39;s EEPROM (persistent memory)</td></tr><tr><td><code>QK_MAKE</code></td><td></td><td>Sends <code>qmk compile -kb (keyboard) -km (keymap)</code>, or <code>qmk flash</code> if shift is held. Puts keyboard into bootloader mode if shift &amp; control are held</td></tr><tr><td><code>QK_REBOOT</code></td><td><code>QK_RBT</code></td><td>Resets the keyboard. Does not load the bootloader</td></tr></tbody></table><h2 id="audio-keys" tabindex="-1">Audio Keys <a class="header-anchor" href="#audio-keys" aria-label="Permalink to &quot;Audio Keys {#audio-keys}&quot;">​</a></h2><p>See also: <a href="./features/audio">Audio</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_AUDIO_ON</code></td><td><code>AU_ON</code></td><td>Turns on Audio Feature</td></tr><tr><td><code>QK_AUDIO_OFF</code></td><td><code>AU_OFF</code></td><td>Turns off Audio Feature</td></tr><tr><td><code>QK_AUDIO_TOGGLE</code></td><td><code>AU_TOGG</code></td><td>Toggles Audio state</td></tr><tr><td><code>QK_AUDIO_CLICKY_TOGGLE</code></td><td><code>CK_TOGG</code></td><td>Toggles Audio clicky mode</td></tr><tr><td><code>QK_AUDIO_CLICKY_ON</code></td><td><code>CK_ON</code></td><td>Turns on Audio clicky mode</td></tr><tr><td><code>QK_AUDIO_CLICKY_OFF</code></td><td><code>CK_OFF</code></td><td>Turns on Audio clicky mode</td></tr><tr><td><code>QK_AUDIO_CLICKY_UP</code></td><td><code>CK_UP</code></td><td>Increases frequency of the clicks</td></tr><tr><td><code>QK_AUDIO_CLICKY_DOWN</code></td><td><code>CK_DOWN</code></td><td>Decreases frequency of the clicks</td></tr><tr><td><code>QK_AUDIO_CLICKY_RESET</code></td><td><code>CK_RST</code></td><td>Resets frequency to default</td></tr><tr><td><code>QK_MUSIC_ON</code></td><td><code>MU_ON</code></td><td>Turns on Music Mode</td></tr><tr><td><code>QK_MUSIC_OFF</code></td><td><code>MU_OFF</code></td><td>Turns off Music Mode</td></tr><tr><td><code>QK_MUSIC_TOGGLE</code></td><td><code>MU_TOGG</code></td><td>Toggles Music Mode</td></tr><tr><td><code>QK_MUSIC_MODE_NEXT</code></td><td><code>MU_NEXT</code></td><td>Cycles through the music modes</td></tr><tr><td><code>QK_AUDIO_VOICE_NEXT</code></td><td><code>AU_NEXT</code></td><td>Cycles through the audio voices</td></tr><tr><td><code>QK_AUDIO_VOICE_PREVIOUS</code></td><td><code>AU_PREV</code></td><td>Cycles through the audio voices in reverse</td></tr></tbody></table><h2 id="auto-shift" tabindex="-1">Auto Shift <a class="header-anchor" href="#auto-shift" aria-label="Permalink to &quot;Auto Shift {#auto-shift}&quot;">​</a></h2><p>See also: <a href="./features/auto_shift">Auto Shift</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_AUTO_SHIFT_DOWN</code></td><td><code>AS_DOWN</code></td><td>Lower the Auto Shift timeout variable (down)</td></tr><tr><td><code>QK_AUTO_SHIFT_UP</code></td><td><code>AS_UP</code></td><td>Raise the Auto Shift timeout variable (up)</td></tr><tr><td><code>QK_AUTO_SHIFT_REPORT</code></td><td><code>AS_RPT</code></td><td>Report your current Auto Shift timeout value</td></tr><tr><td><code>QK_AUTO_SHIFT_ON</code></td><td><code>AS_ON</code></td><td>Turns on the Auto Shift Function</td></tr><tr><td><code>QK_AUTO_SHIFT_OFF</code></td><td><code>AS_OFF</code></td><td>Turns off the Auto Shift Function</td></tr><tr><td><code>QK_AUTO_SHIFT_TOGGLE</code></td><td><code>AS_TOGG</code></td><td>Toggles the state of the Auto Shift feature</td></tr></tbody></table><h2 id="autocorrect" tabindex="-1">Autocorrect <a class="header-anchor" href="#autocorrect" aria-label="Permalink to &quot;Autocorrect {#autocorrect}&quot;">​</a></h2><p>See also: <a href="./features/autocorrect">Autocorrect</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_AUTOCORRECT_ON</code></td><td><code>AC_ON</code></td><td>Turns on the Autocorrect feature.</td></tr><tr><td><code>QK_AUTOCORRECT_OFF</code></td><td><code>AC_OFF</code></td><td>Turns off the Autocorrect feature.</td></tr><tr><td><code>QK_AUTOCORRECT_TOGGLE</code></td><td><code>AC_TOGG</code></td><td>Toggles the status of the Autocorrect feature.</td></tr></tbody></table><h2 id="backlighting" tabindex="-1">Backlighting <a class="header-anchor" href="#backlighting" aria-label="Permalink to &quot;Backlighting {#backlighting}&quot;">​</a></h2><p>See also: <a href="./features/backlight">Backlighting</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_BACKLIGHT_TOGGLE</code></td><td><code>BL_TOGG</code></td><td>Turn the backlight on or off</td></tr><tr><td><code>QK_BACKLIGHT_STEP</code></td><td><code>BL_STEP</code></td><td>Cycle through backlight levels</td></tr><tr><td><code>QK_BACKLIGHT_ON</code></td><td><code>BL_ON</code></td><td>Set the backlight to max brightness</td></tr><tr><td><code>QK_BACKLIGHT_OFF</code></td><td><code>BL_OFF</code></td><td>Turn the backlight off</td></tr><tr><td><code>QK_BACKLIGHT_UP</code></td><td><code>BL_UP</code></td><td>Increase the backlight level</td></tr><tr><td><code>QK_BACKLIGHT_DOWN</code></td><td><code>BL_DOWN</code></td><td>Decrease the backlight level</td></tr><tr><td><code>QK_BACKLIGHT_TOGGLE_BREATHING</code></td><td><code>BL_BRTG</code></td><td>Toggle backlight breathing</td></tr></tbody></table><h2 id="bluetooth" tabindex="-1">Wireless/Bluetooth <a class="header-anchor" href="#bluetooth" aria-label="Permalink to &quot;Wireless/Bluetooth {#bluetooth}&quot;">​</a></h2><p>See also: <a href="./features/wireless">Wireless</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_OUTPUT_AUTO</code></td><td><code>OU_AUTO</code></td><td>Automatically switch to USB when plugged in, otherwise use wireless</td></tr><tr><td><code>QK_OUTPUT_NEXT</code></td><td><code>OU_NEXT</code></td><td>Cycle forwards through USB, Bluetooth, and 2.4GHz (when available) <strong>(not yet implemented)</strong></td></tr><tr><td><code>QK_OUTPUT_PREV</code></td><td><code>OU_PREV</code></td><td>Cycle backwards through USB, Bluetooth, and 2.4GHz (when available) <strong>(not yet implemented)</strong></td></tr><tr><td><code>QK_OUTPUT_NONE</code></td><td><code>OU_NONE</code></td><td>Disable all output <strong>(not yet implemented)</strong></td></tr><tr><td><code>QK_OUTPUT_USB</code></td><td><code>OU_USB</code></td><td>Output to USB only</td></tr><tr><td><code>QK_OUTPUT_2P4GHZ</code></td><td><code>OU_2P4G</code></td><td>Output to 2.4GHz only <strong>(not yet implemented)</strong></td></tr><tr><td><code>QK_OUTPUT_BLUETOOTH</code></td><td><code>OU_BT</code></td><td>Output to Bluetooth only</td></tr><tr><td><code>QK_BLUETOOTH_PROFILE_NEXT</code></td><td><code>BT_NEXT</code></td><td>Move to the next Bluetooth profile <strong>(not yet implemented)</strong></td></tr><tr><td><code>QK_BLUETOOTH_PROFILE_PREV</code></td><td><code>BT_PREV</code></td><td>Move to the previous Bluetooth profile <strong>(not yet implemented)</strong></td></tr><tr><td><code>QK_BLUETOOTH_UNPAIR</code></td><td><code>BT_UNPR</code></td><td>Un-pair the current Bluetooth profile <strong>(not yet implemented)</strong></td></tr><tr><td><code>QK_BLUETOOTH_PROFILE1</code></td><td><code>BT_PRF1</code></td><td>Swap to Bluetooth profile #1 <strong>(not yet implemented)</strong></td></tr><tr><td><code>QK_BLUETOOTH_PROFILE2</code></td><td><code>BT_PRF2</code></td><td>Swap to Bluetooth profile #2 <strong>(not yet implemented)</strong></td></tr><tr><td><code>QK_BLUETOOTH_PROFILE3</code></td><td><code>BT_PRF3</code></td><td>Swap to Bluetooth profile #3 <strong>(not yet implemented)</strong></td></tr><tr><td><code>QK_BLUETOOTH_PROFILE4</code></td><td><code>BT_PRF4</code></td><td>Swap to Bluetooth profile #4 <strong>(not yet implemented)</strong></td></tr><tr><td><code>QK_BLUETOOTH_PROFILE5</code></td><td><code>BT_PRF5</code></td><td>Swap to Bluetooth profile #5 <strong>(not yet implemented)</strong></td></tr></tbody></table><h2 id="caps-word" tabindex="-1">Caps Word <a class="header-anchor" href="#caps-word" aria-label="Permalink to &quot;Caps Word {#caps-word}&quot;">​</a></h2><p>See also: <a href="./features/caps_word">Caps Word</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_CAPS_WORD_TOGGLE</code></td><td><code>CW_TOGG</code></td><td>Toggles Caps Word</td></tr></tbody></table><h2 id="dynamic-macros" tabindex="-1">Dynamic Macros <a class="header-anchor" href="#dynamic-macros" aria-label="Permalink to &quot;Dynamic Macros {#dynamic-macros}&quot;">​</a></h2><p>See also: <a href="./features/dynamic_macros">Dynamic Macros</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_DYNAMIC_MACRO_RECORD_START_1</code></td><td><code>DM_REC1</code></td><td>Start recording Macro 1</td></tr><tr><td><code>QK_DYNAMIC_MACRO_RECORD_START_2</code></td><td><code>DM_REC2</code></td><td>Start recording Macro 2</td></tr><tr><td><code>QK_DYNAMIC_MACRO_PLAY_1</code></td><td><code>DM_PLY1</code></td><td>Replay Macro 1</td></tr><tr><td><code>QK_DYNAMIC_MACRO_PLAY_2</code></td><td><code>DM_PLY2</code></td><td>Replay Macro 2</td></tr><tr><td><code>QK_DYNAMIC_MACRO_RECORD_STOP</code></td><td><code>DM_RSTP</code></td><td>Finish the macro that is currently being recorded.</td></tr></tbody></table><h2 id="grave-escape" tabindex="-1">Grave Escape <a class="header-anchor" href="#grave-escape" aria-label="Permalink to &quot;Grave Escape {#grave-escape}&quot;">​</a></h2><p>See also: <a href="./features/grave_esc">Grave Escape</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_GRAVE_ESCAPE</code></td><td><code>QK_GESC</code></td><td>Escape when pressed, <code>`</code> when Shift or GUI are held</td></tr></tbody></table><h2 id="joystick" tabindex="-1">Joystick <a class="header-anchor" href="#joystick" aria-label="Permalink to &quot;Joystick {#joystick}&quot;">​</a></h2><p>See also: <a href="./features/joystick">Joystick</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_JOYSTICK_BUTTON_0</code></td><td><code>JS_0</code></td><td>Button 0</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_1</code></td><td><code>JS_1</code></td><td>Button 1</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_2</code></td><td><code>JS_2</code></td><td>Button 2</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_3</code></td><td><code>JS_3</code></td><td>Button 3</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_4</code></td><td><code>JS_4</code></td><td>Button 4</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_5</code></td><td><code>JS_5</code></td><td>Button 5</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_6</code></td><td><code>JS_6</code></td><td>Button 6</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_7</code></td><td><code>JS_7</code></td><td>Button 7</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_8</code></td><td><code>JS_8</code></td><td>Button 8</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_9</code></td><td><code>JS_9</code></td><td>Button 9</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_10</code></td><td><code>JS_10</code></td><td>Button 10</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_11</code></td><td><code>JS_11</code></td><td>Button 11</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_12</code></td><td><code>JS_12</code></td><td>Button 12</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_13</code></td><td><code>JS_13</code></td><td>Button 13</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_14</code></td><td><code>JS_14</code></td><td>Button 14</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_15</code></td><td><code>JS_15</code></td><td>Button 15</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_16</code></td><td><code>JS_16</code></td><td>Button 16</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_17</code></td><td><code>JS_17</code></td><td>Button 17</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_18</code></td><td><code>JS_18</code></td><td>Button 18</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_19</code></td><td><code>JS_19</code></td><td>Button 19</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_20</code></td><td><code>JS_20</code></td><td>Button 20</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_21</code></td><td><code>JS_21</code></td><td>Button 21</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_22</code></td><td><code>JS_22</code></td><td>Button 22</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_23</code></td><td><code>JS_23</code></td><td>Button 23</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_24</code></td><td><code>JS_24</code></td><td>Button 24</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_25</code></td><td><code>JS_25</code></td><td>Button 25</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_26</code></td><td><code>JS_26</code></td><td>Button 26</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_27</code></td><td><code>JS_27</code></td><td>Button 27</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_28</code></td><td><code>JS_28</code></td><td>Button 28</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_29</code></td><td><code>JS_29</code></td><td>Button 29</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_30</code></td><td><code>JS_30</code></td><td>Button 30</td></tr><tr><td><code>QK_JOYSTICK_BUTTON_31</code></td><td><code>JS_31</code></td><td>Button 31</td></tr></tbody></table><h2 id="key-lock" tabindex="-1">Key Lock <a class="header-anchor" href="#key-lock" aria-label="Permalink to &quot;Key Lock {#key-lock}&quot;">​</a></h2><p>See also: <a href="./features/key_lock">Key Lock</a></p><table><thead><tr><th>Key</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_LOCK</code></td><td>Hold down the next key pressed, until the key is pressed again</td></tr></tbody></table><h2 id="layer-lock" tabindex="-1">Layer Lock <a class="header-anchor" href="#layer-lock" aria-label="Permalink to &quot;Layer Lock {#layer-lock}&quot;">​</a></h2><p>See also: <a href="./features/layer_lock">Layer Lock</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_LAYER_LOCK</code></td><td><code>QK_LLCK</code></td><td>Locks or unlocks the highest layer</td></tr></tbody></table><h2 id="layer-switching" tabindex="-1">Layer Switching <a class="header-anchor" href="#layer-switching" aria-label="Permalink to &quot;Layer Switching {#layer-switching}&quot;">​</a></h2><p>See also: <a href="./feature_layers#switching-and-toggling-layers">Layer Switching</a></p><table><thead><tr><th>Key</th><th>Description</th></tr></thead><tbody><tr><td><code>DF(layer)</code></td><td>Set the base (default) layer until the keyboard loses power</td></tr><tr><td><code>PDF(layer)</code></td><td>Set the base (default) layer in EEPROM</td></tr><tr><td><code>MO(layer)</code></td><td>Momentarily turn on <code>layer</code> when pressed (requires <code>KC_TRNS</code> on destination layer)</td></tr><tr><td><code>OSL(layer)</code></td><td>Momentarily activates <code>layer</code> until a key is pressed. See <a href="./one_shot_keys">One Shot Keys</a> for details.</td></tr><tr><td><code>LM(layer, mod)</code></td><td>Momentarily turn on <code>layer</code> (like MO) with <code>mod</code> active as well. Where <code>mod</code> is a mods_bit. Mods can be viewed <a href="./mod_tap">here</a>. Example Implementation: <code>LM(LAYER_1, MOD_LALT)</code></td></tr><tr><td><code>LT(layer, kc)</code></td><td>Turn on <code>layer</code> when held, <code>kc</code> when tapped</td></tr><tr><td><code>TG(layer)</code></td><td>Toggle <code>layer</code> on or off</td></tr><tr><td><code>TO(layer)</code></td><td>Turns on <code>layer</code> and turns off all other layers, except the default layer</td></tr><tr><td><code>TT(layer)</code></td><td>Normally acts like MO unless it&#39;s tapped multiple times, which toggles <code>layer</code> on</td></tr></tbody></table><h2 id="leader-key" tabindex="-1">Leader Key <a class="header-anchor" href="#leader-key" aria-label="Permalink to &quot;Leader Key {#leader-key}&quot;">​</a></h2><p>See also: <a href="./features/leader_key">Leader Key</a></p><table><thead><tr><th>Key</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_LEAD</code></td><td>Begins a leader sequence</td></tr></tbody></table><h2 id="led-matrix" tabindex="-1">LED Matrix <a class="header-anchor" href="#led-matrix" aria-label="Permalink to &quot;LED Matrix {#led-matrix}&quot;">​</a></h2><p>See also: <a href="./features/led_matrix">LED Matrix</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_LED_MATRIX_ON</code></td><td><code>LM_ON</code></td><td>Turn on LED Matrix</td></tr><tr><td><code>QK_LED_MATRIX_OFF</code></td><td><code>LM_OFF</code></td><td>Turn off LED Matrix</td></tr><tr><td><code>QK_LED_MATRIX_TOGGLE</code></td><td><code>LM_TOGG</code></td><td>Toggle LED Matrix on or off</td></tr><tr><td><code>QK_LED_MATRIX_MODE_NEXT</code></td><td><code>LM_NEXT</code></td><td>Cycle through animations</td></tr><tr><td><code>QK_LED_MATRIX_MODE_PREVIOUS</code></td><td><code>LM_PREV</code></td><td>Cycle through animations in reverse</td></tr><tr><td><code>QK_LED_MATRIX_BRIGHTNESS_UP</code></td><td><code>LM_BRIU</code></td><td>Increase the brightness level</td></tr><tr><td><code>QK_LED_MATRIX_BRIGHTNESS_DOWN</code></td><td><code>LM_BRID</code></td><td>Decrease the brightness level</td></tr><tr><td><code>QK_LED_MATRIX_SPEED_UP</code></td><td><code>LM_SPDU</code></td><td>Increase the animation speed</td></tr><tr><td><code>QK_LED_MATRIX_SPEED_DOWN</code></td><td><code>LM_SPDD</code></td><td>Decrease the animation speed</td></tr></tbody></table><h2 id="magic-keycodes" tabindex="-1">Magic Keycodes <a class="header-anchor" href="#magic-keycodes" aria-label="Permalink to &quot;Magic Keycodes {#magic-keycodes}&quot;">​</a></h2><p>See also: <a href="./keycodes_magic">Magic Keycodes</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_MAGIC_SWAP_CONTROL_CAPS_LOCK</code></td><td><code>CL_SWAP</code></td><td>Swap Caps Lock and Left Control</td></tr><tr><td><code>QK_MAGIC_UNSWAP_CONTROL_CAPS_LOCK</code></td><td><code>CL_NORM</code></td><td>Unswap Caps Lock and Left Control</td></tr><tr><td><code>QK_MAGIC_TOGGLE_CONTROL_CAPS_LOCK</code></td><td><code>CL_TOGG</code></td><td>Toggle Caps Lock and Left Control swap</td></tr><tr><td><code>QK_MAGIC_CAPS_LOCK_AS_CONTROL_ON</code></td><td><code>CL_CTRL</code></td><td>Treat Caps Lock as Control</td></tr><tr><td><code>QK_MAGIC_CAPS_LOCK_AS_CONTROL_OFF</code></td><td><code>CL_CAPS</code></td><td>Stop treating Caps Lock as Control</td></tr><tr><td><code>QK_MAGIC_SWAP_ESCAPE_CAPS_LOCK</code></td><td><code>EC_SWAP</code></td><td>Swap Caps Lock and Escape</td></tr><tr><td><code>QK_MAGIC_UNSWAP_ESCAPE_CAPS_LOCK</code></td><td><code>EC_NORM</code></td><td>Unswap Caps Lock and Escape</td></tr><tr><td><code>QK_MAGIC_TOGGLE_ESCAPE_CAPS_LOCK</code></td><td><code>EC_TOGG</code></td><td>Toggle Caps Lock and Escape swap</td></tr><tr><td><code>QK_MAGIC_SWAP_LCTL_LGUI</code></td><td><code>CG_LSWP</code></td><td>Swap Left Control and GUI</td></tr><tr><td><code>QK_MAGIC_UNSWAP_LCTL_LGUI</code></td><td><code>CG_LNRM</code></td><td>Unswap Left Control and GUI</td></tr><tr><td><code>QK_MAGIC_SWAP_RCTL_RGUI</code></td><td><code>CG_RSWP</code></td><td>Swap Right Control and GUI</td></tr><tr><td><code>QK_MAGIC_UNSWAP_RCTL_RGUI</code></td><td><code>CG_RNRM</code></td><td>Unswap Right Control and GUI</td></tr><tr><td><code>QK_MAGIC_SWAP_CTL_GUI</code></td><td><code>CG_SWAP</code></td><td>Swap Control and GUI on both sides</td></tr><tr><td><code>QK_MAGIC_UNSWAP_CTL_GUI</code></td><td><code>CG_NORM</code></td><td>Unswap Control and GUI on both sides</td></tr><tr><td><code>QK_MAGIC_TOGGLE_CTL_GUI</code></td><td><code>CG_TOGG</code></td><td>Toggle Control and GUI swap on both sides</td></tr><tr><td><code>QK_MAGIC_SWAP_LALT_LGUI</code></td><td><code>AG_LSWP</code></td><td>Swap Left Alt and GUI</td></tr><tr><td><code>QK_MAGIC_UNSWAP_LALT_LGUI</code></td><td><code>AG_LNRM</code></td><td>Unswap Left Alt and GUI</td></tr><tr><td><code>QK_MAGIC_SWAP_RALT_RGUI</code></td><td><code>AG_RSWP</code></td><td>Swap Right Alt and GUI</td></tr><tr><td><code>QK_MAGIC_UNSWAP_RALT_RGUI</code></td><td><code>AG_RNRM</code></td><td>Unswap Right Alt and GUI</td></tr><tr><td><code>QK_MAGIC_SWAP_ALT_GUI</code></td><td><code>AG_SWAP</code></td><td>Swap Alt and GUI on both sides</td></tr><tr><td><code>QK_MAGIC_UNSWAP_ALT_GUI</code></td><td><code>AG_NORM</code></td><td>Unswap Alt and GUI on both sides</td></tr><tr><td><code>QK_MAGIC_TOGGLE_ALT_GUI</code></td><td><code>AG_TOGG</code></td><td>Toggle Alt and GUI swap on both sides</td></tr><tr><td><code>QK_MAGIC_GUI_OFF</code></td><td><code>GU_OFF</code></td><td>Disable the GUI keys</td></tr><tr><td><code>QK_MAGIC_GUI_ON</code></td><td><code>GU_ON</code></td><td>Enable the GUI keys</td></tr><tr><td><code>QK_MAGIC_TOGGLE_GUI</code></td><td><code>GU_TOGG</code></td><td>Toggles the status of the GUI keys</td></tr><tr><td><code>QK_MAGIC_SWAP_GRAVE_ESC</code></td><td><code>GE_SWAP</code></td><td>Swap <code>`</code> and Escape</td></tr><tr><td><code>QK_MAGIC_UNSWAP_GRAVE_ESC</code></td><td><code>GE_NORM</code></td><td>Unswap <code>`</code> and Escape</td></tr><tr><td><code>QK_MAGIC_SWAP_BACKSLASH_BACKSPACE</code></td><td><code>BS_SWAP</code></td><td>Swap <code>\\</code> and Backspace</td></tr><tr><td><code>QK_MAGIC_UNSWAP_BACKSLASH_BACKSPACE</code></td><td><code>BS_NORM</code></td><td>Unswap <code>\\</code> and Backspace</td></tr><tr><td><code>QK_MAGIC_TOGGLE_BACKSLASH_BACKSPACE</code></td><td><code>BS_TOGG</code></td><td>Toggle <code>\\</code> and Backspace swap state</td></tr><tr><td><code>QK_MAGIC_NKRO_ON</code></td><td><code>NK_ON</code></td><td>Enable N-key rollover</td></tr><tr><td><code>QK_MAGIC_NKRO_OFF</code></td><td><code>NK_OFF</code></td><td>Disable N-key rollover</td></tr><tr><td><code>QK_MAGIC_TOGGLE_NKRO</code></td><td><code>NK_TOGG</code></td><td>Toggle N-key rollover</td></tr><tr><td><code>QK_MAGIC_EE_HANDS_LEFT</code></td><td><code>EH_LEFT</code></td><td>Set the master half of a split keyboard as the left hand (for <code>EE_HANDS</code>)</td></tr><tr><td><code>QK_MAGIC_EE_HANDS_RIGHT</code></td><td><code>EH_RGHT</code></td><td>Set the master half of a split keyboard as the right hand (for <code>EE_HANDS</code>)</td></tr></tbody></table><h2 id="midi" tabindex="-1">MIDI <a class="header-anchor" href="#midi" aria-label="Permalink to &quot;MIDI {#midi}&quot;">​</a></h2><p>See also: <a href="./features/midi">MIDI</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_MIDI_ON</code></td><td><code>MI_ON</code></td><td>Turn MIDI on</td></tr><tr><td><code>QK_MIDI_OFF</code></td><td><code>MI_OFF</code></td><td>Turn MIDI off</td></tr><tr><td><code>QK_MIDI_TOGGLE</code></td><td><code>MI_TOGG</code></td><td>Toggle MIDI enabled</td></tr><tr><td><code>QK_MIDI_NOTE_C_0</code></td><td><code>MI_C</code></td><td>C octave 0</td></tr><tr><td><code>QK_MIDI_NOTE_C_SHARP_0</code></td><td><code>MI_Cs</code>, <code>MI_Db</code></td><td>C♯/D♭ octave 0</td></tr><tr><td><code>QK_MIDI_NOTE_D_0</code></td><td><code>MI_D</code></td><td>D octave 0</td></tr><tr><td><code>QK_MIDI_NOTE_D_SHARP_0</code></td><td><code>MI_Ds</code>, <code>MI_Eb</code></td><td>D♯/E♭ octave 0</td></tr><tr><td><code>QK_MIDI_NOTE_E_0</code></td><td><code>MI_E</code></td><td>E octave 0</td></tr><tr><td><code>QK_MIDI_NOTE_F_0</code></td><td><code>MI_F</code></td><td>F octave 0</td></tr><tr><td><code>QK_MIDI_NOTE_F_SHARP_0</code></td><td><code>MI_Fs</code>, <code>MI_Gb</code></td><td>F♯/G♭ octave 0</td></tr><tr><td><code>QK_MIDI_NOTE_G_0</code></td><td><code>MI_G</code></td><td>G octave 0</td></tr><tr><td><code>QK_MIDI_NOTE_G_SHARP_0</code></td><td><code>MI_Gs</code>, <code>MI_Ab</code></td><td>G♯/A♭ octave 0</td></tr><tr><td><code>QK_MIDI_NOTE_A_0</code></td><td><code>MI_A</code></td><td>A octave 0</td></tr><tr><td><code>QK_MIDI_NOTE_A_SHARP_0</code></td><td><code>MI_As</code>, <code>MI_Bb</code></td><td>A♯/B♭ octave 0</td></tr><tr><td><code>QK_MIDI_NOTE_B_0</code></td><td><code>MI_B</code></td><td>B octave 0</td></tr><tr><td><code>QK_MIDI_NOTE_C_1</code></td><td><code>MI_C1</code></td><td>C octave 1</td></tr><tr><td><code>QK_MIDI_NOTE_C_SHARP_1</code></td><td><code>MI_Cs1</code>, <code>MI_Db1</code></td><td>C♯/D♭ octave 1</td></tr><tr><td><code>QK_MIDI_NOTE_D_1</code></td><td><code>MI_D1</code></td><td>D octave 1</td></tr><tr><td><code>QK_MIDI_NOTE_D_SHARP_1</code></td><td><code>MI_Ds1</code>, <code>MI_Eb1</code></td><td>D♯/E♭ octave 1</td></tr><tr><td><code>QK_MIDI_NOTE_E_1</code></td><td><code>MI_E1</code></td><td>E octave 1</td></tr><tr><td><code>QK_MIDI_NOTE_F_1</code></td><td><code>MI_F1</code></td><td>F octave 1</td></tr><tr><td><code>QK_MIDI_NOTE_F_SHARP_1</code></td><td><code>MI_Fs1</code>, <code>MI_Gb1</code></td><td>F♯/G♭ octave 1</td></tr><tr><td><code>QK_MIDI_NOTE_G_1</code></td><td><code>MI_G1</code></td><td>G octave 1</td></tr><tr><td><code>QK_MIDI_NOTE_G_SHARP_1</code></td><td><code>MI_Gs1</code>, <code>MI_Ab1</code></td><td>G♯/A♭ octave 1</td></tr><tr><td><code>QK_MIDI_NOTE_A_1</code></td><td><code>MI_A1</code></td><td>A octave 1</td></tr><tr><td><code>QK_MIDI_NOTE_A_SHARP_1</code></td><td><code>MI_As1</code>, <code>MI_Bb1</code></td><td>A♯/B♭ octave 1</td></tr><tr><td><code>QK_MIDI_NOTE_B_1</code></td><td><code>MI_B1</code></td><td>B octave 1</td></tr><tr><td><code>QK_MIDI_NOTE_C_2</code></td><td><code>MI_C2</code></td><td>C octave 2</td></tr><tr><td><code>QK_MIDI_NOTE_C_SHARP_2</code></td><td><code>MI_Cs2</code>, <code>MI_Db2</code></td><td>C♯/D♭ octave 2</td></tr><tr><td><code>QK_MIDI_NOTE_D_2</code></td><td><code>MI_D2</code></td><td>D octave 2</td></tr><tr><td><code>QK_MIDI_NOTE_D_SHARP_2</code></td><td><code>MI_Ds2</code>, <code>MI_Eb2</code></td><td>D♯/E♭ octave 2</td></tr><tr><td><code>QK_MIDI_NOTE_E_2</code></td><td><code>MI_E2</code></td><td>E octave 2</td></tr><tr><td><code>QK_MIDI_NOTE_F_2</code></td><td><code>MI_F2</code></td><td>F octave 2</td></tr><tr><td><code>QK_MIDI_NOTE_F_SHARP_2</code></td><td><code>MI_Fs2</code>, <code>MI_Gb2</code></td><td>F♯/G♭ octave 2</td></tr><tr><td><code>QK_MIDI_NOTE_G_2</code></td><td><code>MI_G2</code></td><td>G octave 2</td></tr><tr><td><code>QK_MIDI_NOTE_G_SHARP_2</code></td><td><code>MI_Gs2</code>, <code>MI_Ab2</code></td><td>G♯/A♭ octave 2</td></tr><tr><td><code>QK_MIDI_NOTE_A_2</code></td><td><code>MI_A2</code></td><td>A octave 2</td></tr><tr><td><code>QK_MIDI_NOTE_A_SHARP_2</code></td><td><code>MI_As2</code>, <code>MI_Bb2</code></td><td>A♯/B♭ octave 2</td></tr><tr><td><code>QK_MIDI_NOTE_B_2</code></td><td><code>MI_B2</code></td><td>B octave 2</td></tr><tr><td><code>QK_MIDI_NOTE_C_3</code></td><td><code>MI_C3</code></td><td>C octave 3</td></tr><tr><td><code>QK_MIDI_NOTE_C_SHARP_3</code></td><td><code>MI_Cs3</code>, <code>MI_Db3</code></td><td>C♯/D♭ octave 3</td></tr><tr><td><code>QK_MIDI_NOTE_D_3</code></td><td><code>MI_D3</code></td><td>D octave 3</td></tr><tr><td><code>QK_MIDI_NOTE_D_SHARP_3</code></td><td><code>MI_Ds3</code>, <code>MI_Eb3</code></td><td>D♯/E♭ octave 3</td></tr><tr><td><code>QK_MIDI_NOTE_E_3</code></td><td><code>MI_E3</code></td><td>E octave 3</td></tr><tr><td><code>QK_MIDI_NOTE_F_3</code></td><td><code>MI_F3</code></td><td>F octave 3</td></tr><tr><td><code>QK_MIDI_NOTE_F_SHARP_3</code></td><td><code>MI_Fs3</code>, <code>MI_Gb3</code></td><td>F♯/G♭ octave 3</td></tr><tr><td><code>QK_MIDI_NOTE_G_3</code></td><td><code>MI_G3</code></td><td>G octave 3</td></tr><tr><td><code>QK_MIDI_NOTE_G_SHARP_3</code></td><td><code>MI_Gs3</code>, <code>MI_Ab3</code></td><td>G♯/A♭ octave 3</td></tr><tr><td><code>QK_MIDI_NOTE_A_3</code></td><td><code>MI_A3</code></td><td>A octave 3</td></tr><tr><td><code>QK_MIDI_NOTE_A_SHARP_3</code></td><td><code>MI_As3</code>, <code>MI_Bb3</code></td><td>A♯/B♭ octave 3</td></tr><tr><td><code>QK_MIDI_NOTE_B_3</code></td><td><code>MI_B3</code></td><td>B octave 3</td></tr><tr><td><code>QK_MIDI_NOTE_C_4</code></td><td><code>MI_C4</code></td><td>C octave 4</td></tr><tr><td><code>QK_MIDI_NOTE_C_SHARP_4</code></td><td><code>MI_Cs4</code>, <code>MI_Db4</code></td><td>C♯/D♭ octave 4</td></tr><tr><td><code>QK_MIDI_NOTE_D_4</code></td><td><code>MI_D4</code></td><td>D octave 4</td></tr><tr><td><code>QK_MIDI_NOTE_D_SHARP_4</code></td><td><code>MI_Ds4</code>, <code>MI_Eb4</code></td><td>D♯/E♭ octave 4</td></tr><tr><td><code>QK_MIDI_NOTE_E_4</code></td><td><code>MI_E4</code></td><td>E octave 4</td></tr><tr><td><code>QK_MIDI_NOTE_F_4</code></td><td><code>MI_F4</code></td><td>F octave 4</td></tr><tr><td><code>QK_MIDI_NOTE_F_SHARP_4</code></td><td><code>MI_Fs4</code>, <code>MI_Gb4</code></td><td>F♯/G♭ octave 4</td></tr><tr><td><code>QK_MIDI_NOTE_G_4</code></td><td><code>MI_G4</code></td><td>G octave 4</td></tr><tr><td><code>QK_MIDI_NOTE_G_SHARP_4</code></td><td><code>MI_Gs4</code>, <code>MI_Ab4</code></td><td>G♯/A♭ octave 4</td></tr><tr><td><code>QK_MIDI_NOTE_A_4</code></td><td><code>MI_A4</code></td><td>A octave 4</td></tr><tr><td><code>QK_MIDI_NOTE_A_SHARP_4</code></td><td><code>MI_As4</code>, <code>MI_Bb4</code></td><td>A♯/B♭ octave 4</td></tr><tr><td><code>QK_MIDI_NOTE_B_4</code></td><td><code>MI_B4</code></td><td>B octave 4</td></tr><tr><td><code>QK_MIDI_NOTE_C_5</code></td><td><code>MI_C5</code></td><td>C octave 5</td></tr><tr><td><code>QK_MIDI_NOTE_C_SHARP_5</code></td><td><code>MI_Cs5</code>, <code>MI_Db5</code></td><td>C♯/D♭ octave 5</td></tr><tr><td><code>QK_MIDI_NOTE_D_5</code></td><td><code>MI_D5</code></td><td>D octave 5</td></tr><tr><td><code>QK_MIDI_NOTE_D_SHARP_5</code></td><td><code>MI_Ds5</code>, <code>MI_Eb5</code></td><td>D♯/E♭ octave 5</td></tr><tr><td><code>QK_MIDI_NOTE_E_5</code></td><td><code>MI_E5</code></td><td>E octave 5</td></tr><tr><td><code>QK_MIDI_NOTE_F_5</code></td><td><code>MI_F5</code></td><td>F octave 5</td></tr><tr><td><code>QK_MIDI_NOTE_F_SHARP_5</code></td><td><code>MI_Fs5</code>, <code>MI_Gb5</code></td><td>F♯/G♭ octave 5</td></tr><tr><td><code>QK_MIDI_NOTE_G_5</code></td><td><code>MI_G5</code></td><td>G octave 5</td></tr><tr><td><code>QK_MIDI_NOTE_G_SHARP_5</code></td><td><code>MI_Gs5</code>, <code>MI_Ab5</code></td><td>G♯/A♭ octave 5</td></tr><tr><td><code>QK_MIDI_NOTE_A_5</code></td><td><code>MI_A5</code></td><td>A octave 5</td></tr><tr><td><code>QK_MIDI_NOTE_A_SHARP_5</code></td><td><code>MI_As5</code>, <code>MI_Bb5</code></td><td>A♯/B♭ octave 5</td></tr><tr><td><code>QK_MIDI_NOTE_B_5</code></td><td><code>MI_B5</code></td><td>B octave 5</td></tr><tr><td><code>QK_MIDI_OCTAVE_N2</code></td><td><code>MI_OCN2</code></td><td>Set octave to -2</td></tr><tr><td><code>QK_MIDI_OCTAVE_N1</code></td><td><code>MI_OCN1</code></td><td>Set octave to -1</td></tr><tr><td><code>QK_MIDI_OCTAVE_0</code></td><td><code>MI_OC0</code></td><td>Set octave to 0</td></tr><tr><td><code>QK_MIDI_OCTAVE_1</code></td><td><code>MI_OC1</code></td><td>Set octave to 1</td></tr><tr><td><code>QK_MIDI_OCTAVE_2</code></td><td><code>MI_OC2</code></td><td>Set octave to 2</td></tr><tr><td><code>QK_MIDI_OCTAVE_3</code></td><td><code>MI_OC3</code></td><td>Set octave to 3</td></tr><tr><td><code>QK_MIDI_OCTAVE_4</code></td><td><code>MI_OC4</code></td><td>Set octave to 4</td></tr><tr><td><code>QK_MIDI_OCTAVE_5</code></td><td><code>MI_OC5</code></td><td>Set octave to 5</td></tr><tr><td><code>QK_MIDI_OCTAVE_6</code></td><td><code>MI_OC6</code></td><td>Set octave to 6</td></tr><tr><td><code>QK_MIDI_OCTAVE_7</code></td><td><code>MI_OC7</code></td><td>Set octave to 7</td></tr><tr><td><code>QK_MIDI_OCTAVE_DOWN</code></td><td><code>MI_OCTD</code></td><td>Move down an octave</td></tr><tr><td><code>QK_MIDI_OCTAVE_UP</code></td><td><code>MI_OCTU</code></td><td>Move up an octave</td></tr><tr><td><code>QK_MIDI_TRANSPOSE_N6</code></td><td><code>MI_TRN6</code></td><td>Set transposition to -6 semitones</td></tr><tr><td><code>QK_MIDI_TRANSPOSE_N5</code></td><td><code>MI_TRN5</code></td><td>Set transposition to -5 semitones</td></tr><tr><td><code>QK_MIDI_TRANSPOSE_N4</code></td><td><code>MI_TRN4</code></td><td>Set transposition to -4 semitones</td></tr><tr><td><code>QK_MIDI_TRANSPOSE_N3</code></td><td><code>MI_TRN3</code></td><td>Set transposition to -3 semitones</td></tr><tr><td><code>QK_MIDI_TRANSPOSE_N2</code></td><td><code>MI_TRN2</code></td><td>Set transposition to -2 semitones</td></tr><tr><td><code>QK_MIDI_TRANSPOSE_N1</code></td><td><code>MI_TRN1</code></td><td>Set transposition to -1 semitone</td></tr><tr><td><code>QK_MIDI_TRANSPOSE_0</code></td><td><code>MI_TR0</code></td><td>No transposition</td></tr><tr><td><code>QK_MIDI_TRANSPOSE_1</code></td><td><code>MI_TR1</code></td><td>Set transposition to +1 semitone</td></tr><tr><td><code>QK_MIDI_TRANSPOSE_2</code></td><td><code>MI_TR2</code></td><td>Set transposition to +2 semitones</td></tr><tr><td><code>QK_MIDI_TRANSPOSE_3</code></td><td><code>MI_TR3</code></td><td>Set transposition to +3 semitones</td></tr><tr><td><code>QK_MIDI_TRANSPOSE_4</code></td><td><code>MI_TR4</code></td><td>Set transposition to +4 semitones</td></tr><tr><td><code>QK_MIDI_TRANSPOSE_5</code></td><td><code>MI_TR5</code></td><td>Set transposition to +5 semitones</td></tr><tr><td><code>QK_MIDI_TRANSPOSE_6</code></td><td><code>MI_TR6</code></td><td>Set transposition to +6 semitones</td></tr><tr><td><code>QK_MIDI_TRANSPOSE_DOWN</code></td><td><code>MI_TRSD</code></td><td>Decrease transposition</td></tr><tr><td><code>QK_MIDI_TRANSPOSE_UP</code></td><td><code>MI_TRSU</code></td><td>Increase transposition</td></tr><tr><td><code>QK_MIDI_VELOCITY_0</code></td><td><code>MI_VL0</code></td><td>Set velocity to 0</td></tr><tr><td><code>QK_MIDI_VELOCITY_1</code></td><td><code>MI_VL1</code></td><td>Set velocity to 12</td></tr><tr><td><code>QK_MIDI_VELOCITY_2</code></td><td><code>MI_VL2</code></td><td>Set velocity to 25</td></tr><tr><td><code>QK_MIDI_VELOCITY_3</code></td><td><code>MI_VL3</code></td><td>Set velocity to 38</td></tr><tr><td><code>QK_MIDI_VELOCITY_4</code></td><td><code>MI_VL4</code></td><td>Set velocity to 51</td></tr><tr><td><code>QK_MIDI_VELOCITY_5</code></td><td><code>MI_VL5</code></td><td>Set velocity to 64</td></tr><tr><td><code>QK_MIDI_VELOCITY_6</code></td><td><code>MI_VL6</code></td><td>Set velocity to 76</td></tr><tr><td><code>QK_MIDI_VELOCITY_7</code></td><td><code>MI_VL7</code></td><td>Set velocity to 89</td></tr><tr><td><code>QK_MIDI_VELOCITY_8</code></td><td><code>MI_VL8</code></td><td>Set velocity to 102</td></tr><tr><td><code>QK_MIDI_VELOCITY_9</code></td><td><code>MI_VL9</code></td><td>Set velocity to 114</td></tr><tr><td><code>QK_MIDI_VELOCITY_10</code></td><td><code>MI_VL10</code></td><td>Set velocity to 127</td></tr><tr><td><code>QK_MIDI_VELOCITY_DOWN</code></td><td><code>MI_VELD</code></td><td>Decrease velocity</td></tr><tr><td><code>QK_MIDI_VELOCITY_UP</code></td><td><code>MI_VELU</code></td><td>Increase velocity</td></tr><tr><td><code>QK_MIDI_CHANNEL_1</code></td><td><code>MI_CH1</code></td><td>Set channel to 1</td></tr><tr><td><code>QK_MIDI_CHANNEL_2</code></td><td><code>MI_CH2</code></td><td>Set channel to 2</td></tr><tr><td><code>QK_MIDI_CHANNEL_3</code></td><td><code>MI_CH3</code></td><td>Set channel to 3</td></tr><tr><td><code>QK_MIDI_CHANNEL_4</code></td><td><code>MI_CH4</code></td><td>Set channel to 4</td></tr><tr><td><code>QK_MIDI_CHANNEL_5</code></td><td><code>MI_CH5</code></td><td>Set channel to 5</td></tr><tr><td><code>QK_MIDI_CHANNEL_6</code></td><td><code>MI_CH6</code></td><td>Set channel to 6</td></tr><tr><td><code>QK_MIDI_CHANNEL_7</code></td><td><code>MI_CH7</code></td><td>Set channel to 7</td></tr><tr><td><code>QK_MIDI_CHANNEL_8</code></td><td><code>MI_CH8</code></td><td>Set channel to 8</td></tr><tr><td><code>QK_MIDI_CHANNEL_9</code></td><td><code>MI_CH9</code></td><td>Set channel to 9</td></tr><tr><td><code>QK_MIDI_CHANNEL_10</code></td><td><code>MI_CH10</code></td><td>Set channel to 10</td></tr><tr><td><code>QK_MIDI_CHANNEL_11</code></td><td><code>MI_CH11</code></td><td>Set channel to 11</td></tr><tr><td><code>QK_MIDI_CHANNEL_12</code></td><td><code>MI_CH12</code></td><td>Set channel to 12</td></tr><tr><td><code>QK_MIDI_CHANNEL_13</code></td><td><code>MI_CH13</code></td><td>Set channel to 13</td></tr><tr><td><code>QK_MIDI_CHANNEL_14</code></td><td><code>MI_CH14</code></td><td>Set channel to 14</td></tr><tr><td><code>QK_MIDI_CHANNEL_15</code></td><td><code>MI_CH15</code></td><td>Set channel to 15</td></tr><tr><td><code>QK_MIDI_CHANNEL_16</code></td><td><code>MI_CH16</code></td><td>Set channel to 16</td></tr><tr><td><code>QK_MIDI_CHANNEL_DOWN</code></td><td><code>MI_CHND</code></td><td>Decrease channel</td></tr><tr><td><code>QK_MIDI_CHANNEL_UP</code></td><td><code>MI_CHNU</code></td><td>Increase channel</td></tr><tr><td><code>QK_MIDI_ALL_NOTES_OFF</code></td><td><code>MI_AOFF</code></td><td>Stop all notes</td></tr><tr><td><code>QK_MIDI_SUSTAIN</code></td><td><code>MI_SUST</code></td><td>Sustain</td></tr><tr><td><code>QK_MIDI_PORTAMENTO</code></td><td><code>MI_PORT</code></td><td>Portmento</td></tr><tr><td><code>QK_MIDI_SOSTENUTO</code></td><td><code>MI_SOST</code></td><td>Sostenuto</td></tr><tr><td><code>QK_MIDI_SOFT</code></td><td><code>MI_SOFT</code></td><td>Soft Pedal</td></tr><tr><td><code>QK_MIDI_LEGATO</code></td><td><code>MI_LEG</code></td><td>Legato</td></tr><tr><td><code>QK_MIDI_MODULATION</code></td><td><code>MI_MOD</code></td><td>Modulation</td></tr><tr><td><code>QK_MIDI_MODULATION_SPEED_DOWN</code></td><td><code>MI_MODD</code></td><td>Decrease modulation speed</td></tr><tr><td><code>QK_MIDI_MODULATION_SPEED_UP</code></td><td><code>MI_MODU</code></td><td>Increase modulation speed</td></tr><tr><td><code>QK_MIDI_PITCH_BEND_DOWN</code></td><td><code>MI_BNDD</code></td><td>Bend pitch down</td></tr><tr><td><code>QK_MIDI_PITCH_BEND_UP</code></td><td><code>MI_BNDU</code></td><td>Bend pitch up</td></tr></tbody></table><h2 id="mouse-keys" tabindex="-1">Mouse Keys <a class="header-anchor" href="#mouse-keys" aria-label="Permalink to &quot;Mouse Keys {#mouse-keys}&quot;">​</a></h2><p>See also: <a href="./features/mouse_keys">Mouse Keys</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_MOUSE_CURSOR_UP</code></td><td><code>MS_UP</code></td><td>Mouse cursor up</td></tr><tr><td><code>QK_MOUSE_CURSOR_DOWN</code></td><td><code>MS_DOWN</code></td><td>Mouse cursor down</td></tr><tr><td><code>QK_MOUSE_CURSOR_LEFT</code></td><td><code>MS_LEFT</code></td><td>Mouse cursor left</td></tr><tr><td><code>QK_MOUSE_CURSOR_RIGHT</code></td><td><code>MS_RGHT</code></td><td>Mouse cursor right</td></tr><tr><td><code>QK_MOUSE_BUTTON_1</code></td><td><code>MS_BTN1</code></td><td>Mouse button 1</td></tr><tr><td><code>QK_MOUSE_BUTTON_2</code></td><td><code>MS_BTN2</code></td><td>Mouse button 2</td></tr><tr><td><code>QK_MOUSE_BUTTON_3</code></td><td><code>MS_BTN3</code></td><td>Mouse button 3</td></tr><tr><td><code>QK_MOUSE_BUTTON_4</code></td><td><code>MS_BTN4</code></td><td>Mouse button 4</td></tr><tr><td><code>QK_MOUSE_BUTTON_5</code></td><td><code>MS_BTN5</code></td><td>Mouse button 5</td></tr><tr><td><code>QK_MOUSE_BUTTON_6</code></td><td><code>MS_BTN6</code></td><td>Mouse button 6</td></tr><tr><td><code>QK_MOUSE_BUTTON_7</code></td><td><code>MS_BTN7</code></td><td>Mouse button 7</td></tr><tr><td><code>QK_MOUSE_BUTTON_8</code></td><td><code>MS_BTN8</code></td><td>Mouse button 8</td></tr><tr><td><code>QK_MOUSE_WHEEL_UP</code></td><td><code>MS_WHLU</code></td><td>Mouse wheel up</td></tr><tr><td><code>QK_MOUSE_WHEEL_DOWN</code></td><td><code>MS_WHLD</code></td><td>Mouse wheel down</td></tr><tr><td><code>QK_MOUSE_WHEEL_LEFT</code></td><td><code>MS_WHLL</code></td><td>Mouse wheel left</td></tr><tr><td><code>QK_MOUSE_WHEEL_RIGHT</code></td><td><code>MS_WHLR</code></td><td>Mouse wheel right</td></tr><tr><td><code>QK_MOUSE_ACCELERATION_0</code></td><td><code>MS_ACL0</code></td><td>Set mouse acceleration to 0</td></tr><tr><td><code>QK_MOUSE_ACCELERATION_1</code></td><td><code>MS_ACL1</code></td><td>Set mouse acceleration to 1</td></tr><tr><td><code>QK_MOUSE_ACCELERATION_2</code></td><td><code>MS_ACL2</code></td><td>Set mouse acceleration to 2</td></tr></tbody></table><h2 id="modifiers" tabindex="-1">Modifiers <a class="header-anchor" href="#modifiers" aria-label="Permalink to &quot;Modifiers {#modifiers}&quot;">​</a></h2><p>See also: <a href="./feature_advanced_keycodes#modifier-keys">Modifier Keys</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>LCTL(kc)</code></td><td><code>C(kc)</code></td><td>Hold Left Control and press <code>kc</code></td></tr><tr><td><code>LSFT(kc)</code></td><td><code>S(kc)</code></td><td>Hold Left Shift and press <code>kc</code></td></tr><tr><td><code>LALT(kc)</code></td><td><code>A(kc)</code>, <code>LOPT(kc)</code></td><td>Hold Left Alt and press <code>kc</code></td></tr><tr><td><code>LGUI(kc)</code></td><td><code>G(kc)</code>, <code>LCMD(kc)</code>, <code>LWIN(kc)</code></td><td>Hold Left GUI and press <code>kc</code></td></tr><tr><td><code>RCTL(kc)</code></td><td></td><td>Hold Right Control and press <code>kc</code></td></tr><tr><td><code>RSFT(kc)</code></td><td></td><td>Hold Right Shift and press <code>kc</code></td></tr><tr><td><code>RALT(kc)</code></td><td><code>ROPT(kc)</code>, <code>ALGR(kc)</code></td><td>Hold Right Alt (AltGr) and press <code>kc</code></td></tr><tr><td><code>RGUI(kc)</code></td><td><code>RCMD(kc)</code>, <code>RWIN(kc)</code></td><td>Hold Right GUI and press <code>kc</code></td></tr><tr><td><code>LSG(kc)</code></td><td><code>SGUI(kc)</code>, <code>SCMD(kc)</code>, <code>SWIN(kc)</code></td><td>Hold Left Shift and Left GUI and press <code>kc</code></td></tr><tr><td><code>LAG(kc)</code></td><td></td><td>Hold Left Alt and Left GUI and press <code>kc</code></td></tr><tr><td><code>RSG(kc)</code></td><td></td><td>Hold Right Shift and Right GUI and press <code>kc</code></td></tr><tr><td><code>RAG(kc)</code></td><td></td><td>Hold Right Alt and Right GUI and press <code>kc</code></td></tr><tr><td><code>LCA(kc)</code></td><td></td><td>Hold Left Control and Alt and press <code>kc</code></td></tr><tr><td><code>LSA(kc)</code></td><td></td><td>Hold Left Shift and Left Alt and press <code>kc</code></td></tr><tr><td><code>RSA(kc)</code></td><td><code>SAGR(kc)</code></td><td>Hold Right Shift and Right Alt (AltGr) and press <code>kc</code></td></tr><tr><td><code>RCS(kc)</code></td><td></td><td>Hold Right Control and Right Shift and press <code>kc</code></td></tr><tr><td><code>LCAG(kc)</code></td><td></td><td>Hold Left Control, Alt and GUI and press <code>kc</code></td></tr><tr><td><code>MEH(kc)</code></td><td></td><td>Hold Left Control, Shift and Alt and press <code>kc</code></td></tr><tr><td><code>HYPR(kc)</code></td><td></td><td>Hold Left Control, Shift, Alt and GUI and press <code>kc</code></td></tr><tr><td><code>KC_MEH</code></td><td></td><td>Left Control, Shift and Alt</td></tr><tr><td><code>KC_HYPR</code></td><td></td><td>Left Control, Shift, Alt and GUI</td></tr></tbody></table><h2 id="mod-tap-keys" tabindex="-1">Mod-Tap Keys <a class="header-anchor" href="#mod-tap-keys" aria-label="Permalink to &quot;Mod-Tap Keys {#mod-tap-keys}&quot;">​</a></h2><p>See also: <a href="./mod_tap">Mod-Tap</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>MT(mod, kc)</code></td><td></td><td><code>mod</code> when held, <code>kc</code> when tapped</td></tr><tr><td><code>LCTL_T(kc)</code></td><td><code>CTL_T(kc)</code></td><td>Left Control when held, <code>kc</code> when tapped</td></tr><tr><td><code>LSFT_T(kc)</code></td><td><code>SFT_T(kc)</code></td><td>Left Shift when held, <code>kc</code> when tapped</td></tr><tr><td><code>LALT_T(kc)</code></td><td><code>LOPT_T(kc)</code>, <code>ALT_T(kc)</code>, <code>OPT_T(kc)</code></td><td>Left Alt when held, <code>kc</code> when tapped</td></tr><tr><td><code>LGUI_T(kc)</code></td><td><code>LCMD_T(kc)</code>, <code>LWIN_T(kc)</code>, <code>GUI_T(kc)</code>, <code>CMD_T(kc)</code>, <code>WIN_T(kc)</code></td><td>Left GUI when held, <code>kc</code> when tapped</td></tr><tr><td><code>RCTL_T(kc)</code></td><td></td><td>Right Control when held, <code>kc</code> when tapped</td></tr><tr><td><code>RSFT_T(kc)</code></td><td></td><td>Right Shift when held, <code>kc</code> when tapped</td></tr><tr><td><code>RALT_T(kc)</code></td><td><code>ROPT_T(kc)</code>, <code>ALGR_T(kc)</code></td><td>Right Alt (AltGr) when held, <code>kc</code> when tapped</td></tr><tr><td><code>RGUI_T(kc)</code></td><td><code>RCMD_T(kc)</code>, <code>RWIN_T(kc)</code></td><td>Right GUI when held, <code>kc</code> when tapped</td></tr><tr><td><code>LSG_T(kc)</code></td><td><code>SGUI_T(kc)</code>, <code>SCMD_T(kc)</code>, <code>SWIN_T(kc)</code></td><td>Left Shift and GUI when held, <code>kc</code> when tapped</td></tr><tr><td><code>LAG_T(kc)</code></td><td></td><td>Left Alt and GUI when held, <code>kc</code> when tapped</td></tr><tr><td><code>RSG_T(kc)</code></td><td></td><td>Right Shift and GUI when held, <code>kc</code> when tapped</td></tr><tr><td><code>RAG_T(kc)</code></td><td></td><td>Right Alt and GUI when held, <code>kc</code> when tapped</td></tr><tr><td><code>LCA_T(kc)</code></td><td></td><td>Left Control and Alt when held, <code>kc</code> when tapped</td></tr><tr><td><code>LSA_T(kc)</code></td><td></td><td>Left Shift and Left Alt when held, <code>kc</code> when tapped</td></tr><tr><td><code>RSA_T(kc)</code></td><td><code>SAGR_T(kc)</code></td><td>Right Shift and Right Alt (AltGr) when held, <code>kc</code> when tapped</td></tr><tr><td><code>RCS_T(kc)</code></td><td></td><td>Right Control and Right Shift when held, <code>kc</code> when tapped</td></tr><tr><td><code>LCAG_T(kc)</code></td><td></td><td>Left Control, Alt and GUI when held, <code>kc</code> when tapped</td></tr><tr><td><code>RCAG_T(kc)</code></td><td></td><td>Right Control, Alt and GUI when held, <code>kc</code> when tapped</td></tr><tr><td><code>C_S_T(kc)</code></td><td></td><td>Left Control and Shift when held, <code>kc</code> when tapped</td></tr><tr><td><code>MEH_T(kc)</code></td><td></td><td>Left Control, Shift and Alt when held, <code>kc</code> when tapped</td></tr><tr><td><code>HYPR_T(kc)</code></td><td><code>ALL_T(kc)</code></td><td>Left Control, Shift, Alt and GUI when held, <code>kc</code> when tapped - more info <a href="https://brettterpstra.com/2012/12/08/a-useful-caps-lock-key/" target="_blank" rel="noreferrer">here</a></td></tr></tbody></table><h2 id="tapping-term-keys" tabindex="-1">Tapping Term Keys <a class="header-anchor" href="#tapping-term-keys" aria-label="Permalink to &quot;Tapping Term Keys {#tapping-term-keys}&quot;">​</a></h2><p>See also: <a href="./tap_hold#dynamic-tapping-term">Dynamic Tapping Term</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_DYNAMIC_TAPPING_TERM_PRINT</code></td><td><code>DT_PRNT</code></td><td>Types the current tapping term, in milliseconds</td></tr><tr><td><code>QK_DYNAMIC_TAPPING_TERM_UP</code></td><td><code>DT_UP</code></td><td>Increases the current tapping term by <code>DYNAMIC_TAPPING_TERM_INCREMENT</code>ms (5ms by default)</td></tr><tr><td><code>QK_DYNAMIC_TAPPING_TERM_DOWN</code></td><td><code>DT_DOWN</code></td><td>Decreases the current tapping term by <code>DYNAMIC_TAPPING_TERM_INCREMENT</code>ms (5ms by default)</td></tr></tbody></table><h2 id="rgb-lighting" tabindex="-1">RGB Lighting <a class="header-anchor" href="#rgb-lighting" aria-label="Permalink to &quot;RGB Lighting {#rgb-lighting}&quot;">​</a></h2><p>See also: <a href="./features/rgblight">RGB Lighting</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_UNDERGLOW_TOGGLE</code></td><td><code>UG_TOGG</code></td><td>Toggle RGB lighting on or off</td></tr><tr><td><code>QK_UNDERGLOW_MODE_NEXT</code></td><td><code>UG_NEXT</code></td><td>Cycle through modes, reverse direction when Shift is held</td></tr><tr><td><code>QK_UNDERGLOW_MODE_PREVIOUS</code></td><td><code>UG_PREV</code></td><td>Cycle through modes in reverse, forward direction when Shift is held</td></tr><tr><td><code>QK_UNDERGLOW_HUE_UP</code></td><td><code>UG_HUEU</code></td><td>Increase hue, decrease hue when Shift is held</td></tr><tr><td><code>QK_UNDERGLOW_HUE_DOWN</code></td><td><code>UG_HUED</code></td><td>Decrease hue, increase hue when Shift is held</td></tr><tr><td><code>QK_UNDERGLOW_SATURATION_UP</code></td><td><code>UG_SATU</code></td><td>Increase saturation, decrease saturation when Shift is held</td></tr><tr><td><code>QK_UNDERGLOW_SATURATION_DOWN</code></td><td><code>UG_SATD</code></td><td>Decrease saturation, increase saturation when Shift is held</td></tr><tr><td><code>QK_UNDERGLOW_VALUE_UP</code></td><td><code>UG_VALU</code></td><td>Increase value (brightness), decrease value when Shift is held</td></tr><tr><td><code>QK_UNDERGLOW_VALUE_DOWN</code></td><td><code>UG_VALD</code></td><td>Decrease value (brightness), increase value when Shift is held</td></tr><tr><td><code>QK_UNDERGLOW_SPEED_UP</code></td><td><code>UG_SPDU</code></td><td>Increase effect speed (brightness), decrease speed when Shift is held</td></tr><tr><td><code>QK_UNDERGLOW_SPEED_DOWN</code></td><td><code>UG_SPDD</code></td><td>Decrease effect speed (brightness), increase speed when Shift is held</td></tr><tr><td><code>RGB_MODE_PLAIN</code></td><td><code>RGB_M_P </code></td><td>Static (no animation) mode (deprecated)</td></tr><tr><td><code>RGB_MODE_BREATHE</code></td><td><code>RGB_M_B</code></td><td>Breathing animation mode (deprecated)</td></tr><tr><td><code>RGB_MODE_RAINBOW</code></td><td><code>RGB_M_R</code></td><td>Rainbow animation mode (deprecated)</td></tr><tr><td><code>RGB_MODE_SWIRL</code></td><td><code>RGB_M_SW</code></td><td>Swirl animation mode (deprecated)</td></tr><tr><td><code>RGB_MODE_SNAKE</code></td><td><code>RGB_M_SN</code></td><td>Snake animation mode (deprecated)</td></tr><tr><td><code>RGB_MODE_KNIGHT</code></td><td><code>RGB_M_K</code></td><td>&quot;Knight Rider&quot; animation mode (deprecated)</td></tr><tr><td><code>RGB_MODE_XMAS</code></td><td><code>RGB_M_X</code></td><td>Christmas animation mode (deprecated)</td></tr><tr><td><code>RGB_MODE_GRADIENT</code></td><td><code>RGB_M_G</code></td><td>Static gradient animation mode (deprecated)</td></tr><tr><td><code>RGB_MODE_RGBTEST</code></td><td><code>RGB_M_T</code></td><td>Red, Green, Blue test animation mode (deprecated)</td></tr><tr><td><code>RGB_MODE_TWINKLE</code></td><td><code>RGB_M_TW</code></td><td>Twinkle animation mode (deprecated)</td></tr></tbody></table><h2 id="rgb-matrix" tabindex="-1">RGB Matrix <a class="header-anchor" href="#rgb-matrix" aria-label="Permalink to &quot;RGB Matrix {#rgb-matrix}&quot;">​</a></h2><p>See also: <a href="./features/rgb_matrix">RGB Matrix</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_RGB_MATRIX_ON</code></td><td><code>RM_ON</code></td><td>Turn on RGB Matrix</td></tr><tr><td><code>QK_RGB_MATRIX_OFF</code></td><td><code>RM_OFF</code></td><td>Turn off RGB Matrix</td></tr><tr><td><code>QK_RGB_MATRIX_TOGGLE</code></td><td><code>RM_TOGG</code></td><td>Toggle RGB Matrix on or off</td></tr><tr><td><code>QK_RGB_MATRIX_MODE_NEXT</code></td><td><code>RM_NEXT</code></td><td>Cycle through animations</td></tr><tr><td><code>QK_RGB_MATRIX_MODE_PREVIOUS</code></td><td><code>RM_PREV</code></td><td>Cycle through animations in reverse</td></tr><tr><td><code>QK_RGB_MATRIX_HUE_UP</code></td><td><code>RM_HUEU</code></td><td>Cycle through hue</td></tr><tr><td><code>QK_RGB_MATRIX_HUE_DOWN</code></td><td><code>RM_HUED</code></td><td>Cycle through hue in reverse</td></tr><tr><td><code>QK_RGB_MATRIX_SATURATION_UP</code></td><td><code>RM_SATU</code></td><td>Increase the saturation</td></tr><tr><td><code>QK_RGB_MATRIX_SATURATION_DOWN</code></td><td><code>RM_SATD</code></td><td>Decrease the saturation</td></tr><tr><td><code>QK_RGB_MATRIX_VALUE_UP</code></td><td><code>RM_VALU</code></td><td>Increase the brightness level</td></tr><tr><td><code>QK_RGB_MATRIX_VALUE_DOWN</code></td><td><code>RM_VALD</code></td><td>Decrease the brightness level</td></tr><tr><td><code>QK_RGB_MATRIX_SPEED_UP</code></td><td><code>RM_SPDU</code></td><td>Increase the animation speed</td></tr><tr><td><code>QK_RGB_MATRIX_SPEED_DOWN</code></td><td><code>RM_SPDD</code></td><td>Decrease the animation speed</td></tr></tbody></table><h2 id="us-ansi-shifted-symbols" tabindex="-1">US ANSI Shifted Symbols <a class="header-anchor" href="#us-ansi-shifted-symbols" aria-label="Permalink to &quot;US ANSI Shifted Symbols {#us-ansi-shifted-symbols}&quot;">​</a></h2><p>See also: <a href="./keycodes_us_ansi_shifted">US ANSI Shifted Symbols</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>KC_TILDE</code></td><td><code>KC_TILD</code></td><td><code>~</code></td></tr><tr><td><code>KC_EXCLAIM</code></td><td><code>KC_EXLM</code></td><td><code>!</code></td></tr><tr><td><code>KC_AT</code></td><td></td><td><code>@</code></td></tr><tr><td><code>KC_HASH</code></td><td></td><td><code>#</code></td></tr><tr><td><code>KC_DOLLAR</code></td><td><code>KC_DLR</code></td><td><code>$</code></td></tr><tr><td><code>KC_PERCENT</code></td><td><code>KC_PERC</code></td><td><code>%</code></td></tr><tr><td><code>KC_CIRCUMFLEX</code></td><td><code>KC_CIRC</code></td><td><code>^</code></td></tr><tr><td><code>KC_AMPERSAND</code></td><td><code>KC_AMPR</code></td><td><code>&amp;</code></td></tr><tr><td><code>KC_ASTERISK</code></td><td><code>KC_ASTR</code></td><td><code>*</code></td></tr><tr><td><code>KC_LEFT_PAREN</code></td><td><code>KC_LPRN</code></td><td><code>(</code></td></tr><tr><td><code>KC_RIGHT_PAREN</code></td><td><code>KC_RPRN</code></td><td><code>)</code></td></tr><tr><td><code>KC_UNDERSCORE</code></td><td><code>KC_UNDS</code></td><td><code>_</code></td></tr><tr><td><code>KC_PLUS</code></td><td></td><td><code>+</code></td></tr><tr><td><code>KC_LEFT_CURLY_BRACE</code></td><td><code>KC_LCBR</code></td><td><code>{</code></td></tr><tr><td><code>KC_RIGHT_CURLY_BRACE</code></td><td><code>KC_RCBR</code></td><td><code>}</code></td></tr><tr><td><code>KC_PIPE</code></td><td></td><td><code>|</code></td></tr><tr><td><code>KC_COLON</code></td><td><code>KC_COLN</code></td><td><code>:</code></td></tr><tr><td><code>KC_DOUBLE_QUOTE</code></td><td><code>KC_DQUO</code>, <code>KC_DQT</code></td><td><code>&quot;</code></td></tr><tr><td><code>KC_LEFT_ANGLE_BRACKET</code></td><td><code>KC_LABK</code>, <code>KC_LT</code></td><td><code>&lt;</code></td></tr><tr><td><code>KC_RIGHT_ANGLE_BRACKET</code></td><td><code>KC_RABK</code>, <code>KC_GT</code></td><td><code>&gt;</code></td></tr><tr><td><code>KC_QUESTION</code></td><td><code>KC_QUES</code></td><td><code>?</code></td></tr></tbody></table><h2 id="one-shot-keys" tabindex="-1">One Shot Keys <a class="header-anchor" href="#one-shot-keys" aria-label="Permalink to &quot;One Shot Keys {#one-shot-keys}&quot;">​</a></h2><p>See also: <a href="./one_shot_keys">One Shot Keys</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>OSM(mod)</code></td><td></td><td>Hold <code>mod</code> for one keypress</td></tr><tr><td><code>OSL(layer)</code></td><td></td><td>Switch to <code>layer</code> for one keypress</td></tr><tr><td><code>QK_ONE_SHOT_TOGGLE</code></td><td><code>OS_TOGG</code></td><td>Toggles One Shot keys status</td></tr><tr><td><code>QK_ONE_SHOT_ON</code></td><td><code>OS_ON</code></td><td>Turns One Shot keys on</td></tr><tr><td><code>QK_ONE_SHOT_OFF</code></td><td><code>OS_OFF</code></td><td>Turns One Shot keys off</td></tr></tbody></table><h2 id="programmable-button" tabindex="-1">Programmable Button Support <a class="header-anchor" href="#programmable-button" aria-label="Permalink to &quot;Programmable Button Support {#programmable-button}&quot;">​</a></h2><p>See also: <a href="./features/programmable_button">Programmable Button</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_PROGRAMMABLE_BUTTON_1</code></td><td><code>PB_1</code></td><td>Programmable button 1</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_2</code></td><td><code>PB_2</code></td><td>Programmable button 2</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_3</code></td><td><code>PB_3</code></td><td>Programmable button 3</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_4</code></td><td><code>PB_4</code></td><td>Programmable button 4</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_5</code></td><td><code>PB_5</code></td><td>Programmable button 5</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_6</code></td><td><code>PB_6</code></td><td>Programmable button 6</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_7</code></td><td><code>PB_7</code></td><td>Programmable button 7</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_8</code></td><td><code>PB_8</code></td><td>Programmable button 8</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_9</code></td><td><code>PB_9</code></td><td>Programmable button 9</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_10</code></td><td><code>PB_10</code></td><td>Programmable button 10</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_11</code></td><td><code>PB_11</code></td><td>Programmable button 11</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_12</code></td><td><code>PB_12</code></td><td>Programmable button 12</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_13</code></td><td><code>PB_13</code></td><td>Programmable button 13</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_14</code></td><td><code>PB_14</code></td><td>Programmable button 14</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_15</code></td><td><code>PB_15</code></td><td>Programmable button 15</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_16</code></td><td><code>PB_16</code></td><td>Programmable button 16</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_17</code></td><td><code>PB_17</code></td><td>Programmable button 17</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_18</code></td><td><code>PB_18</code></td><td>Programmable button 18</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_19</code></td><td><code>PB_19</code></td><td>Programmable button 19</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_20</code></td><td><code>PB_20</code></td><td>Programmable button 20</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_21</code></td><td><code>PB_21</code></td><td>Programmable button 21</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_22</code></td><td><code>PB_22</code></td><td>Programmable button 22</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_23</code></td><td><code>PB_23</code></td><td>Programmable button 23</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_24</code></td><td><code>PB_24</code></td><td>Programmable button 24</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_25</code></td><td><code>PB_25</code></td><td>Programmable button 25</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_26</code></td><td><code>PB_26</code></td><td>Programmable button 26</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_27</code></td><td><code>PB_27</code></td><td>Programmable button 27</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_28</code></td><td><code>PB_28</code></td><td>Programmable button 28</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_29</code></td><td><code>PB_29</code></td><td>Programmable button 29</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_30</code></td><td><code>PB_30</code></td><td>Programmable button 30</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_31</code></td><td><code>PB_31</code></td><td>Programmable button 31</td></tr><tr><td><code>QK_PROGRAMMABLE_BUTTON_32</code></td><td><code>PB_32</code></td><td>Programmable button 32</td></tr></tbody></table><h2 id="repeat-key" tabindex="-1">Repeat Key <a class="header-anchor" href="#repeat-key" aria-label="Permalink to &quot;Repeat Key {#repeat-key}&quot;">​</a></h2><p>See also: <a href="./features/repeat_key">Repeat Key</a></p><table><thead><tr><th>Keycode</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_REPEAT_KEY</code></td><td><code>QK_REP</code></td><td>Repeat the last pressed key</td></tr><tr><td><code>QK_ALT_REPEAT_KEY</code></td><td><code>QK_AREP</code></td><td>Perform alternate of the last key</td></tr></tbody></table><h2 id="space-cadet" tabindex="-1">Space Cadet <a class="header-anchor" href="#space-cadet" aria-label="Permalink to &quot;Space Cadet {#space-cadet}&quot;">​</a></h2><p>See also: <a href="./features/space_cadet">Space Cadet</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>QK_SPACE_CADET_LEFT_CTRL_PARENTHESIS_OPEN</code></td><td><code>SC_LCPO</code></td><td>Left Control when held, <code>(</code> when tapped</td></tr><tr><td><code>QK_SPACE_CADET_RIGHT_CTRL_PARENTHESIS_CLOSE</code></td><td><code>SC_RCPC</code></td><td>Right Control when held, <code>)</code> when tapped</td></tr><tr><td><code>QK_SPACE_CADET_LEFT_SHIFT_PARENTHESIS_OPEN</code></td><td><code>SC_LSPO</code></td><td>Left Shift when held, <code>(</code> when tapped</td></tr><tr><td><code>QK_SPACE_CADET_RIGHT_SHIFT_PARENTHESIS_CLOSE</code></td><td><code>SC_RSPC</code></td><td>Right Shift when held, <code>)</code> when tapped</td></tr><tr><td><code>QK_SPACE_CADET_LEFT_ALT_PARENTHESIS_OPEN</code></td><td><code>SC_LAPO</code></td><td>Left Alt when held, <code>(</code> when tapped</td></tr><tr><td><code>QK_SPACE_CADET_RIGHT_ALT_PARENTHESIS_CLOSE</code></td><td><code>SC_RAPC</code></td><td>Right Alt when held, <code>)</code> when tapped</td></tr><tr><td><code>QK_SPACE_CADET_RIGHT_SHIFT_ENTER</code></td><td><code>SC_SENT</code></td><td>Right Shift when held, Enter when tapped</td></tr></tbody></table><h2 id="swap-hands" tabindex="-1">Swap Hands <a class="header-anchor" href="#swap-hands" aria-label="Permalink to &quot;Swap Hands {#swap-hands}&quot;">​</a></h2><p>See also: <a href="./features/swap_hands">Swap Hands</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>SH_T(kc)</code></td><td></td><td>Momentary swap when held, <code>kc</code> when tapped</td></tr><tr><td><code>QK_SWAP_HANDS_ON</code></td><td><code>SH_ON</code></td><td>Turn on hand swap</td></tr><tr><td><code>QK_SWAP_HANDS_OFF</code></td><td><code>SH_OFF</code></td><td>Turn off hand swap</td></tr><tr><td><code>QK_SWAP_HANDS_MOMENTARY_ON</code></td><td><code>SH_MON</code></td><td>Turn on hand swap while held</td></tr><tr><td><code>QK_SWAP_HANDS_MOMENTARY_OFF</code></td><td><code>SH_MOFF</code></td><td>Turn off hand swap while held</td></tr><tr><td><code>QK_SWAP_HANDS_TOGGLE</code></td><td><code>SH_TOGG</code></td><td>Toggle hand swap</td></tr><tr><td><code>QK_SWAP_HANDS_TAP_TOGGLE</code></td><td><code>SH_TT</code></td><td>Momentary swap when held, toggle when tapped</td></tr><tr><td><code>QK_SWAP_HANDS_ONE_SHOT</code></td><td><code>SH_OS</code></td><td>Turn on hand swap while held or until next key press</td></tr></tbody></table><h2 id="unicode-support" tabindex="-1">Unicode Support <a class="header-anchor" href="#unicode-support" aria-label="Permalink to &quot;Unicode Support {#unicode-support}&quot;">​</a></h2><p>See also: <a href="./features/unicode">Unicode Support</a></p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>UC(c)</code></td><td></td><td>Send Unicode code point <code>c</code>, up to <code>0x7FFF</code></td></tr><tr><td><code>UM(i)</code></td><td></td><td>Send Unicode code point at index <code>i</code> in <code>unicode_map</code></td></tr><tr><td><code>UP(i, j)</code></td><td></td><td>Send Unicode code point at index <code>i</code>, or <code>j</code> if Shift/Caps is on</td></tr><tr><td><code>QK_UNICODE_MODE_NEXT</code></td><td><code>UC_NEXT</code></td><td>Cycle through selected input modes</td></tr><tr><td><code>QK_UNICODE_MODE_PREVIOUS</code></td><td><code>UC_PREV</code></td><td>Cycle through selected input modes in reverse</td></tr><tr><td><code>QK_UNICODE_MODE_MACOS</code></td><td><code>UC_MAC</code></td><td>Switch to macOS input</td></tr><tr><td><code>QK_UNICODE_MODE_LINUX</code></td><td><code>UC_LINX</code></td><td>Switch to Linux input</td></tr><tr><td><code>QK_UNICODE_MODE_WINDOWS</code></td><td><code>UC_WIN</code></td><td>Switch to Windows input</td></tr><tr><td><code>QK_UNICODE_MODE_BSD</code></td><td><code>UC_BSD</code></td><td>Switch to BSD input (not implemented)</td></tr><tr><td><code>QK_UNICODE_MODE_WINCOMPOSE</code></td><td><code>UC_WINC</code></td><td>Switch to Windows input using WinCompose</td></tr><tr><td><code>QK_UNICODE_MODE_EMACS</code></td><td><code>UC_EMAC</code></td><td>Switch to emacs (<code>C-x-8 RET</code>)</td></tr></tbody></table>', 97);
const _hoisted_98 = [
  _hoisted_1
];
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", null, _hoisted_98);
}
const keycodes = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  __pageData,
  keycodes as default
};
