import { _ as _export_sfc, c as createElementBlock, o as openBlock, a8 as createStaticVNode } from "./chunks/framework.B9AX-CPi.js";
const __pageData = JSON.parse('{"title":"Basic Keycodes","description":"","frontmatter":{},"headers":[],"relativePath":"keycodes_basic.md","filePath":"keycodes_basic.md","lastUpdated":null}');
const _sfc_main = { name: "keycodes_basic.md" };
const _hoisted_1 = /* @__PURE__ */ createStaticVNode('<h1 id="basic-keycodes" tabindex="-1">Basic Keycodes <a class="header-anchor" href="#basic-keycodes" aria-label="Permalink to &quot;Basic Keycodes&quot;">​</a></h1><p>The basic set of keycodes are based on the <a href="https://www.usb.org/sites/default/files/documents/hut1_12v2.pdf" target="_blank" rel="noreferrer">HID Keyboard/Keypad Usage Page (0x07)</a> with the exception of <code>KC_NO</code>, <code>KC_TRNS</code> and keycodes in the <code>0xA5-DF</code> range. See below for more details.</p><h2 id="letters-and-numbers" tabindex="-1">Letters and Numbers <a class="header-anchor" href="#letters-and-numbers" aria-label="Permalink to &quot;Letters and Numbers&quot;">​</a></h2><table><thead><tr><th>Key</th><th>Description</th></tr></thead><tbody><tr><td><code>KC_A</code></td><td><code>a</code> and <code>A</code></td></tr><tr><td><code>KC_B</code></td><td><code>b</code> and <code>B</code></td></tr><tr><td><code>KC_C</code></td><td><code>c</code> and <code>C</code></td></tr><tr><td><code>KC_D</code></td><td><code>d</code> and <code>D</code></td></tr><tr><td><code>KC_E</code></td><td><code>e</code> and <code>E</code></td></tr><tr><td><code>KC_F</code></td><td><code>f</code> and <code>F</code></td></tr><tr><td><code>KC_G</code></td><td><code>g</code> and <code>G</code></td></tr><tr><td><code>KC_H</code></td><td><code>h</code> and <code>H</code></td></tr><tr><td><code>KC_I</code></td><td><code>i</code> and <code>I</code></td></tr><tr><td><code>KC_J</code></td><td><code>j</code> and <code>J</code></td></tr><tr><td><code>KC_K</code></td><td><code>k</code> and <code>K</code></td></tr><tr><td><code>KC_L</code></td><td><code>l</code> and <code>L</code></td></tr><tr><td><code>KC_M</code></td><td><code>m</code> and <code>M</code></td></tr><tr><td><code>KC_N</code></td><td><code>n</code> and <code>N</code></td></tr><tr><td><code>KC_O</code></td><td><code>o</code> and <code>O</code></td></tr><tr><td><code>KC_P</code></td><td><code>p</code> and <code>P</code></td></tr><tr><td><code>KC_Q</code></td><td><code>q</code> and <code>Q</code></td></tr><tr><td><code>KC_R</code></td><td><code>r</code> and <code>R</code></td></tr><tr><td><code>KC_S</code></td><td><code>s</code> and <code>S</code></td></tr><tr><td><code>KC_T</code></td><td><code>t</code> and <code>T</code></td></tr><tr><td><code>KC_U</code></td><td><code>u</code> and <code>U</code></td></tr><tr><td><code>KC_V</code></td><td><code>v</code> and <code>V</code></td></tr><tr><td><code>KC_W</code></td><td><code>w</code> and <code>W</code></td></tr><tr><td><code>KC_X</code></td><td><code>x</code> and <code>X</code></td></tr><tr><td><code>KC_Y</code></td><td><code>y</code> and <code>Y</code></td></tr><tr><td><code>KC_Z</code></td><td><code>z</code> and <code>Z</code></td></tr><tr><td><code>KC_1</code></td><td><code>1</code> and <code>!</code></td></tr><tr><td><code>KC_2</code></td><td><code>2</code> and <code>@</code></td></tr><tr><td><code>KC_3</code></td><td><code>3</code> and <code>#</code></td></tr><tr><td><code>KC_4</code></td><td><code>4</code> and <code>$</code></td></tr><tr><td><code>KC_5</code></td><td><code>5</code> and <code>%</code></td></tr><tr><td><code>KC_6</code></td><td><code>6</code> and <code>^</code></td></tr><tr><td><code>KC_7</code></td><td><code>7</code> and <code>&amp;</code></td></tr><tr><td><code>KC_8</code></td><td><code>8</code> and <code>*</code></td></tr><tr><td><code>KC_9</code></td><td><code>9</code> and <code>(</code></td></tr><tr><td><code>KC_0</code></td><td><code>0</code> and <code>)</code></td></tr></tbody></table><h2 id="f-keys" tabindex="-1">F Keys <a class="header-anchor" href="#f-keys" aria-label="Permalink to &quot;F Keys&quot;">​</a></h2><table><thead><tr><th>Key</th><th>Description</th></tr></thead><tbody><tr><td><code>KC_F1</code></td><td>F1</td></tr><tr><td><code>KC_F2</code></td><td>F2</td></tr><tr><td><code>KC_F3</code></td><td>F3</td></tr><tr><td><code>KC_F4</code></td><td>F4</td></tr><tr><td><code>KC_F5</code></td><td>F5</td></tr><tr><td><code>KC_F6</code></td><td>F6</td></tr><tr><td><code>KC_F7</code></td><td>F7</td></tr><tr><td><code>KC_F8</code></td><td>F8</td></tr><tr><td><code>KC_F9</code></td><td>F9</td></tr><tr><td><code>KC_F10</code></td><td>F10</td></tr><tr><td><code>KC_F11</code></td><td>F11</td></tr><tr><td><code>KC_F12</code></td><td>F12</td></tr><tr><td><code>KC_F13</code></td><td>F13</td></tr><tr><td><code>KC_F14</code></td><td>F14</td></tr><tr><td><code>KC_F15</code></td><td>F15</td></tr><tr><td><code>KC_F16</code></td><td>F16</td></tr><tr><td><code>KC_F17</code></td><td>F17</td></tr><tr><td><code>KC_F18</code></td><td>F18</td></tr><tr><td><code>KC_F19</code></td><td>F19</td></tr><tr><td><code>KC_F20</code></td><td>F20</td></tr><tr><td><code>KC_F21</code></td><td>F21</td></tr><tr><td><code>KC_F22</code></td><td>F22</td></tr><tr><td><code>KC_F23</code></td><td>F23</td></tr><tr><td><code>KC_F24</code></td><td>F24</td></tr></tbody></table><h2 id="punctuation" tabindex="-1">Punctuation <a class="header-anchor" href="#punctuation" aria-label="Permalink to &quot;Punctuation&quot;">​</a></h2><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>KC_ENTER</code></td><td><code>KC_ENT</code></td><td>Return (Enter)</td></tr><tr><td><code>KC_ESCAPE</code></td><td><code>KC_ESC</code></td><td>Escape</td></tr><tr><td><code>KC_BACKSPACE</code></td><td><code>KC_BSPC</code></td><td>Delete (Backspace)</td></tr><tr><td><code>KC_TAB</code></td><td></td><td>Tab</td></tr><tr><td><code>KC_SPACE</code></td><td><code>KC_SPC</code></td><td>Spacebar</td></tr><tr><td><code>KC_MINUS</code></td><td><code>KC_MINS</code></td><td><code>-</code> and <code>_</code></td></tr><tr><td><code>KC_EQUAL</code></td><td><code>KC_EQL</code></td><td><code>=</code> and <code>+</code></td></tr><tr><td><code>KC_LEFT_BRACKET</code></td><td><code>KC_LBRC</code></td><td><code>[</code> and <code>{</code></td></tr><tr><td><code>KC_RIGHT_BRACKET</code></td><td><code>KC_RBRC</code></td><td><code>]</code> and <code>}</code></td></tr><tr><td><code>KC_BACKSLASH</code></td><td><code>KC_BSLS</code></td><td><code>\\</code> and <code>|</code></td></tr><tr><td><code>KC_NONUS_HASH</code></td><td><code>KC_NUHS</code></td><td>Non-US <code>#</code> and <code>~</code></td></tr><tr><td><code>KC_SEMICOLON</code></td><td><code>KC_SCLN</code></td><td><code>;</code> and <code>:</code></td></tr><tr><td><code>KC_QUOTE</code></td><td><code>KC_QUOT</code></td><td><code>&#39;</code> and <code>&quot;</code></td></tr><tr><td><code>KC_GRAVE</code></td><td><code>KC_GRV</code></td><td><code>`</code> and <code>~</code></td></tr><tr><td><code>KC_COMMA</code></td><td><code>KC_COMM</code></td><td><code>,</code> and <code>&lt;</code></td></tr><tr><td><code>KC_DOT</code></td><td></td><td><code>.</code> and <code>&gt;</code></td></tr><tr><td><code>KC_SLASH</code></td><td><code>KC_SLSH</code></td><td><code>/</code> and <code>?</code></td></tr><tr><td><code>KC_NONUS_BACKSLASH</code></td><td><code>KC_NUBS</code></td><td>Non-US <code>\\</code> and <code>|</code></td></tr></tbody></table><h2 id="lock-keys" tabindex="-1">Lock Keys <a class="header-anchor" href="#lock-keys" aria-label="Permalink to &quot;Lock Keys&quot;">​</a></h2><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>KC_CAPS_LOCK</code></td><td><code>KC_CAPS</code></td><td>Caps Lock</td></tr><tr><td><code>KC_SCROLL_LOCK</code></td><td><code>KC_SCRL</code>, <code>KC_BRMD</code></td><td>Scroll Lock, Brightness Down (macOS)</td></tr><tr><td><code>KC_NUM_LOCK</code></td><td><code>KC_NUM</code></td><td>Keypad Num Lock and Clear</td></tr><tr><td><code>KC_LOCKING_CAPS_LOCK</code></td><td><code>KC_LCAP</code></td><td>Locking Caps Lock</td></tr><tr><td><code>KC_LOCKING_NUM_LOCK</code></td><td><code>KC_LNUM</code></td><td>Locking Num Lock</td></tr><tr><td><code>KC_LOCKING_SCROLL_LOCK</code></td><td><code>KC_LSCR</code></td><td>Locking Scroll Lock</td></tr></tbody></table><h2 id="modifiers" tabindex="-1">Modifiers <a class="header-anchor" href="#modifiers" aria-label="Permalink to &quot;Modifiers&quot;">​</a></h2><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>KC_LEFT_CTRL</code></td><td><code>KC_LCTL</code></td><td>Left Control</td></tr><tr><td><code>KC_LEFT_SHIFT</code></td><td><code>KC_LSFT</code></td><td>Left Shift</td></tr><tr><td><code>KC_LEFT_ALT</code></td><td><code>KC_LALT</code>, <code>KC_LOPT</code></td><td>Left Alt (Option)</td></tr><tr><td><code>KC_LEFT_GUI</code></td><td><code>KC_LGUI</code>, <code>KC_LCMD</code>, <code>KC_LWIN</code></td><td>Left GUI (Windows/Command/Meta key)</td></tr><tr><td><code>KC_RIGHT_CTRL</code></td><td><code>KC_RCTL</code></td><td>Right Control</td></tr><tr><td><code>KC_RIGHT_SHIFT</code></td><td><code>KC_RSFT</code></td><td>Right Shift</td></tr><tr><td><code>KC_RIGHT_ALT</code></td><td><code>KC_RALT</code>, <code>KC_ROPT</code>, <code>KC_ALGR</code></td><td>Right Alt (Option/AltGr)</td></tr><tr><td><code>KC_RIGHT_GUI</code></td><td><code>KC_RGUI</code>, <code>KC_RCMD</code>, <code>KC_RWIN</code></td><td>Right GUI (Windows/Command/Meta key)</td></tr></tbody></table><h2 id="international" tabindex="-1">International <a class="header-anchor" href="#international" aria-label="Permalink to &quot;International&quot;">​</a></h2><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>KC_INTERNATIONAL_1</code></td><td><code>KC_INT1</code></td><td>JIS <code>\\</code> and <code>_</code></td></tr><tr><td><code>KC_INTERNATIONAL_2</code></td><td><code>KC_INT2</code></td><td>JIS Katakana/Hiragana</td></tr><tr><td><code>KC_INTERNATIONAL_3</code></td><td><code>KC_INT3</code></td><td>JIS <code>¥</code> and <code>|</code></td></tr><tr><td><code>KC_INTERNATIONAL_4</code></td><td><code>KC_INT4</code></td><td>JIS Henkan</td></tr><tr><td><code>KC_INTERNATIONAL_5</code></td><td><code>KC_INT5</code></td><td>JIS Muhenkan</td></tr><tr><td><code>KC_INTERNATIONAL_6</code></td><td><code>KC_INT6</code></td><td>JIS Numpad <code>,</code></td></tr><tr><td><code>KC_INTERNATIONAL_7</code></td><td><code>KC_INT7</code></td><td>International 7</td></tr><tr><td><code>KC_INTERNATIONAL_8</code></td><td><code>KC_INT8</code></td><td>International 8</td></tr><tr><td><code>KC_INTERNATIONAL_9</code></td><td><code>KC_INT9</code></td><td>International 9</td></tr><tr><td><code>KC_LANGUAGE_1</code></td><td><code>KC_LNG1</code></td><td>Hangul/English</td></tr><tr><td><code>KC_LANGUAGE_2</code></td><td><code>KC_LNG2</code></td><td>Hanja</td></tr><tr><td><code>KC_LANGUAGE_3</code></td><td><code>KC_LNG3</code></td><td>JIS Katakana</td></tr><tr><td><code>KC_LANGUAGE_4</code></td><td><code>KC_LNG4</code></td><td>JIS Hiragana</td></tr><tr><td><code>KC_LANGUAGE_5</code></td><td><code>KC_LNG5</code></td><td>JIS Zenkaku/Hankaku</td></tr><tr><td><code>KC_LANGUAGE_6</code></td><td><code>KC_LNG6</code></td><td>Language 6</td></tr><tr><td><code>KC_LANGUAGE_7</code></td><td><code>KC_LNG7</code></td><td>Language 7</td></tr><tr><td><code>KC_LANGUAGE_8</code></td><td><code>KC_LNG8</code></td><td>Language 8</td></tr><tr><td><code>KC_LANGUAGE_9</code></td><td><code>KC_LNG9</code></td><td>Language 9</td></tr></tbody></table><h2 id="commands" tabindex="-1">Commands <a class="header-anchor" href="#commands" aria-label="Permalink to &quot;Commands&quot;">​</a></h2><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>KC_PRINT_SCREEN</code></td><td><code>KC_PSCR</code></td><td>Print Screen</td></tr><tr><td><code>KC_PAUSE</code></td><td><code>KC_PAUS</code>, <code>KC_BRK</code>, <code>KC_BRMU</code></td><td>Pause, Brightness Up (macOS)</td></tr><tr><td><code>KC_INSERT</code></td><td><code>KC_INS</code></td><td>Insert</td></tr><tr><td><code>KC_HOME</code></td><td></td><td>Home</td></tr><tr><td><code>KC_PAGE_UP</code></td><td><code>KC_PGUP</code></td><td>Page Up</td></tr><tr><td><code>KC_DELETE</code></td><td><code>KC_DEL</code></td><td>Forward Delete</td></tr><tr><td><code>KC_END</code></td><td></td><td>End</td></tr><tr><td><code>KC_PAGE_DOWN</code></td><td><code>KC_PGDN</code></td><td>Page Down</td></tr><tr><td><code>KC_RIGHT</code></td><td><code>KC_RGHT</code></td><td>Right Arrow</td></tr><tr><td><code>KC_LEFT</code></td><td></td><td>Left Arrow</td></tr><tr><td><code>KC_DOWN</code></td><td></td><td>Down Arrow</td></tr><tr><td><code>KC_UP</code></td><td></td><td>Up Arrow</td></tr><tr><td><code>KC_APPLICATION</code></td><td><code>KC_APP</code></td><td>Application (Windows Context Menu Key)</td></tr><tr><td><code>KC_KB_POWER</code></td><td></td><td>System Power</td></tr><tr><td><code>KC_EXECUTE</code></td><td><code>KC_EXEC</code></td><td>Execute</td></tr><tr><td><code>KC_HELP</code></td><td></td><td>Help</td></tr><tr><td><code>KC_MENU</code></td><td></td><td>Menu</td></tr><tr><td><code>KC_SELECT</code></td><td><code>KC_SLCT</code></td><td>Select</td></tr><tr><td><code>KC_STOP</code></td><td></td><td>Stop</td></tr><tr><td><code>KC_AGAIN</code></td><td><code>KC_AGIN</code></td><td>Again</td></tr><tr><td><code>KC_UNDO</code></td><td></td><td>Undo</td></tr><tr><td><code>KC_CUT</code></td><td></td><td>Cut</td></tr><tr><td><code>KC_COPY</code></td><td></td><td>Copy</td></tr><tr><td><code>KC_PASTE</code></td><td><code>KC_PSTE</code></td><td>Paste</td></tr><tr><td><code>KC_FIND</code></td><td></td><td>Find</td></tr><tr><td><code>KC_KB_MUTE</code></td><td></td><td>Mute</td></tr><tr><td><code>KC_KB_VOLUME_UP</code></td><td></td><td>Volume Up</td></tr><tr><td><code>KC_KB_VOLUME_DOWN</code></td><td></td><td>Volume Down</td></tr><tr><td><code>KC_ALTERNATE_ERASE</code></td><td><code>KC_ERAS</code></td><td>Alternate Erase</td></tr><tr><td><code>KC_SYSTEM_REQUEST</code></td><td><code>KC_SYRQ</code></td><td>SysReq/Attention</td></tr><tr><td><code>KC_CANCEL</code></td><td><code>KC_CNCL</code></td><td>Cancel</td></tr><tr><td><code>KC_CLEAR</code></td><td><code>KC_CLR</code></td><td>Clear</td></tr><tr><td><code>KC_PRIOR</code></td><td><code>KC_PRIR</code></td><td>Prior</td></tr><tr><td><code>KC_RETURN</code></td><td><code>KC_RETN</code></td><td>Return</td></tr><tr><td><code>KC_SEPARATOR</code></td><td><code>KC_SEPR</code></td><td>Separator</td></tr><tr><td><code>KC_OUT</code></td><td></td><td>Out</td></tr><tr><td><code>KC_OPER</code></td><td></td><td>Oper</td></tr><tr><td><code>KC_CLEAR_AGAIN</code></td><td><code>KC_CLAG</code></td><td>Clear/Again</td></tr><tr><td><code>KC_CRSEL</code></td><td><code>KC_CRSL</code></td><td>CrSel/Props</td></tr><tr><td><code>KC_EXSEL</code></td><td><code>KC_EXSL</code></td><td>ExSel</td></tr></tbody></table><h2 id="media-keys" tabindex="-1">Media Keys <a class="header-anchor" href="#media-keys" aria-label="Permalink to &quot;Media Keys&quot;">​</a></h2><p>These keycodes are not part of the Keyboard/Keypad usage page. The <code>SYSTEM_</code> keycodes are found in the Generic Desktop page, and the rest are located in the Consumer page.</p><div class="tip custom-block"><p class="custom-block-title">TIP</p><p>Some of these keycodes may behave differently depending on the OS. For example, on macOS, the keycodes <code>KC_MEDIA_FAST_FORWARD</code>, <code>KC_MEDIA_REWIND</code>, <code>KC_MEDIA_NEXT_TRACK</code> and <code>KC_MEDIA_PREV_TRACK</code> skip within the current track when held, but skip the entire track when tapped.</p></div><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>KC_SYSTEM_POWER</code></td><td><code>KC_PWR</code></td><td>System Power Down</td></tr><tr><td><code>KC_SYSTEM_SLEEP</code></td><td><code>KC_SLEP</code></td><td>System Sleep</td></tr><tr><td><code>KC_SYSTEM_WAKE</code></td><td><code>KC_WAKE</code></td><td>System Wake</td></tr><tr><td><code>KC_AUDIO_MUTE</code></td><td><code>KC_MUTE</code></td><td>Mute</td></tr><tr><td><code>KC_AUDIO_VOL_UP</code></td><td><code>KC_VOLU</code></td><td>Volume Up</td></tr><tr><td><code>KC_AUDIO_VOL_DOWN</code></td><td><code>KC_VOLD</code></td><td>Volume Down</td></tr><tr><td><code>KC_MEDIA_NEXT_TRACK</code></td><td><code>KC_MNXT</code></td><td>Next Track</td></tr><tr><td><code>KC_MEDIA_PREV_TRACK</code></td><td><code>KC_MPRV</code></td><td>Previous Track</td></tr><tr><td><code>KC_MEDIA_STOP</code></td><td><code>KC_MSTP</code></td><td>Stop Track</td></tr><tr><td><code>KC_MEDIA_PLAY_PAUSE</code></td><td><code>KC_MPLY</code></td><td>Play/Pause Track</td></tr><tr><td><code>KC_MEDIA_SELECT</code></td><td><code>KC_MSEL</code></td><td>Launch Media Player</td></tr><tr><td><code>KC_MEDIA_EJECT</code></td><td><code>KC_EJCT</code></td><td>Eject</td></tr><tr><td><code>KC_MAIL</code></td><td></td><td>Launch Mail</td></tr><tr><td><code>KC_CALCULATOR</code></td><td><code>KC_CALC</code></td><td>Launch Calculator</td></tr><tr><td><code>KC_MY_COMPUTER</code></td><td><code>KC_MYCM</code></td><td>Launch My Computer</td></tr><tr><td><code>KC_WWW_SEARCH</code></td><td><code>KC_WSCH</code></td><td>Browser Search</td></tr><tr><td><code>KC_WWW_HOME</code></td><td><code>KC_WHOM</code></td><td>Browser Home</td></tr><tr><td><code>KC_WWW_BACK</code></td><td><code>KC_WBAK</code></td><td>Browser Back</td></tr><tr><td><code>KC_WWW_FORWARD</code></td><td><code>KC_WFWD</code></td><td>Browser Forward</td></tr><tr><td><code>KC_WWW_STOP</code></td><td><code>KC_WSTP</code></td><td>Browser Stop</td></tr><tr><td><code>KC_WWW_REFRESH</code></td><td><code>KC_WREF</code></td><td>Browser Refresh</td></tr><tr><td><code>KC_WWW_FAVORITES</code></td><td><code>KC_WFAV</code></td><td>Browser Favorites</td></tr><tr><td><code>KC_MEDIA_FAST_FORWARD</code></td><td><code>KC_MFFD</code></td><td>Next Track</td></tr><tr><td><code>KC_MEDIA_REWIND</code></td><td><code>KC_MRWD</code></td><td>Previous Track</td></tr><tr><td><code>KC_BRIGHTNESS_UP</code></td><td><code>KC_BRIU</code></td><td>Brightness Up</td></tr><tr><td><code>KC_BRIGHTNESS_DOWN</code></td><td><code>KC_BRID</code></td><td>Brightness Down</td></tr><tr><td><code>KC_CONTROL_PANEL</code></td><td><code>KC_CPNL</code></td><td>Open Control Panel</td></tr><tr><td><code>KC_ASSISTANT</code></td><td><code>KC_ASST</code></td><td>Launch Assistant</td></tr><tr><td><code>KC_MISSION_CONTROL</code></td><td><code>KC_MCTL</code></td><td>Open Mission Control</td></tr><tr><td><code>KC_LAUNCHPAD</code></td><td><code>KC_LPAD</code></td><td>Open Launchpad</td></tr></tbody></table><h2 id="number-pad" tabindex="-1">Number Pad <a class="header-anchor" href="#number-pad" aria-label="Permalink to &quot;Number Pad&quot;">​</a></h2><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>KC_KP_SLASH</code></td><td><code>KC_PSLS</code></td><td>Keypad <code>/</code></td></tr><tr><td><code>KC_KP_ASTERISK</code></td><td><code>KC_PAST</code></td><td>Keypad <code>*</code></td></tr><tr><td><code>KC_KP_MINUS</code></td><td><code>KC_PMNS</code></td><td>Keypad <code>-</code></td></tr><tr><td><code>KC_KP_PLUS</code></td><td><code>KC_PPLS</code></td><td>Keypad <code>+</code></td></tr><tr><td><code>KC_KP_ENTER</code></td><td><code>KC_PENT</code></td><td>Keypad Enter</td></tr><tr><td><code>KC_KP_1</code></td><td><code>KC_P1</code></td><td>Keypad <code>1</code> and End</td></tr><tr><td><code>KC_KP_2</code></td><td><code>KC_P2</code></td><td>Keypad <code>2</code> and Down Arrow</td></tr><tr><td><code>KC_KP_3</code></td><td><code>KC_P3</code></td><td>Keypad <code>3</code> and Page Down</td></tr><tr><td><code>KC_KP_4</code></td><td><code>KC_P4</code></td><td>Keypad <code>4</code> and Left Arrow</td></tr><tr><td><code>KC_KP_5</code></td><td><code>KC_P5</code></td><td>Keypad <code>5</code></td></tr><tr><td><code>KC_KP_6</code></td><td><code>KC_P6</code></td><td>Keypad <code>6</code> and Right Arrow</td></tr><tr><td><code>KC_KP_7</code></td><td><code>KC_P7</code></td><td>Keypad <code>7</code> and Home</td></tr><tr><td><code>KC_KP_8</code></td><td><code>KC_P8</code></td><td>Keypad <code>8</code> and Up Arrow</td></tr><tr><td><code>KC_KP_9</code></td><td><code>KC_P9</code></td><td>Keypad <code>9</code> and Page Up</td></tr><tr><td><code>KC_KP_0</code></td><td><code>KC_P0</code></td><td>Keypad <code>0</code> and Insert</td></tr><tr><td><code>KC_KP_DOT</code></td><td><code>KC_PDOT</code></td><td>Keypad <code>.</code> and Delete</td></tr><tr><td><code>KC_KP_EQUAL</code></td><td><code>KC_PEQL</code></td><td>Keypad <code>=</code></td></tr><tr><td><code>KC_KP_COMMA</code></td><td><code>KC_PCMM</code></td><td>Keypad <code>,</code></td></tr><tr><td><code>KC_KP_EQUAL_AS400</code></td><td></td><td>Keypad <code>=</code> on AS/400 keyboards</td></tr></tbody></table><h2 id="special-keys" tabindex="-1">Special Keys <a class="header-anchor" href="#special-keys" aria-label="Permalink to &quot;Special Keys&quot;">​</a></h2><p>In addition to these, keycodes in the range of <code>0xA5-DF</code> are reserved for internal use.</p><table><thead><tr><th>Key</th><th>Aliases</th><th>Description</th></tr></thead><tbody><tr><td><code>KC_NO</code></td><td><code>XXXXXXX</code></td><td>Ignore this key (NOOP)</td></tr><tr><td><code>KC_TRANSPARENT</code></td><td><code>KC_TRNS</code>, <code>_______</code></td><td>Use the next lowest non-transparent key</td></tr></tbody></table>', 25);
const _hoisted_26 = [
  _hoisted_1
];
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", null, _hoisted_26);
}
const keycodes_basic = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  __pageData,
  keycodes_basic as default
};
