import { _ as _export_sfc, c as createElementBlock, o as openBlock, a8 as createStaticVNode } from "./chunks/framework.B9AX-CPi.js";
const __pageData = JSON.parse('{"title":"QMK Syllabus","description":"","frontmatter":{},"headers":[],"relativePath":"syllabus.md","filePath":"syllabus.md","lastUpdated":null}');
const _sfc_main = { name: "syllabus.md" };
const _hoisted_1 = /* @__PURE__ */ createStaticVNode('<h1 id="qmk-syllabus" tabindex="-1">QMK Syllabus <a class="header-anchor" href="#qmk-syllabus" aria-label="Permalink to &quot;QMK Syllabus&quot;">​</a></h1><p>This page helps you build up your QMK knowledge by introducing the basics first and guiding you to understanding all the concepts you need to know to be proficient with QMK.</p><h1 id="beginning-topics" tabindex="-1">Beginning Topics <a class="header-anchor" href="#beginning-topics" aria-label="Permalink to &quot;Beginning Topics&quot;">​</a></h1><p>If you read nothing else you should read the documents in this section. After reading the <a href="./newbs">Tutorial</a> you should be able to create a basic keymap, compile it, and flash it to your keyboard. The remaining documents will flesh out your knowledge of these basics.</p><ul><li><strong>Learn How To Use QMK Tools</strong><ul><li><a href="./newbs">Tutorial</a></li><li><a href="./cli">CLI</a></li><li><a href="./newbs_git_best_practices">GIT</a></li></ul></li><li><strong>Learn About Keymaps</strong><ul><li><a href="./feature_layers">Layers</a></li><li><a href="./keycodes">Keycodes</a><ul><li>The full list of keycodes you can use. Note that some may require knowledge found in the Intermediate or Advanced Topics.</li></ul></li></ul></li><li><strong>Configuring IDEs</strong> - Optional <ul><li><a href="./other_eclipse">Eclipse</a></li><li><a href="./other_vscode">VS Code</a></li></ul></li></ul><h1 id="intermediate-topics" tabindex="-1">Intermediate Topics <a class="header-anchor" href="#intermediate-topics" aria-label="Permalink to &quot;Intermediate Topics&quot;">​</a></h1><p>These topics start to dig into some of the features that QMK supports. You don&#39;t have to read all of these documents, but some of the documents in the Advanced Topics section won&#39;t make sense if you skip over some of these.</p><ul><li><strong>Learn How To Configure Features</strong><ul><li><a href="./features/audio">Audio</a></li><li>Lighting <ul><li><a href="./features/backlight">Backlight</a></li><li><a href="./features/led_matrix">LED Matrix</a></li><li><a href="./features/rgblight">RGB Lighting</a></li><li><a href="./features/rgb_matrix">RGB Matrix</a></li></ul></li><li><a href="./tap_hold">Tap-Hold Configuration</a></li><li><a href="./squeezing_avr">Squeezing Space from AVR</a></li></ul></li><li><strong>Learn More About Keymaps</strong><ul><li><a href="./keymap">Keymaps</a></li><li><a href="./custom_quantum_functions">Custom Functions and Keycodes</a></li><li>Macros <ul><li><a href="./features/dynamic_macros">Dynamic Macros</a></li><li><a href="./feature_macros">Compiled Macros</a></li></ul></li><li><a href="./features/tap_dance">Tap Dance</a></li><li><a href="./features/combo">Combos</a></li><li><a href="./feature_userspace">Userspace</a></li><li><a href="./features/key_overrides">Key Overrides</a></li></ul></li></ul><h1 id="advanced-topics" tabindex="-1">Advanced Topics <a class="header-anchor" href="#advanced-topics" aria-label="Permalink to &quot;Advanced Topics&quot;">​</a></h1><p>Everything below here requires a lot of foundational knowledge. Besides being able to create keymaps using advanced features you should be familiar with using both <code>config.h</code> and <code>rules.mk</code> to configure options for your keyboard.</p><ul><li><strong>Maintaining Keyboards Within QMK</strong><ul><li><a href="./hand_wire">Handwiring a Keyboard</a></li><li><a href="./hardware_keyboard_guidelines">Keyboard Guidelines</a></li><li><a href="./reference_info_json">info.json Reference</a></li><li><a href="./feature_debounce_type">Debounce API</a></li></ul></li><li><strong>Advanced Features</strong><ul><li><a href="./features/unicode">Unicode</a></li><li><a href="./api_overview">API</a></li><li><a href="./features/bootmagic">Bootmagic</a></li></ul></li><li><strong>Hardware</strong><ul><li><a href="./how_keyboards_work">How Keyboards Work</a></li><li><a href="./how_a_matrix_works">How A Keyboard Matrix Works</a></li><li><a href="./features/split_keyboard">Split Keyboards</a></li><li><a href="./features/stenography">Stenography</a></li><li><a href="./features/pointing_device">Pointing Devices</a></li></ul></li><li><strong>Core Development</strong><ul><li><a href="./coding_conventions_c">Coding Conventions</a></li><li><a href="./compatible_microcontrollers">Compatible Microcontrollers</a></li><li><a href="./custom_matrix">Custom Matrix</a></li><li><a href="./understanding_qmk">Understanding QMK</a></li></ul></li><li><strong>CLI Development</strong><ul><li><a href="./coding_conventions_python">Coding Conventions</a></li><li><a href="./cli_development">CLI Development Overview</a></li></ul></li></ul>', 11);
const _hoisted_12 = [
  _hoisted_1
];
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", null, _hoisted_12);
}
const syllabus = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  __pageData,
  syllabus as default
};
